#include "strutil.h"
#include "transpor.h"
#include "errhand.h"

static int SAAL=1;   /* antialiasing mode */
static int SDPC=1;   /* depth-cue mode */
static int SDTH=1;   /* dithering mode */
static int SLTM=1;   /* 3D text mode */

static float SLWM[] = {1.5, 10.0, 0.5, 10.0};   /* virtual line-width map */

extern int graphix;


int setAttribute(char *which,int what)
{
  int r;

  if (streq(which,"SAAL")) {
    r=SAAL; SAAL=what;
    send_bheader(graphix,"SAAL",sizeof(int));
    send_bint(graphix,what);
  }else if (streq(which,"SDPC")) {
    r=SDPC; SDPC=what;
    send_bheader(graphix,"SDPC",sizeof(int));
    send_bint(graphix,what);
  }else if (streq(which,"SDTH")) {
    r=SDTH; SDTH=what;
    send_bheader(graphix,"SDTH",sizeof(int));
    send_bint(graphix,what);
  }else if (streq(which,"SLTM")) {
    r=SLTM; SLTM=what;
    send_bheader(graphix,"SLTM",sizeof(int));
    send_bint(graphix,what);
  }else{
    err_set(1,"bad first argument in setAttribute: %s",which);
    r=0;
  }

  return(r);
}

int getAttribute(char *which)
{
  int r;

  if (streq(which,"SAAL")) {
    r=SAAL;
  }else if (streq(which,"SDPC")) {
    r=SDPC;
  }else if (streq(which,"SDTH")) {
    r=SDTH;
  }else if (streq(which,"SLTM")) {
    r=SLTM;
  }else{
    err_set(1,"bad fisrt argumnet in setAttribute: %s",which);
    r=0;
  }

  return(r);
}

void setAttributeFA(char *which,float *what)
{
  int i;
  int nf;

  if (streq(which,"SLWM")) {
    nf=sizeof(SLWM)/sizeof(float);
    for (i=0;i<nf;i++) SLWM[i]=what[i];
    send_bheader(graphix,"SLWM",nf*sizeof(int));
    send_bfloata(graphix,nf,SLWM);
  }
}

float *getAttributeFA(char *which)
{
  float *r;

  if (streq(which,"SLWM")) r=SLWM;
  else r=NULL;
  return(r);
}

