#ifndef BHTREEDEF
#define BHTREEDEF

#include "object.h"

typedef struct BHnode {
  struct BHnode *left,*right;
  Atom   **atom;
  float  cut;
  int    dim,n,marked;
} BHnode;  

typedef struct BHtree {
  struct BHnode *root;
  Atom **atom;
  float xmin[3];
  float xmax[3];
  int n,own_atoms;
} BHtree;

#define BH_CUT_MIDDLE 1
#define BH_CUT_MEDIAN 2

BHtree *generateBHtree(Nodechain *atoms,int granularity);
BHtree *GenerateBHtree(int N,Atom **atoms,int granularity);
BHnode *findBHnode(BHtree *tree,float *x);
int    findBHcloseAtoms(BHtree *tree,float *x,float cutoff,
		    Atom **atom,float *d,int maxn);
int    nrfindBHcloseAtoms(BHtree *tree,int idx,float cutoff,
		    Atom **atom,float *d,int maxn);
Atom  *findBHclosest(BHtree *tree,float *x,float dmax,float *d);
Atom  *findBHnearestNeighbour(BHtree *tree,Atom *A,float dmax,float *d);
void   freeBHtree(BHtree *tree);
void   divideBHnode(BHnode *node,float *xmin,float *xmax,int granularity);
void   freeBHnode(BHnode *node);
int    markBHcloseAtoms(BHtree *tree,float *x,float cutoff,int flag);
float  findBHmindist(BHtree *tree,float *x);
int    mark_close(int n1,Atom **A1,int n2,Atom **A2,float maxd);
int    set_bh_cut_method(int m);

#endif
