#include <stdio.h>
#include <unistd.h>
#include <math.h>
#include "object.h"
#include "swdef.h"
#include "mystdlib.h"
#include "parser.h"
#include "transpor.h"
#include "strutil.h"
#include "errhand.h"
#include "gcalc.h"
#include "bhtree.h"
#include "graphics.h"

extern int graphix;
extern Node *DefaultNode,*MolRoot;
extern Dspobj *DspRoot;

#define neighbour(i,a) (a->bnd[i]->f == a ? a->bnd[i]->t : a->bnd[i]->f)
#define key_is(a) (streq(a,key->key))
#define free_menu(x) if (mvld(x)) free(x),x=(char *)NULL

#define PSF  1
#define RTF  2
#define XPSF 3

void cmd_charmm(void)
{
  Token *key;
  char *fname,*menu,buf[4096];
  Nodechain *c;
  Node *root;
  Atom *a;
  int type=0;

  key=(Token *)NULL;
  fname=(char *)NULL;
  menu=(char *)NULL;

  key=Get_Kwd("file type: ",";","psf rtf xpsf");
  if (key->status==TOK_OK) {
    if (key_is("psf")) type=PSF;
    else if (key_is("rtf")) type=RTF;
    else if (key_is("xpsf")) type=XPSF;
    key=free_Token(key);
    key=Get_String("File: ",";");
    if (key->status==TOK_OK) {
      fname=Strdup(key->text);
      key=free_Token(key);
      menu=Make_TopMolNameList("",DefaultNode);
      key=Get_Mols_M("molecule: ",";",menu); free_menu(menu);
      send_bheader(graphix,"ARMK",0);
      if (key->status==TOK_OK) {
	c=(Nodechain *)key->ptr;
	if (c->n>1) {
	  err_set(1,"molecule selection is ambiguous.");
	  key->status=TOK_NOK;
	}else if (c->n<1) {
	  err_set(1,"no molecule selected.");
	  key->status=TOK_OK;
	}else{
	  root=c->s;
	  ForAtoms(a,root) a->flg|=(1<<1);
	  switch (type) {
	  case PSF:
	    prtGraphics("writing PSF file %s for %s\n",fname,nodeptr_to_name(buf,root));
	    write_charmm_psf(fname,root,CHRM_PSF_CHARMM);
	    break;
	  case XPSF:
	    prtGraphics("writing XPSF file %s for %s\n",fname,nodeptr_to_name(buf,root));
	    write_charmm_psf(fname,root,CHRM_PSF_XPLOR);
	    break;
	  case RTF:
	    prtGraphics("writing RTF file %s for %s\n",fname,nodeptr_to_name(buf,root));
	    write_charmm_rtf(fname,root);
	    break;
	  }
	  ForAtoms(a,root) a->flg&=~(1<<1);
	}
	clear_node_chain(c); free_node_chain(c);
      }else if (key->status==TOK_NOK) err_set(1,"bad molecule selection: %s",key->text);
    }else if (key->status==TOK_NOK) err_set(1,"bad filename: %s",key->text);
  }else if (key->status==TOK_NOK) {
    err_set(1,"unknown CharMM file type: %s",key->text);
  }
  free_Token(key);
  if (mvld(fname)) free(fname);
  if (mvld(menu)) free(menu);
}
