#include <stdio.h>
#include <math.h>
#include "object.h"
#include "swdef.h"
#include "mystdlib.h"
#include "parser.h"
#include "transpor.h"
#include "strutil.h"
#include "errhand.h"

extern int graphix;
extern Node *DefaultNode;

#define TRUE 1
#define FALSE 0

#define COL_BY_TYPE -1

void cmd_color(void)
{
  int  i,color,old_color,new_color,size,nchgd;
  Token *key;
  Atom *a;
  Nodechain *c,colst[WNP_MAXCOL];
  
  key=Get_Color_M("color: ",";","by_atomtype ' '");
  if (key->status==TOK_OK) {
    color=key->n;
    free_Token(key);
    key=Get_Atoms_D("Atoms: ",";");
    c=(Nodechain *)key->ptr;
    if (key->status==TOK_OK) {
      for (i=0;i<WNP_MAXCOL;i++) {
	colst[i].n=0; 
	colst[i].s=(Node *)NULL; 
	colst[i].e=(Node *)NULL;
      }
      for (a=(Atom *)c->s;a;a=(Atom *)a->chain) {
	if (color==COL_BY_TYPE) {
	  if (a->atp) new_color=a->atp->color;
	  else new_color=a->color;
	}else{
	  new_color=color;
	}
	old_color=(a->color<0 ? -a->color : a->color);
	a->color=(color==COL_BY_TYPE ? -new_color : color);
	if (old_color==new_color||!cPtr(a->cross)||new_color>=WNP_MAXCOL) new_color=0;
	if (new_color>=WNP_MAXCOL||new_color<0) new_color=0;
	if (colst[new_color].e) colst[new_color].e->chain=(Node *)a;
	else colst[new_color].s=(Node *)a;
	colst[new_color].e=(Node *)a;
	colst[new_color].n++;
      }
      for (i=1;i<WNP_MAXCOL;i++) {
	if (colst[i].e) colst[i].e->chain=(Node *)NULL;
	nchgd=colst[i].n;
	if (nchgd>0) {
	  size=sizeof(int)+nchgd*cPtrSize();
	  send_bheader(graphix,"ATCO",size);
	  send_bint(graphix,i);
	  for (a=(Atom *)colst[i].s;a;a=(Atom *)a->chain) {
	    send_bcptr(graphix,a->cross);
	  }
	}
      }
      for (i=0;i<WNP_MAXCOL;i++) clear_node_chain(&colst[i]);
      if (mvld(key->ptr)) free(key->ptr);
    }
  }else if (key->status==TOK_NOK) {
    err_set(1,"unknown color: %s",key->text);
  }
  free_Token(key);
}
