#include <stdio.h>
#include <math.h>
#include "object.h"
#include "swdef.h"
#include "mystdlib.h"
#include "parser.h"
#include "transpor.h"
#include "strutil.h"
#include "errhand.h"

extern int graphix;
extern Node *DefaultNode;

#define key_is(a) (streq(a,key->key))

#define TRUE 1
#define FALSE 0

void cmd_cpk(void)				    /* render atoms */
{
  int display,nchgd,size;
  Atom *a;
  Nodechain *c;
  Token *key;
  
  key=Get_Kwd("status: ",";","on off");
  if (key->status == TOK_OK) {
    display=key_is("on");
    free_Token(key);
    
    key=Get_Atoms_D("Atoms: ",";");
    if (key->status == TOK_OK) {
      c=(Nodechain *)key->ptr;
      for (nchgd=0,a=(Atom *)c->s;a;a=(Atom *)a->chain) {
	a->sdsp=display?1:0;
	if (cPtr(a->cross)) nchgd++;
      }
      size=sizeof(int)+nchgd*cPtrSize();
      send_bheader(graphix,"ARST",size);
      send_bint(graphix,display);
      for (a=(Atom *)c->s;a;a=(Atom *)a->chain) {
	if (cPtr(a->cross)) {
	  send_bcptr(graphix,a->cross);
	}
      }
      trflush(graphix);
      clear_node_chain(key->ptr);
      free_node_chain(key->ptr);
    }
  }else if (key->status == TOK_NOK) {
    err_set(1,"unknown status: %s",key->text);
  }
  send_header(graphix,"ARMK",0);
  free_Token(key);
}
