#include <stdio.h>
#include <math.h>
#include "object.h"
#include "swdef.h"
#include "mystdlib.h"
#include "parser.h"
#include "transpor.h"
#include "strutil.h"
#include "xtal.h"
#include "errhand.h"

extern int graphix;
extern Dspobj *DspRoot;

#define TRUE 1
#define FALSE 0

#define key_is(x) (streq(x,key->key))

void cmd_freeze(void)
{
  Token *key;
  char *glblnames;
  mat_4 pt,ot;
  Dspobj *root,*o;
  Atom *a;
  Node *m;
  Xcn *xcn;
  int i;
  
  glblnames=Make_GlblNameList("/",DspRoot);
  if (glblnames) {
    key=Get_DspGlbl_M("object: ",";",glblnames);
    free(glblnames);
  }else key=Get_DspGlbl_M("object: ",";","/");
  if (key->status==TOK_OK) {
    /* lock server event queue */
    lock_evtq();
    root=(Dspobj *)key->ptr;
    pt=dsp_transform((Dspobj *)root->up);
    pt=mmxinv(pt);
    get_MVT(root);
    /* the following will deal with all that needs to be done in the server... */
    send_bmessage(graphix,"FRZE",sizeof(root),(char *)&root);
    /* transform coordinates in the client */
    ForDspobjs(o,root) {
      if (o->dsptype==DSP_MOL) {
	m=o->root;
	if (mvld(m)) {
	  ot=m4xm4(pt,((Dspobj *)o->up)->mtrx);
	  ForAtoms(a,m) transform_atom(ot,a);
	  xcn=first_xcn(m);
	  if (mvld(xcn)) {
	    for (i=0;i<xcn->nsymx;i++) xcn->sym[i]=symF(xcn,xcn->sym[i]);
	    xcn->fta=m4xm4(ot,xcn->fta);
	    xcn->atf=inv_4(xcn->fta);
	    for (i=0;i<xcn->nsymx;i++) xcn->sym[i]=symA(xcn,xcn->sym[i]);
	  }
	}
      }
    }
    /* for each global: transform pivot and reset global transformation */
    ForDspobjs(o,root) {
      if (o->dsptype==DSP_GLBL) {
	ot=m4xm4(pt,o->mtrx);
	v32arr(o->pivot,m4xv3(ot,vec3(o->pivot)));
	for (i=0;i<3;i++) o->tra[i]=0;
	o->rot=ident_4();
      }
    }
    /* finally, transform pivot of root, and reset local transformation */
    ot=m4xm4(pt,root->mtrx);
    v32arr(root->pivot,m4xv3(ot,vec3(root->pivot)));
    for (i=0;i<3;i++) root->tra[i]=0;
    root->rot=ident_4();
    /* unlock event que in server... */
    unlock_evtq();
  }else if (key->status==TOK_NOK) {
    err_set(1,"unknown display object: %s",key->text);
  }
  free_Token(key);
}
