#include <stdio.h>
#include <math.h>
#include "object.h"
#include "swdef.h"
#include "mystdlib.h"
#include "parser.h"
#include "transpor.h"
#include "strutil.h"
#include "streamio.h"
#include "errhand.h"

extern int graphix;
extern int command_level;

#define key_is(a) (streq(a,key->key))
#define TRUE  1
#define FALSE 0

void cmd_pause(void)
{
  Token *key;
  float time;
  int loop=0,quiet=FALSE;
  Stream *s;
  
  default_token("forever");
  key=Get_Kwd("seconds: ",";","'h!-quiet' command '1' '5' '10' '15' '30' '60' forever");
  if (key_is("-quiet")) {
    quiet=TRUE;
    default_token("forever");
    key=Get_Kwd("seconds: ",";","command '1' '5' '10' '15' '30' '60' forever");
  }
  end_parse();
  if (key->status == TOK_OK) {
    if (key_is("forever")) {
      if (push_parse((char *)NULL)) {
	do {
	  err_dump();
	  free_Token(key);
	  default_token("continue");
	  key=Get_Kwd("option: ","","continue command popcmds");
	  if (key->status==TOK_OK) {
	    if (key_is("command")) {
	      if (push_parse((char *)NULL)) {
		command_loop("Pause> ");
		pop_parse();
		loop=TRUE;
	      }else{
		err_set(1,"failed to push parser."); 
		loop=TRUE;
	      }
	    }else if (key_is("continue")) {
	      loop=FALSE;
	    }else if (key_is("popcmds")) {
	      loop=FALSE;
	      for (s=CurrStream();;s=CurrStream()) {
		if (s->prv) {
		  if (s->prv->type!=STRM_NULL) pop_parse();
		  else break;
		}else break;
	      }
	    }
	  }else if (key->status==TOK_NOK) {
	    err_set(1,"bad token.");
	    loop=TRUE;
	  }else{
	    loop=TRUE;
	  }
	} while (loop);
	pop_parse();
      }else{
	err_set(1,"internal error: failed to push stream.");
      }
    }else if (key_is("command")) {
      if (push_parse((char *)NULL)) {
	command_loop("Pause> ");
	pop_parse();
      }else err_set(1,"failed to push parser."); 
    }else{
      time=str2f(key->key);
      if (time>0) {
	if (!quiet) prtGraphics("gone to sleep for %0.1f seconds...\n",time);
	uSleep(time*1000000);
      }else err_set(1,"bad token:",key->text);
    }
  }else{
    if (key->status==TOK_NOK) {
      time=str2f(key->text);
      if (time>0) {
	if (!quiet) prtGraphics("gone to sleep for %0.1f seconds...\n",time);
	uSleep(time*1000000);
      }else{
	send_bheader(graphix,"EVTQ",0);
      }
    }
  }
  free_Token(key);
}
