#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "cyana.h"

/* structure used by sort in str2types */

typedef struct iTP_t {
  int i;
  char *str;
} iTP_t;

static char *types2str(cyaAtom_t *A);
static int   str2types(cyaResidue_t *L,char **str);
static int   compare_utpStr(const void *A, const void *B);

void cyaAssignUniqueTypes(cyaResidue_t *L)
{
  int i,nt,old;
  char **str=NULL;

  if (L && L->nat>0) {
    str=malloc(L->nat*sizeof(char *));
    if (str) {
      for (i=0;i<L->nat;i++) L->A[i]->utp=L->A[i]->z;
      for (old=0,nt=1;old<nt;) {
	old=nt;
	for (i=0;i<L->nat;i++) str[i]=types2str(L->A[i]);
	nt=str2types(L,str);
	for (i=0;i<L->nat;i++) free(str[i]);
      }
    }
    if (str) free(str);
  }
}

static char *types2str(cyaAtom_t *A)
{
  int i,j,ntp[CYAMAXNB];
  char buff[2048];

  for (i=0;i<A->nn;i++) {
    ntp[i]=A->n[i]->utp;
    for (j=i;j>0;j--) {
      if (ntp[j-1]>ntp[j]) {
	ntp[j]=ntp[j-1];
	ntp[j-1]=A->n[i]->utp;
      }
    }
  }
  sprintf(buff,"%d",A->utp);
  for (i=0;i<A->nn;i++) sprintf(buff+strlen(buff)," %d",ntp[i]);
  return (strdup(buff));
}

static int str2types(cyaResidue_t *L,char **str)
{
  int i,nxt=0;
  iTP_t *idx;
  char *old="";

  idx=malloc(L->nat*sizeof(iTP_t));

  if (idx) {
    for (i=0;i<L->nat;i++) {
      idx[i].i=i;
      idx[i].str=str[i];
    }
    qsort(idx,L->nat,sizeof(iTP_t),compare_utpStr);
    for (i=0;i<L->nat;i++) {
      if (strcmp(old,idx[i].str)) {
	old=idx[i].str;
	nxt+=1;
      }
      L->A[idx[i].i]->utp=nxt;
    }
    free(idx);
  }
  return nxt;
}

static int compare_utpStr(const void *A, const void *B)
{
  int r;
  char *a,*b;

  a=((iTP_t *)A)->str;
  b=((iTP_t *)B)->str;

  r=strcmp(a,b);
  return r;
}
