#ifndef FILEUTILDEF
#define FILEUTILDEF

#include <stdio.h>

#define UCP_FILE  1
#define UCP_PIPE  2
#define UCP_BLOCK 3

typedef struct {
  FILE *fd;
  int pipe,eof;
  char *filename;
  char *block;
  char *bptr;
}UCpipe;

typedef struct {
  int *nr;
  long *pos;
  int N,n,limit;
}FileCache;

UCpipe *UCpopen(char *file);
UCpipe *UCpblock(char *block);
int     UCpclose(UCpipe *ucp);
int     UCpeof(UCpipe *ucp);
int     UCperror(UCpipe *ucp);
char   *UCpgets(char *s,int n,UCpipe *p);
int     UCpgetc(UCpipe *ucp);

FileCache *makeFileCache(int size,int limit);
int findFileCachePos(FileCache *cache,int target);
void addFileCachePos(FileCache *cache,int now,long pos);
void purgeFileCache(FileCache *cache);
FileCache *freeFileCache(FileCache *cache);
int FindFileName(char *path,char *name,char *fullname,int nl);
int FileAccessible(int amode,char *dir,char *name,char *fullname,int n);
int FileReadable(char *dir,char *name,char *fullname,int n);
int FileExists(char *dir,char *name,char *fullname,int n);
int FileExecutable(char *dir,char *name,char *fullname,int n);
FILE *PipeOpen(char *cmd,char *type);
int   PipeClose(FILE *fp);

#endif
