#ifndef GCALCDEF
#define GCALCDEF

typedef struct {
  float c[3];
} vec_3;

typedef struct {
  vec_3 r[3];
} mat_3;

typedef struct {
  float c[4];
} vec_4;

typedef struct {
  vec_4 r[4];
} mat_4;

vec_3 vec3(float *x);
mat_3 mat3(float *x);
mat_3 m3t(mat_3 m);
mat_3 ident_3(void);
mat_3 rot3of(mat_4 m);
void  v32arr(float *x,vec_3 v);
void  m32arr(float *x,mat_3 m);
vec_3 v3n(vec_3 v);
float v3l(vec_3 v);
float v3sv3(vec_3 v,vec_3 w);
vec_3 v3xv3(vec_3 v,vec_3 w);
vec_3 v3mv3(vec_3 v,vec_3 w);
vec_3 v3pv3(vec_3 v,vec_3 w);
vec_3 sxv3(float s,vec_3 v);
vec_3 v3ds(vec_3 v,float s);
vec_3 m3xv3(mat_3 a,vec_3 v);
mat_3 m3xm3(mat_3 a,mat_3 b);
vec_4 sxv4(float s,vec_4 v);
vec_4 vec4(float *x);
mat_4 mat4(float *x);
mat_4 m4t(mat_4 m);
mat_4 ident_4(void);
mat_4 zero_4(void);
mat_4 inv_4(mat_4 a);
mat_4 m4xm4(mat_4 a,mat_4 b);
mat_4 m4mm4(mat_4 a,mat_4 b);
mat_4 rotm4(char axis,float angle);
int   is_mmx(mat_4 m);
float mmx_err(mat_4 m);
mat_4 mmxinv(mat_4 m);
mat_4 rotax(float *a,float *b,float tau);
vec_3 m4xv3(mat_4 a,vec_3 x);
void  prt_mat4(mat_4 a);
float m4scale(mat_4 m);
void  m4factor(float r[3][3],float t[3],float *s,mat_4 matrix);
void  eqrxyz(float *rx,float *ry,float *rz,mat_4 rmat);
void  v42arr(float *x,vec_4 v);
void  m42arr(float *x,mat_4 m);
float cdist(float *x,float *y);
float cdistsq(float *x,float *y);
float cangle(float *x,float *y,float *z);
float cangled(float *x,float *y,float *z);
float ctors(float *p,float *q,float *r,float *s);
float ctorsd(float *p,float *q,float *r,float *s);
void  wline2xyz(float *line,float z,float *xyz);
vec_3 wline2v3(float *line,float z);
int   cnstr(float *p,float *x,float *y,float *z,float d3,float alp,float tau);
vec_3 cnstrv(vec_3 x,vec_3 y,vec_3 z,float d3,float alp,float tau);
mat_4 QtoRot4(float *q);
vec_3 Rot3Euler(mat_3 R);
mat_3 EulerRot3(float *tau);
mat_3 EulerRot3Dq(float *tau,int k);
mat_4 EulerRot4(float *tau);

#endif
