#ifndef MAESTREAM
#define MAESTREAM

#include <stdio.h>
#include "strutil.h"
#include "fileutil.h"

typedef struct maestream_t {
  UCpipe *in;                /*  source of stream             */
  char   *buff;              /*  I/O buffer                   */
  char   *token;             /*  token buffer                 */
  int    eof;                /*  have we reached EOF?         */
  int    own_p;              /*  does stream own in pipe ?    */ 
  int    buffsz;             /*  buffer size                  */
  int    mts;                /*  size of token buffer         */
  int    pos;                /*  next char position in buff   */
  int    tpos;               /*  next character in token      */
  int    own_t;              /*  does stream own token ?      */
} maestream_t ;


maestream_t *maeStream_open(char *filename,UCpipe *pipe,int maxsize,char *token,int mts);
maestream_t *maeStream_close(maestream_t *s);
char *mae_token(maestream_t *s);


#endif
