#include <stdio.h>
#include <unistd.h>
#include "mystdlib.h"
#include "strutil.h"
#include "errhand.h"
#include "object.h"
#include "transpor.h" 
#include "swdef.h"

extern int graphix;

/*-------------------- err_dump --------------------*/

void err_dump()
{
  while (err_depth()>0) {
    prt_message(graphix,"%s",err_text_bot());
    wnpRPCprintResponse(1,err_text_bot());
    err_dequeue(1);
  }
}
/*-------------------- getCWD --------------------*/

char  *getCWD(char *buf,int size)
{
  char *cwd;
#ifdef mingw
  char *p;
#endif

  cwd=getcwd(buf,size);
#ifdef mingw
  /* replace \ in path by /, to make it mor UNIXish */
  if (cwd) {
    for (p=cwd;*p;p++) if (*p=='\\') *p='/';
  }
#endif
  return(cwd);
}

/*-------------------- newtwd --------------------*/

char *newtwd(char *old,char *update)
{
  /* update temporary working directory name        */
  /* quite dirty stuff here:                        */
  /* it is assumed the old is large enough to hold  */
  /* the updated path                               */

  char *r,*p,*q;
  int first;
#ifdef mingw
  char *cpy;
#endif
  
  r=old;

#ifdef mingw
  /* we have to handle drive-letter garbage... */
  /* replace \ in path by /, to make it mor UNIXish */
  if (old) for (p=old;*p;p++) if (*p=='\\') *p='/';
  if (update) {
    update=strdup(update);    /* to avoid modification... */
    cpy=update;
    for (p=update;*p;p++) if (*p=='\\') *p='/'; 
    if (isalpha(update[0])&&update[1]==':') {
      old[0]=update[0];
      old[1]=':';
      old[2]='\0';
      update+=2;
      old+=2;
    }else if (isalpha(old[0])&&old[1]==':') {
      old+=2;
    }
  }
#endif

  if (r) {
    first=TRUE;
    while (update&&strlen(update)>0) {
      if (strlen(old)>0) {
	p=old+strlen(old)-1;
	if (*p!='/') {
	  *(++p)='/';
	  *(++p)='\0';
	}
      }else{
	strcpy(old,"./");
      }
      p=strchr(update,'/');
      if (p==update) {
	if (first) {
	  old[0]='/';
	  old[1]='\0';
	  first=FALSE;
	}
	update++;
      }else {
	if (p) *p='\0'; 
	if (streq(update,"..")) {
	  if (!streq(old,"/")) {
	    old[strlen(old)-1]='\0';
	    q=strrchr(old,'/');
	    if (q) {
	      if (streq(q+1,"..")) {
		strcat(old,"/../");
	      }else{
		*(++q)='\0';
	      }
	    }else{
	      if (streq(old,".")||streq(old,"..")) {
		strcat(old,"/../");
	      }else{
		strcpy(old,"../");
	      }
	    }
	  }
	}else if (!streq(update,".")) {
	  strcat(old,update);
	}
	if (p) {
	  *p++ = '/'; update=p;
	}else{
	  update+=strlen(update);
	}
      }
      first=FALSE;
    }
    if (strlen(r)>0) {
      p=old+strlen(r)-1;
      if (*p!='/') {
	*(++p)='/';
	*(++p)='\0';
      }
    }
  }

  /* cleanup */

#ifdef mingw
  if (cpy) free(cpy); /* on MINGW, this is just a copy... */
  if (strlen(r)>1 && r[strlen(r)-1]=='/' && 
      (r[strlen(r)-2]!=':'||strlen(r)>3)) r[strlen(r)-1]='\0';
  if (strlen(r)==2&&r[1]==':') strcpy(r+2,".");
#else
  if (strlen(r)>1 && r[strlen(r)-1]=='/') r[strlen(r)-1]='\0';
#endif

  return(r);
}
/*----------------------------- startCmd --------------------*/

int startCmd(char *command,char *logfile,char *errfile,int wait,char *priority)
{
  char cmd[8196];

  /* Interface to 'system'. If the shell is DOS::cmd.exe, this needs the help of 'start' */
  /* command is the command to execute,     */
  /* stdout and stderr will be redirected to logfile and errfile  */
  /* if errfile is "-join", stderr will be joined to stdout (not a real join in DOS...) */
  /* if wait is TRUE, function will wait for completion, else return immediately */
  /* priority is the process priority in which the command will run (DOS only, ignored in Unix) */

#ifdef mingw
  sprintf(cmd,"start /B /%s ",priority);
  if (wait) sprintf(cmd+strlen(cmd),"/wait ");
  sprintf(cmd+strlen(cmd),"%s",command);

  if (streq(logfile,"-null")) {
    sprintf(cmd+strlen(cmd)," 1> nul");
  }else if (strlen(logfile)>0) {
    sprintf(cmd+strlen(cmd)," 1> %s",logfile);
  }

  if (streq(errfile,"-join")) {
    if (streq(logfile,"-null")) {
      sprintf(cmd+strlen(cmd)," 2> nul");
    }else if (strlen(logfile)>0) {
      /* sprintf(cmd+strlen(cmd)," 2> %s",logfile); */
    }
  }else if (streq(errfile,"-null")) {
    sprintf(cmd+strlen(cmd)," 2> nul");
  }else if (strlen(errfile)>0) {
    sprintf(cmd+strlen(cmd)," 2> %s",errfile);
  }
#else
  sprintf(cmd,"%s",command);

  if (streq(logfile,"-null")) {
    sprintf(cmd+strlen(cmd)," 1> /dev/null");
  }else if (strlen(logfile)>0) {
    sprintf(cmd+strlen(cmd)," 1> %s",logfile);
  }

  if (streq(errfile,"-join")) {
    sprintf(cmd+strlen(cmd)," 2>&1");
  }else if (streq(errfile,"-null")) {
    sprintf(cmd+strlen(cmd)," 2> /dev/null");
  }else if (strlen(errfile)>0) {
    sprintf(cmd+strlen(cmd)," 2> %s",errfile);
  }
  if (!wait) sprintf(cmd+strlen(cmd)," &");
#endif
  return(system(cmd));
}
