/*todo: multiple sources of messages (~1990) */

#include <stdio.h>
#include "mystdlib.h"
#include "object.h"
#include "swdef.h"
#include "transpor.h"
#include "strutil.h"

extern int graphix;
extern int server;

static Qmsg *MsgQF,*MsgQL;

static int NoResponseFromServer = 0;

void initmsgq(void)
{
  MsgQF=(Qmsg *)NULL;
  MsgQL=(Qmsg *)NULL;
}

Qmsg *qmsg(char *type,int size,char *msg)
{
  Qmsg *new;
  
  new=(Qmsg *)malloc(sizeof(Qmsg));
  if (!new) return((Qmsg *)NULL);
  new->nxt=(Qmsg *)NULL;
  strncpy(new->type,type,4);
  new->size=size;
  new->msg=(char *)NULL;
  if (size>0) {
    new->msg=(char *)malloc(size);
    if (!new->msg) {
      free(new);
      return((Qmsg *)NULL);
    }
    memcpy(new->msg,msg,size);
  }
  if (MsgQL) {
    MsgQL->nxt=new;
    MsgQL=new;		
  }else{
    MsgQF=new;
    MsgQL=new;
  }
  return(new);
}

Qmsg *delqmsg(Qmsg *Msg)
{
  Qmsg *prev;
  
  if (!Msg) return(NULL);
  if (!MsgQF) return(NULL);
  
  if (Msg==MsgQF) {
    if (MsgQF==MsgQL) {
      MsgQF=MsgQL=(Qmsg *)NULL;
    }else{
      MsgQF=Msg->nxt;
    }
  }else{
    for (prev=MsgQF;Msg!=prev->nxt;prev=prev->nxt){};
    prev->nxt=Msg->nxt;
    if (Msg==MsgQL) MsgQL=prev;
  }
  if (Msg->size>0) free(Msg->msg);
  free(Msg);
  return(NULL);
}

Qmsg *nextqmsg(char *types)
{
  Parse p;
  char type[5];
  Qmsg *m,*msg;
  
  msg=(Qmsg *)NULL;;
  p.buf=types;
  p.tok=type;
  p.mts=5;
  p.sep="";
  p.pos=0;
  
  while (get_token(&p)) {
    m=MsgQF;
    while (m!=msg) { 
      if (strcmp(type,"*")==0 || strncmp(m->type,type,4)==0) msg=m;
      else m=m->nxt;
    }
  }
  return(msg);
}

Qmsg *waitqmsg(char *types)
{
  Qmsg *qm;
  
  if (graphix<=0) return((Qmsg *)NULL);
  while (!(qm=nextqmsg(types))) if (!fillmsgq(MSGQWAIT)) break;
  return(qm);
}

void readqmsg(Qmsg *qm,char *msg)
{
  if (qm->size > 0) memcpy(msg,qm->msg,qm->size);
  delqmsg(qm);
}

void syncqmsg(char *discard)
{
  /* synchronize message queue : send SYNC request, discard all messages
     of given types up to SYNC response
     */
  
  Qmsg *q,*qs;
  
  if (graphix<1) {
    while((q=nextqmsg(discard))) delqmsg(q);
  }else{
    send_header(graphix,"SYNC",0);
    while(!(qs=nextqmsg("SYNC"))) {
      while((q=nextqmsg(discard))) delqmsg(q);
      if (!fillmsgq(MSGQWAIT)) break;
    }
    delqmsg(qs); 
  }
}

Qmsg *fillmsgq(int wait)
{
  int flags=0,size;
  char *hdr,*msg=(char *)NULL;
  Qmsg *q;
  
  q=(Qmsg *)NULL;
  trflush(graphix);                         /* make sure we are in sync */
  flags=transport_wait(graphix,wait);
  if ((hdr=got_message(graphix))) {
    transport_wait(graphix,TRUE);
    size=message_size(graphix);
    q=qmsg(hdr,0,(char *)NULL);
    if (q) {
      if (size>0) {
	msg=(char *)malloc(size);
	if (msg) {
	  read_message(graphix,hdr,msg);
	  q->size=size;
	}else{
	  q->size= -1;
	}		    
      }else{
	read_message(graphix,hdr,msg);
      }
      q->msg=msg;
    }
  }else{
    if (wait) {
      qmsg("SCCN",0,(char *)NULL);
      if (server) {
	fprintf(stderr,"fillmsgq: No response from server...\n");
	NoResponseFromServer++;
	if (NoResponseFromServer>100) {
	  fprintf(stderr,"Internal error, Parser ignores SCCN\n");
	  fprintf(stderr,"Abort\n");
	  *((int *)NULL) = 1;         /* should force coredump... */
	  exit(1);
	}
      }
    }
  }
  transport_wait(graphix,flags);
  return(q);
}
