#ifndef PEAKSDEF
#define PEAKSDEF

#include <stdio.h>
#include "object.h"
#include "insane.h"

#define NMR_SORT_NOTHING       0
#define NMR_SORT_BY_PEAKNR     1
#define NMR_SORT_BY_D1         2
#define NMR_SORT_BY_3D         3
#define NMR_SORT_BY_ASSIGNMENT 4

#define NMR_PKFT_FELIX         1
#define NMR_PKFT_SPARKY        2

typedef struct {
  PAtom *pa;
  float pt[3];
} PApts;

void             nmr_peaks(Mol *root,DistFilter filter);
void             nmr_peaks_read(Mol *root);
void             nmr_peaks_write(Mol *root);
void             nmr_peaks_delete(Mol *root);
void             nmr_peaks_identify(Mol *root,float pntres);
void             nmr_peaks_make(Mol *root,DistFilter filter);
void             nmr_peaks_sort(Mol *root);
void             nmr_peaks_assignment(Mol *root,DistFilter filter);
void             nmr_reset_assignment(Mol *root);
void             nmr_peaks_annotation(Mol *root,DistFilter filter);
void             nmr_annotate_peaklist(HHDistInfo *DI,FELIXMATRIXP mat,DistFilter filter);
void             nmr_insane_assign(Mol *root,DistFilter filter);
void             nmr_insane_assignment(HHDistInfo *DI,FELIXMATRIXP mat,DistFilter filter);
nmrPeakList      nmr_peaks_from_structure(HHDistInfo *DI,int spect,float pntres);
void             nmr_sort_peaks(int np,nmrPeak **P,int key);
int              nmr_findPeaks(float *pt,int np,nmrPeak **P,float *tol,int mxnr,int *Nr);
int              nmr_findClosestPeak(float *pt,int np,nmrPeak **P,float *tol);
int              nmr_findPAtomsf1f3(float *pt,int np,PApts **P,float *tol,int mxnr,int *Nr);
int              nmr_findPAtomsf2(float *pt,int np,PApts **P,float *tol,int mxnr,int *Nr);
void             nmr_writePeak_file(FILE* out,char *buf,FELIXMATRIXP mat,int ft);
int              insane_reduction(HHDistInfo *DI,nmrPeak **P,int n,int *nr,DistFilter filter);
#endif
