#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include "mystdlib.h"
#include "object.h"
#include "swdef.h"
#include "strutil.h"
#include "fileutil.h"
#include "transpor.h"
#include "errhand.h"
#include "xtal.h"
#define NO 0
#define YES 1
#define Return(x) {if (own_p)UCpclose(in);if (mvld(spgrp))free(spgrp);return(x);}
#define MAXTOKENSIZE 133
#define RECSZ 256
#define TRUE 1
#define FALSE 0

#define key_is(s) (recin && strncmp(recin,s,strlen(s))==0)

extern int graphix;
extern Node *LibRoot;

static int fc[4] = {12,17,22,27} ;

static int parseNameField(char *name,char *chs,char *resnam,int type);
static void fixupName(char *name);

/*********************************************************************/
int read_pdb(UCpipe *in,char *file,Node *node,int type)
     
     /*   Read Brookhaven file into node. Default extension is PDB,
	  Returns non-zero status if read fails.  */

     /*   accepts 4-letter residuenames in cols. 18-21 */
     /*   reads multi-mol files */
     /*   reads chain name from col 22 or cols 73...76, depending on type */

{
  char *recin,rec[RECSZ],cur_res[10],resnam[10],resnr[10],name[5],model_name[10];
  char res[20],chain[20],cur_chain[20],chrg[3];
  char alt,x[3][10],chs[3],sernr[6],buff[256],*spgrp;
  int fchrg,nold;
  float err;

  Node *cur_node,*res_node=(Node *)NULL,*cthis,*cnext,*m,*r,*rn;
  Node *rthis,*rnext;
  Node *ResLib;
  Bond FBC;
  Lib  *reslib;
  Link *L,*L2;
  Symbol *S;
  Atom *a,*b,*t,**tab,*l1,*l2;
  Atmmatch *mthis,*mnext;
  Atomdef *def,*default_type;
  Bond *bnd,*nb;
  int SR,i,j,k,l,maxsernr,ia,ib,since,in_model,nmodels,natrec,own_p,susp,nalt;
  float sof,biso,d,D;
  Xcn *xcn;
  
  own_p=(in ? FALSE : TRUE);
  if (own_p) in=UCpopen(extfil(rec,file,".pdb",NO));
  if (!in) return(1);
  
  ResLib=find_name(LibRoot,"ResLib",OBJ_LIB);
  if (!mvld(ResLib)) {
    err_set(-1,"Failed to open default library");
    if (own_p) UCpclose(in);
    return(-1);
  }
  reslib=(Lib *)ResLib;
  default_type=find_atomdef_name((Node *)reslib,"unk");
  if (!mvld(default_type)) {
    default_type=(Atomdef *)add_node(ResLib,"unk",OBJ_ATOMDEF);
  }
  
  spgrp=(char *)NULL;
  cur_res[0]='\0';
  cur_node=node;
  cthis=node;
  cur_chain[0]='\0';
  maxsernr=0;
  a=(Atom *)NULL;
  xcn=(Xcn *)NULL;
  SR=0;
  natrec=0;
  in_model=FALSE;
  nmodels=0;
  
  while((recin=UCpgets(rec,RECSZ,in))) {
    if (strrchr(rec,'\n')) *strrchr(rec,'\n')='\0';
    for (i=strlen(rec);i<80;i++) rec[i]=' ';
    rec[i]='\0';
    
    /* Header, Compound, Source, Author ... */
    
    if (key_is("HEADER")) {
      prtGraphics("%s\n",rec);
    }else if (key_is("COMPND")) {
      prtGraphics("%s\n",rec);
    }else if (key_is("SOURCE")) {
      prtGraphics("%s\n",rec);
    }else if (key_is("AUTHOR")) {
      prtGraphics("%s\n",rec);
    }else if (type==FT_XPDB&&key_is("REMARK")) {
      prtGraphics("%s\n",rec);

    }else if (key_is("CRYST1")) {
      if (!mvld(xcn)) {
	prtGraphics("%s\n",rec);
	xcn=(Xcn *)add_node(node,"Xcn",OBJ_XCN);
	if (mvld(xcn)) {
	  for (i=0;i<3;i++) {
	    xcn->cl[i]=str2f(strfld(buff,rec+6+i*9,1,9));
	    xcn->ca[i]=str2f(strfld(buff,rec+33+i*7,1,7));
	  }
	  spgrp=Strdup(strfld(buff,rec+55,1,11));
	}else{
	  err_set(1,"memory allocation failed (xcn in read_pdb)");
	  Return(899);
	}
      }else{
	err_set(0,"multiple CRYST1 records, ignored.");
      }

    }else if (key_is("SCALE")) {
      if (mvld(xcn)) {
	i=rec[5]-'1';
	if (i>=0 && i<=2) {
	  if (SR==i) {
	    SR++;
	    for (k=0;k<3;k++) {
	      xcn->atf.r[i].c[k]=str2f(strfld(buff,rec+10*k,11,20));
	    }
	    xcn->atf.r[i].c[3]=str2f(strfld(buff,rec,46,55));
	  }else{
	    err_set(1,"wrong order of SCALE records in PDB file");
	    Return(899);
	  }
	}else{
	  err_set(1,"bad SCALE record in PDB file.");
	  Return(899);
	}
      }else{
	err_set(1,"SCALE record out of sequence in PDB file");
	Return(899);
      }

    }else if (key_is("MODEL")) {
      prtGraphics("%s\n",rec);
      if ((natrec>0 && nmodels==0) || in_model) {
	err_set(1,"MODEL record out of sequence...");
	Return(899);
      }
      sprintf(model_name,"M_%s",strsqz(buff,strfld(buff,rec,11,14)));
      cur_node=add_node(node,model_name,OBJ_MOL);
      if (!mvld(cur_node)) {
	err_set(1,"memory allocation failure in read_pdb.");
	Return(899);
      }
      ((Mol *)node)->moltype=MOL_NMRSET;
      cur_res[0]='\0';
      cthis=cur_node;
      cur_chain[0]='\0';
      in_model=TRUE;
      nmodels++;
      ((Mol *)cthis)->moltype=MOL_MODEL;

    }else if (key_is("ENDMDL")) {
      cur_res[0]='\0';
      cur_node=node;
      cthis=cur_node;
      cur_chain[0]='\0';
      in_model=FALSE;

    }else if (key_is("ATOM") || key_is("HETATM")) {

      /* ATOM and HETATM records: */
      
      /* Chain ... */
      
      natrec++;
      if (type==FT_PDB) strfld(chain,rec,22,22);
      else if (type==FT_XPDB) strfld(chain,rec,73,76);
      else strfld(chain,rec,22,22);
      if (!streq(chain,cur_chain)) {
	if (strlen(chain)==0) {
	  cthis=cur_node;
	}else{
	  forObjs(cthis,cur_node,OBJ_MOL) {
	    if (((Mol *)cthis)->moltype==MOL_CHAIN) {
	      if (streq(cthis->name,chain)) break;
	    }
	  }
	  if (!mvld(cthis)) {
	    cthis=add_node(cur_node,chain,OBJ_MOL);
	    if (!mvld(cthis)) Return(3);
	    ((Mol *)cthis)->moltype=MOL_CHAIN;
	  }
	}
	strcpy(cur_chain,chain);
	cur_res[0]='\0';
      }
      
      /* Residue ... */
      
      strfld(resnam,rec,18,21); strfld(resnr,rec,23,27);
      sprintf(res,"%s_%s",resnam,resnr);
      strsqz(res,res);
      if (!streq(cur_res,res)) {
	forNodes(res_node,cthis) if (streq(res_node->name,res)) break;  /*** optimize? ***/
	if (!res_node) res_node=add_node(cthis,res,OBJ_MOL);
	if (!res_node) Return(3);
	strcpy(cur_res,res);
	((Mol *)res_node)->moltype=MOL_RESIDUE;
      }
      
      /* Atom, Hetatm ... */
      
      strfld(name,rec,13,16); alt=rec[16]; strfld(sernr,rec,7,11); 
      strfld(x[0],rec,31,38); strfld(x[1],rec,39,46); strfld(x[2],rec,47,54);
      strfld(buff,rec,55,60); sof=1.0;
      if (strlen(buff)>0) sof=str2f(buff);
      strfld(buff,rec,61,66); biso=15.0;
      if (strlen(buff)>0) biso=str2f(buff);
      susp=FALSE;
      if (type==FT_PDB&&rec[77]!=' ') {
	strfld(chs,rec,77,78);
	if (chs[0]==' ') {
	  chs[0]=chs[1];
	  chs[1]='\0';
	}
	if (chs[1]>='A'&&chs[1]<='Z') chs[1]+='a'-'A';
	if (chs[0]>='a'&&chs[0]<='z') chs[0]+='A'-'z';
	if (ptab_n(chs)<0) {
	  susp=parseNameField(name,chs,resnam,type);
	  chs[0]='\0';
	}
      }else{
	susp=parseNameField(name,chs,resnam,type);
      }
      fixupName(name);
      chrg[0]='\0';
      fchrg='?';
      if (type==FT_PDB&&(rec[78]!=' '||rec[79]!=' ')) {
	if (rec[79]=='+'||rec[79]=='-') {
	  chrg[1]=rec[78];
	  chrg[0]=rec[79];
	  chrg[2]='\0';
	}else{
	  strfld(chrg,rec,79,80);
	}
	strsqz(chrg,chrg);
	nold=err_seqnr();
	fchrg=str2i(chrg);
	if (nold<err_seqnr()) {
	  err_pop(err_seqnr()-nold);
	  chrg[0]='\0';
	}
      }
      a=NULL;
      if (alt!=' ') {
	forAtoms(a,res_node) if (streq(a->name,name)) break;
	if (a) {
	  if (a->nxyz>=a->mxyz) reall_atom_x(a,a->nxyz+1);
	  if (a->nxyz<a->mxyz) {
	    for (i=0;i<3;i++) a->x[i+ATM_LOCSZ*a->nxyz]=str2f(x[i]);
	    a->x[ATM_BISO+ATM_LOCSZ*a->nxyz]=biso;
	    a->x[ATM_SOF+ATM_LOCSZ*a->nxyz]=sof;
	    a->alt[a->nxyz]=alt;
	    a->nxyz++;
	    /***what about seqnr ? ***/
	  }
	}
      }
      if (!a) {
	a=(Atom *)add_node(res_node,(char *)NULL,OBJ_ATOM);
	if (!a) Return(4);
	if (susp) a->flg|=(1<<0);
	a->seqnr=str2i(sernr);
	for (i=0;i<3;i++) a->x[i]=str2f(x[i]);
	a->alt[0]=alt; a->nxyz=1;
	set_node_name((Node *)a,name);
	sprintf(buff,"%s.?",chs);
	def=find_atomdef_name((Node *)reslib,buff);
	if (!mvld(def)) {
	  def=(Atomdef *)copy_node((Node *)default_type);
	  if (mvld(def)) {
	    set_node_name((Node *)def,buff);
	    def->up=(Node *)reslib;
	    link_node((Node *)def);
	    Strcpy(def->chs,chs);
	    S=find_symbol_name((Node *)reslib,chs);
	    if (mvld(S)) {
	      def->mass=S->mass; def->rcov=S->rcov;
	      def->rvdw=S->rvdw;
	    }
	  }
	}
	a->x[ATM_SOF]=sof; a->x[ATM_BISO]=biso;
	set_atom_type(a,def);
	if (strlen(chrg)>0) a->chrg=fchrg;
	maxsernr=(a->seqnr > maxsernr ? a->seqnr : maxsernr);
      }
    }else if (key_is("CONECT")) {
      break;
    }
  }
  
  /* complete XCN info block, if present... */

  if (mvld(xcn)) {
    if (cell_volume(xcn->cl,xcn->ca)<1.5) {
      del_node((Node *)xcn);xcn=(Xcn *)NULL;  /* assume non-cryst cell */
    }
  }

  if (mvld(xcn)) {
    since=err_since();
    if (SR==0) {
      xcn->fta=PDB_fta_matrix(xcn->cl,xcn->ca);
      xcn->atf=inv_4(xcn->fta);
    }else if (SR==3) {
      xcn->fta=inv_4(xcn->atf);
    }else{
      err_set(1,"incomplete set of SCALE records in PDB file");
      del_node((Node *)xcn);
      xcn=(Xcn *)NULL;
    }
    if (since!=err_since()) {
      del_node((Node *)xcn);
      xcn=(Xcn *)NULL;
    }
  }

  /* read symmetry operators in A/cart system */

  if (mvld(xcn)) {
    if (spgrp) read_spgrp(xcn,spgrp);
  }

  /* convert flat to Xcn */

  if (mvld(xcn)) {
    m=make_node(OBJ_MOL);
    if (mvld(m)) {
      set_node_name(m,"A");
      for (r=node->fst;mvld(r);r=rn) {
	rn=r->nxt;
	if (!is_xcn(r)) {
	  unlink_node(r);
	  r->up=m;
	  link_node(r);
	}
      }
      m->up=node;
      link_node(m);
    }
  }

  /* do plausibility checks on chs of suspicious atoms */

  ForAtoms(a,node) {
    if (mvld(a->atp)&&strlen(a->atp->chs)==2&&(a->flg&(1<<0))) {
      switch (a->atp->chs[0]) {
      case 'H':
	r=a->up;
	D=1000000;
	ForAtoms(b,r) {
	  if (!(b->flg&(1<<0))) {
	    if (a!=b) {
	      d=cdist(a->x,b->x)-b->atp->rcov;
	      if (d<D) D=d;
	    }
	  }
	}
	if (D<0.5) {
	  def=guess_atom_type("H");
	  if (def) set_atom_type(a,def);
	}
	break;
      case 'C':
	k=0;
	r=a->up;
	ForAtoms(b,r) {
	  if (!(b->flg&(1<<0))) {
	    if (a!=b) {
	      d=cdist(a->x,b->x)-b->atp->rcov;
	      if (d<1.65) k++;
	    }
	  }
	}
	if (k>1) {
	  def=guess_atom_type("C"); 
	  if (def) set_atom_type(a,def);
	}
	break;
      case 'N':
	k=0;
	r=a->up;
	ForAtoms(b,r) {
	  if (!(b->flg&(1<<0))) {
	    if (a!=b) {
	      d=cdist(a->x,b->x)-b->atp->rcov;
	      if (d<1.55) k++;
	    }
	  }
	}
	if (k>1) {
	  def=guess_atom_type("N"); 
	  if (def) set_atom_type(a,def);
	}
	break;
      case 'B':
	k=0;
	r=a->up;
	ForAtoms(b,r) {
	  if (!(b->flg&(1<<0))) {
	    if (a!=b) {
	      d=cdist(a->x,b->x)-b->atp->rcov;
	      if (d<1.55) k++;
	    }
	  }
	}
	if (k>1) {
	  def=guess_atom_type("B"); 
	  if (def) set_atom_type(a,def);
	}
	break;
      }
    }
  }
  ForAtoms(a,node) a->flg&=~(1<<0);

  /* Add info from residue library */
  
  mnext=(Atmmatch *)NULL;
  r=(Node *)NULL;
  cthis=(Node *)NULL;
  rthis=rfirst_type(node,OBJ_MOL);
  if (rthis) {
    if (((Mol *)rthis)->moltype==MOL_RESIDUE) {
      cthis=rthis->up;
      r=find_residue_name((Node *)reslib,rthis->name);
    }
  }
  mthis=(r ? match_residue_atoms(r,rthis) : (Atmmatch *)NULL);
  
  do { /* atomtypes, connectivity */
    if (mthis) {
      for (k=0;k<mthis->count;k++) {
	t=mthis->a[k]; a=mthis->b[k];
	if (a) {
	  if (mvld(t)) {
	    set_atom_type(a,t->atp);
	  }
	  for (i=0;i<t->nbnd;i++) {
	    bnd=t->bnd[i]; 
	    a=mthis->b[bnd->f->seqnr]; 
	    b=mthis->b[bnd->t->seqnr];
	    nb=add_bond(a,b);
	    set_bt(nb,bnd->bt);
	  }
	}
      }
    }
    
    /* inter residue links */
    
    cnext=(Node *)NULL;
    rn=(Node *)NULL;
    rnext=rnext_type(node,rthis,OBJ_MOL);
    if (rnext) {
      if (((Mol *)rnext)->moltype==MOL_RESIDUE) {
	cnext=rnext->up;
	rn=find_residue_name((Node *)reslib,rnext->name);
      }
    }
    mnext=(rn ? match_residue_atoms(rn,rnext) : (Atmmatch *)NULL);
    
    if (mthis && mnext && cthis==cnext) {
      forLinks(L,r) {
	if (!find_link_name(rn,L->name)) continue;
	forLinks(L2,reslib) {
	  if (streq(L->name,L2->name)) {
	    strcpy(buff,L2->from);
	    if (strchr(buff,'/')) {
	      *strchr(buff,'/')='\0';
	      if (strcmp(r->name,buff)) continue;
	      strcpy(buff,buff+strlen(buff)+1);
	    }
	    for (ia=0;ia<mthis->count;ia++) {
	      if (streq(mthis->a[ia]->name,buff)) break;
	    }
	    if (ia>=mthis->count) break;
	    l1=mthis->b[ia]; if (!l1) break;
	    strcpy(buff,L2->to);
	    if (strchr(buff,'/')) {
	      *strchr(buff,'/')='\0';
	      if (strcmp(rn->name,buff)) continue;
	      strcpy(buff,buff+strlen(buff)+1);
	    }
	    for (ib=0;ib<mnext->count;ib++) {
	      if (streq(mnext->a[ib]->name,buff)) break;
	    }
	    if (ib>=mnext->count) break;
	    l2=mnext->b[ib]; if (!l2) break;
	    for (d=0.0,j=0;j<3;j++) d+=(l1->x[j]-l2->x[j])*(l1->x[j]-l2->x[j]);
	    d=sqrt(d);
	    if (d>=L2->dmin && d<=L2->dmax) {
	      bnd=add_bond(l1,l2);
	      set_bt(bnd,L2->bt);
	    }
	    break;
	  }
	}
      }
    }
    del_atmmatch(mthis);
    r=rn;
    rthis=rnext;
    mthis=mnext;
    cthis=cnext;
  } while(rthis);
  del_atmmatch(mnext);
  
  /* Generate translation table seq# --> *atom : */
  
  tab=(Atom **)malloc((maxsernr+1)*sizeof(Atom *));
  if (!tab) Return(3);
  for (k=0;k<=maxsernr;k++) tab[k]=(Atom *)NULL;
  nalt=0;
  ForAtoms(a,node) {
    if (a->seqnr > 0 && a->seqnr <= maxsernr) tab[a->seqnr]=a;
    if (a->nxyz>1) nalt++;
  }
  
  FBC.chain=(Bond *)NULL;
  while(recin) {
    if (key_is("CONECT")) {
      l=strlen(rec);
      strfld(sernr,rec,7,11);ia=str2i(sernr);
      if (ia > 0 && ia <= maxsernr && tab[ia]) {
	a=tab[ia];
	for (k=0;k<4;k++) {
	  if (l>=fc[k]+3) {
	    strfld(sernr,rec,fc[k],fc[k]+4);ib=str2i(sernr);
	    if (ib > 0 && ib <= maxsernr && tab[ib] ) {
	      b=tab[ib];
	      if (!find_bond(a,b)) {
		bnd=add_bond(a,b);
		if (bnd) {
		  bnd->chain=FBC.chain;
		  FBC.chain=bnd;
		}else{
		  err_set(1,"Warning: CONECT %d %d failed.",ia,ib);
		  err_set(1,"%s",rec);
		}
	      }
	    }
	  }
	}
      }
    }
    recin=UCpgets(rec,RECSZ,in);
  }

  /* fix bond types of bonds made by CONECT, clear FBC chain */

  set_bt_automatic(FBC.chain);
  for (bnd=FBC.chain;bnd;bnd=FBC.chain) {
    FBC.chain=bnd->chain;
    bnd->chain=(Bond *)NULL;
  }

  /* check if CRYST1 is consistent with SCALE */
  
  if (mvld(xcn)) {
    err=check_fta_matrix(xcn->fta,xcn->cl,xcn->ca);
    if (err>0.05) err_set(0,"Warning: CRYST1/SCALE inconsistent, error= %0.3f A.",err);
  }
    
  if (nalt>0) err_set(0,"Warning: %d atoms with multiple positions.",nalt);

  if (own_p) UCpclose(in); 
  if (mvld(tab)) free(tab);
  if (mvld(spgrp)) free(spgrp);
  return(0);
}
/*-------------------- parseNameField --------------------*/

#define NDP (1<<0)
#define NDS (1<<1)
#define AMI (1<<2)
#define NUC (1<<3)
#define HET (1<<4)
#define OTHERS 0
typedef struct {
  char *name;
  int type;
} residue_t;

static int parseNameField(char *name,char *chs,char *resnam,int ftype)
{
  /* Note: this needs to be reviewed, some of the rules are obsolete for
     post-remediation files...

  */

  int susp=0,n,type;
  char input[5];
  residue_t rtype[] = {
    {"GPC",HET},{"NAD",HET},{"NDP",HET},         /* pre-remediation: +NDP */
    {"AGF",NDS}, {"COT",NDS}, {"FVF",NDS},
    {"ACE",AMI}, {"ALA",AMI}, {"ARG",AMI}, {"ASN",AMI}, {"ASP",AMI}, 
    {"ASX",AMI}, {"CYS",AMI}, {"FOR",AMI}, {"GLN",AMI}, {"GLU",AMI},
    {"GLX",AMI}, {"GLY",AMI}, {"HIS",AMI}, {"HYP",AMI}, {"ILE",AMI},
    {"LEU",AMI}, {"LYS",AMI}, {"MET",AMI}, {"PHE",AMI}, {"PRO",AMI},
    {"PCA",AMI}, {"SER",AMI}, {"THR",AMI}, {"TRP",AMI}, {"TYR",AMI}, 
    {"UNK",AMI}, {"VAL",AMI},
    {"  A",NUC}, {"  C",NUC}, {"  G",NUC}, {"  T",NUC}, {"  U",NUC},
    {" +U",NUC}, {" YG",NUC}, {"1MA",NUC}, {"1MG",NUC}, {"2MG",NUC}, 
    {"5MC",NUC}, {"5MU",NUC}, {"7MG",NUC}, {"H2U",NUC}, {"M2G",NUC},
    {"OMC",NUC}, {"OMG",NUC}, {"PSU",NUC},
    {"101",HET}, {"12A",HET}, {"1AR",HET}, {"1GL",HET}, {"2AS",HET},
    {"2GL",HET}, {"3AA",HET}, {"3AT",HET}, {"3DR",HET}, {"3PO",HET}, 
    {"6HA",HET}, {"6HC",HET}, {"6HG",HET}, {"6HT",HET}, {"A26",HET},
    {"AA6",HET}, {"ABD",HET}, {"AC1",HET}, {"ACO",HET}, {"AIR",HET},
    {"AMU",HET}, {"AMX",HET}, {"AP5",HET}, {"AMG",HET}, {"APU",HET},
    {"B9A",HET}, {"BCA",HET}, {"BNA",HET}, {"CAA",HET}, {"CBS",HET}, 
    {"CGS",HET}, {"CMC",HET}, {"CND",HET}, {"CO8",HET}, {"COA",HET},
    {"COF",HET}, {"COS",HET}, {"DCA",HET}, {"DGD",HET}, {"FAB",HET}, 
    {"FAD",HET}, {"FAG",HET}, {"FAM",HET}, {"FDA",HET}, {"IB2",HET}, 
    {"NAH",HET}, {"NAI",HET}, {"NAL",HET}, {"NAP",HET}, {"NBD",HET}, 
    {"PAD",HET}, {"SAD",HET}, {"SAE",HET}, {"T5A",HET}, {"TRE",HET}, 
    {"UP5",HET}, {"ZID",HET}, {"BU1",HET},
    {(char *)NULL,OTHERS} /* end-of-array tag */
  };

  /* parse name read from PDB record and determine chemical symbol */
  /* returns 'susp' (1 if suspicious assignment of chs, else 0)    */
  /* type is the PDB filetype from which record was read */
  /* Implements ideas from R.Sayle's "PDB Cruft to Content HTML document" */
  

  strcpy(input,name);
  strcpy(chs,"");

  for (n=0;rtype[n].name;n++) if (streq(resnam,rtype[n].name)) break;
  type=rtype[n].type;
  
  /* R. Sayle's rules */

  if (streq(name," UNK")) {                    /* 3a */
    strcpy(chs,"Du");
  }else if (name[0]==' '&&                     /* 3b */
	strchr("ABCDEFGHIJKLMNOPQRSTUVWXYZ",name[1])&&
	strchr("abcdefghijklmnopqrstuvwxyz",name[2])) {
    strncpy(chs,name+1,2);
    chs[2]='\0';
  }else{
    if ((type&NDP)&&name[0]==' ') {            /* 3c */
      if (strchr("HCNOPS",name[2])) {
	chs[0]=name[2]; 
	chs[1]='\0';
      }else{
	chs[0]=name[1]; 
	chs[1]='\0';
      }
    }else if (name[0]==' ') {                  /* 3d */
      chs[0]=name[1];
      chs[1]='\0';
      if (ptab_n(chs)<0) {
	if (strchr("HCNOPS",name[2])) chs[0]=name[2]; 
      }
    }else if (strchr("0123456789",name[0])) {  /* 3e */
      chs[0]=name[1];
      chs[1]='\0';
    }else if (name[0]=='H') {                  /* 3f */
      if (type&(AMI|NUC|HET)) {
	strcpy(chs,"H");
      }else{
	strncpy(chs,name,2);
	chs[2]='\0'; 
	chs[1]=tolower(chs[1]);                /* AWI, 19-Feb-2007 */
	if (ptab_n(chs)<0) chs[1]='\0';
      }
    }else if (strchr("'*\"",name[0])) {        /* 3g */
      chs[0]=name[1];
      chs[1]='\0';
    }else if (type&NDS) {                      /* 3h */
      chs[0]=name[0];
      chs[1]='\0'; 
    }else if (type&HET) {                      /* 3i */
      chs[0]=name[1];
      chs[1]='\0';
    }else{                                     /* 3j */
      strncpy(chs,name,2);
      chs[2]='\0';
      chs[1]=tolower(chs[1]);
      if (ptab_n(chs)<0) {
	chs[0]=name[1];
	chs[1]='\0';
      }
      if (ptab_n(chs)<0) {                     /* AWI, 8-Jul-2004 */
	chs[0]=name[0];
      }
    }
  }

  if (strceq(chs,"Nd")&&(type&HET)) {          /* 3k */
    strcpy(chs,"N");
  }

  if (streq(name,"NSE1")&&                     /* 3l */
      ( streq(resnam,"SAD")||streq(resnam,"SAE") )) {
    strcpy(chs,"Se");
  }

  /* fiddle with chemical symbol... */
  chs[1]=tolower(chs[1]);
  if (!isalpha(chs[1])) chs[1]='\0';
  if (strlen(chs)==2&&ptab_n(chs)<0) chs[1]='\0';

  /* what do we do if chs is not a known symbol? */

  /* need a better definition of 'suspicious' */
  susp = strlen(input)==4&&
    strchr("ABCDEFGHIJKLMNOPQRSTUVWXYZ",input[0])&&
    strchr("ABCDEFGHIJKLMNOPQRSTUVWXYZ",input[1]);

  return(susp);
}

static void fixupName(char *name)
{
  char c;

  /* remove blanks from atomname, and rotate name if name is [0-9*"'].* */
  strsqz(name,name);
  if (strchr("0123456789*'\"",name[0])) {
    c=name[0];
    strcpy(name,name+1);
    name[strlen(name)]=c;
  }
}
