/*  read SYBYL MOL file */

#include "object.h"
#include "swdef.h"
#include "mystdlib.h"
#include "fileutil.h"
#include "strutil.h"
#include "transpor.h"
#include "errhand.h"
#include <ctype.h>

#define MXRS 512
#define MXTS 80
#define YES  1
#define NO   0

#define COMMENT(x) ((x)[0]=='#')
#define is_WNP(x) (strneq(x,"#<Wit!P>",8))
#define WNP_is(x) (is_WNP(rec) && strneq(x,rec+8,strlen(x)))
#define is_RTI(x) (strneq(x,"@<TRIPOS>",9))
#define RTI_is(x) (is_RTI(rec) && strneq(x,rec+9,strlen(x)))
#define breakout(s,x) {status=(s);err_set(s,"read_syb: %s",x);break;}
#define feed(x,y) {do if (!UCpgets(x,MXRS,y)) *x='\0';while(COMMENT(x) && !UCpeof(y));}
#define forcefeed(x,y) {do if (!UCpgets(x,MXRS,y)) *x='\0';while(COMMENT(x) && !UCpeof(y));\
                   if (UCpeof(y)) status=102;}
#define INT(x) ( str2i(((_c_nv=x) ? _c_nv : "0" )))
#define FLT(x) ( str2f(((_c_nv=x) ? _c_nv : "0" )))
#define Return(x,y) {err_set(x,"read_syb: %s",y);if (own_p)UCpclose(inp);return(x);}

static char *_c_nv;

/*----------------------------------------------------------------------*/

extern Node *LibRoot;
extern int graphix;

/*----------------------------------------------------------------------*/

static int blank(char *line)
{
  char *s;
  for (s=line;*s;s++) if (!isspace(*s)) break;
  if (*s) return(0);
  else return(1);
}

static char *next(UCpipe *inp,Parse *p)
{
  char *n;

  if (p->buf[p->pos]=='\\') {
    p->buf[0]='\0'; p->pos=0;
    if (!UCpgets(p->buf,MXRS,inp)) p->buf[0]='\0';
  }

  n=token(p);
  if (n) {
    if (streq(n,"****")) n=(char *)NULL;
  }
  return(n);
}
/*----------------------------------------------------------------------*/

int read_syb(UCpipe *inp,char *file,Node *node,int ft)
{
  char  ffmnem[MXRS],rec[MXRS],tok[MXTS],buf[MXRS],*chain,*setname,*type,*c,*cc;
  int B,i,status,ssnr,nat,natt,ia,ib,nsubt,nsub,nmols,nmemb,statst,nsets,atomset,own_p;
  int ivalue;
  Atom *a,**aptr;
  Bond *bnd;
  Atomdef *A,*default_type;
  Atomset *s;
  Parse p;
  Node *ResLib,**sptr,*chn,*mol,*o;
  Mol *cm;

  own_p=(inp ? FALSE : TRUE);
  if (own_p) {
    inp=UCpopen(extfil(rec,file,(ft==FT_MOL2 ? ".mol2" : ".mol") ,NO));
  }
  if (!inp) return(1);

  /* read first record to see if file format is old */

  if (!UCpgets(rec,MXRS,inp)) return(2);
  if (rec[0]!='@' && rec[0]!='#' && strneq("MOL",rec+5,3)) {
    status=read_mol(inp,rec,node);
    if (own_p) UCpclose(inp);
    return(status);
  }

  /* not old, try new format ... */

  /* Note: assume that MOLECULE < ATOM , BOND , SUBSTRUCTURE  */
  
  ResLib=find_name(LibRoot,"ResLib",OBJ_LIB);
  if (!mvld(ResLib)) {
    Return(-1,"could not open default library");
  }
  default_type=find_atomdef_name(ResLib,"unk");
  if (!mvld(default_type)) {
    default_type=(Atomdef *)add_node(ResLib,"unk",OBJ_ATOMDEF);
  }

  status=0; 
  nat=0; nsub=0;
  natt=0; nsubt=0;
  aptr=(Atom **)NULL; 
  sptr=(Node **)NULL;
  mol=(Node *)NULL;
  nmols=0;

  while(!status && !UCpeof(inp)) {

    if (RTI_is("MOLECULE")) {

      if (mvld(aptr)) {
	for (i=1;i<=natt;i++) {
	  if (mvld(aptr[i])) {
	    if (!mvld(aptr[i]->up)) aptr[i]->up=mol;
	    if (mvld(aptr[i]->up)) link_node((Node *)aptr[i]);
	    else del_node((Node *)aptr[i]);
	  }
	}
	free(aptr);
	aptr=(Atom **)NULL;
      }
      
      if (mvld(sptr)) {
	for (i=1;i<=nsubt;i++) {
	  if (mvld(sptr[i])) {
	    if (!mvld(sptr[i]->up)) del_node(sptr[i]);
	  }
	}
	free(sptr);
	sptr=(Node **)NULL;
      }

      p.sep=" "; p.tok=tok; p.mts=sizeof(tok); p.buf=rec;
      forcefeed(rec,inp); p.pos=0;
      for (c=rec;isspace(*c);c++) ; /* skip leading whitespace */
      for (cc=rec;*c;c++) {            /* copy, replace whitespace with _ ... */
        if (isspace(*c)) {
	  while (isspace(*(c+1))) c++;
	  if (*(c+1)) *cc++ = '_';
	}else *cc++ = *c;
      }
      *cc='\0';

      mol=add_node(node,strfld(rec,rec,1,strlen(rec)),OBJ_MOL);
      if (mvld(mol)) if (mvld(mol->name)) for (c=mol->name;*c;c++) *c=(*c==' '?'_':*c);
      nmols++;
      nat=0; nsub=0;
      natt=0; nsubt=0;
      prtGraphics("%s\n",rec);
      forcefeed(rec,inp); p.pos=0;

      if (!status) {
	natt=INT(next(inp,&p));
	INT(next(inp,&p));
	nsubt=INT(next(inp,&p));
      }

      if (natt>0) {
	aptr=(Atom **)malloc((natt+1)*sizeof(Atom *));
	if (!aptr) breakout(104,"memory allocation failed");
      }else{
	aptr=(Atom **)NULL;
      }
      if (aptr) {
	for (i=0;i<=natt;i++) aptr[i]=(Atom *)NULL;
	for (i=1;i<=natt;i++) {
	  aptr[i]=(Atom *)make_node(OBJ_ATOM);
	  if (!aptr[i]) breakout(106,"failed to create atom");
	}
      }
      
      if (nsubt>=0) {
	sptr=(Node **)malloc((nsubt+1)*sizeof(Mol *));
	if (!sptr) breakout(105,"memory allocation failed");
      }else{
	sptr=(Node **)NULL;
      }
      if (sptr) {
	for (i=0;i<=nsubt;i++) sptr[i]=(Node *)NULL;
	for (i=1;i<=nsubt;i++) {
	  sptr[i]=(Node *)make_node(OBJ_MOL);
	  if (!sptr[i]) breakout(107,"failed to create residue");
	  ((Mol *)sptr[i])->moltype=MOL_SUBSTRUCT;
	}
      }
      feed(rec,inp); p.pos=0;

    }else if (RTI_is("ATOM")) {
      if (natt<=0) breakout(115,"extra ATOM records encountered.");
      p.sep=" "; p.tok=tok; p.mts=sizeof(tok); p.buf=rec;
      while(!status && UCpgets(rec,MXRS,inp)) {
	if (is_RTI(rec)||is_WNP(rec)) break;
	if (COMMENT(rec)) continue;
	if (blank(rec)) continue;
	p.pos=0;
	a=aptr[++nat]; if (nat>natt) {
	  breakout(118,"extra ATOM records encountered.");
	}
	if (!a) breakout(120,"invalid atom pointer");
	INT(next(inp,&p));  /* old seqnr is just comment */
	set_node_name((Node *)a,next(inp,&p));
	for (i=0;i<3;i++)  a->x[i]=str2f(next(inp,&p));
	a->nxyz=1;
	Strcpy(ffmnem,next(inp,&p));
	A=find_atomdef_name(ResLib,ffmnem);
	if (!mvld(A)) {
	  A=(Atomdef *)copy_node((Node *)default_type);
	  if (mvld(A)) {
	    A->up=ResLib;
	    link_node((Node *)A);
	    set_node_name((Node *)A,ffmnem);
	  }
	}
	set_atom_type(a,A);
	if (mvld(sptr)) {
	  ssnr=INT(next(inp,&p));
	  if (ssnr>nsubt || ssnr <0) ssnr=0;
	  a->up=sptr[ssnr];
	}else{
	  next(inp,&p);
	}
	if (mvld(a->up)&&!mvld(a->up->name)) set_node_name(a->up,next(inp,&p));
	else next(inp,&p);  /* skip substructure name... */
	a->q=FLT(next(inp,&p));
	a->seqnr=nat;
      }

    }else if (RTI_is("UNITY_ATOM_ATTR")) {
      p.sep=" "; p.tok=tok; p.mts=sizeof(tok); p.buf=rec;
      if (!aptr) breakout(150,"UNITY_ATOM_ATTRs, but no atoms");
      while(!status && UCpgets(rec,MXRS,inp)) {
	if (is_RTI(rec)||is_WNP(rec)) break;
	if (COMMENT(rec)) continue;
	if (blank(rec)) continue;
	p.pos=0;
	ia=str2i(next(inp,&p)); ib=str2i(next(inp,&p));
	if (ia<1||ia>natt||!is_atom(aptr[ia]))
	  breakout(151,"atom number out of range in UNITY_ATOM_ATTR record");
	while(ib>0 && !status && UCpgets(rec,MXRS,inp)) {
	  if (is_RTI(rec)||is_WNP(rec)) breakout(152,"invalid UNITY_ATOM_ATTR section");
	  if (COMMENT(rec)||blank(rec)) continue;
	  ib--;
	  p.pos=0;
	  if (strceq("charge",next(inp,&p))) {
	    aptr[ia]->chrg=str2i(next(inp,&p));
	  }
	}
      }
      
    }else if (RTI_is("BOND")) {
      p.sep=" "; p.tok=tok; p.mts=sizeof(tok); p.buf=rec;
      if (!aptr) breakout(200,"BONDs but no atoms");
      while(!status && UCpgets(rec,MXRS,inp)) {
	if (is_RTI(rec)||is_WNP(rec)) break;
	if (COMMENT(rec)) continue;
	if (blank(rec)) continue;
	p.pos=0;
	next(inp,&p); ia=str2i(next(inp,&p)); ib=str2i(next(inp,&p));
	if (ia<1 || ib<1 || ia>natt || ib>natt) {
	  breakout(210,"BOND: atom numbers out of range");
	}else{
	  bnd=add_bond(aptr[ia],aptr[ib]);
	  if (bnd) {
	    B=BT_number(next(inp,&p));
	    if (B>=0) set_bt(bnd,B);
	  }else{
	    breakout(220,"failed to add bond");
	  }
	}
      }

    }else if (RTI_is("SUBSTRUCTURE")) {
      p.sep=" "; p.tok=tok; p.mts=sizeof(tok); p.buf=rec;
      if (!sptr) breakout(300,"extra SUBSTRUCTURE");
      while(!status && UCpgets(rec,MXRS,inp)) {
	if (is_RTI(rec)||is_WNP(rec)) break;
	if (COMMENT(rec)) continue;
	if (blank(rec)) continue;
	p.pos=0;
	nsub++;
	if (nsub>nsubt) breakout(305,"extra SUBSTRUCTURES");
	next(inp,&p); /* just comment */
	set_node_name(sptr[nsub],next(inp,&p));
	if (!sptr[nsub]->name||streq(sptr[nsub]->name,"****")) {
	  sprintf(tok,"SBST_%d",nsub);
	  set_node_name(sptr[nsub],tok);
	}
	next(inp,&p);next(inp,&p);next(inp,&p); /* skip three */
	chain=next(inp,&p);
	if (!chain) {
	  if (!sptr[nsub]->up) {
	    sptr[nsub]->up=mol;
	    link_node(sptr[nsub]);
	  }
	}else{
	  forMols(cm,mol) if (cm->moltype==MOL_CHAIN&&streq(chain,cm->name)) break;
	  if (!cm) {
	    chn=add_node(mol,chain,OBJ_MOL);
	    ((Mol *)chn)->moltype=MOL_CHAIN;
	  }else chn=(Node *)cm;
	  if (chn) {
	    if (!sptr[nsub]->up) {
	      sptr[nsub]->up=chn;
	      link_node(sptr[nsub]);
	    }
	  }else{
	    breakout(320,"failed to add chain");
	  }
	}
	type=next(inp,&p);               /* modify ALA13 to ALA_13 if type is ALA */
	if (type&&!strneq(type,"****",4)) {
	  if (strneq(sptr[nsub]->name,type,strlen(type))) {
	    if (sptr[nsub]->name[strlen(type)]!='_') {
	      sprintf(tok,"%s_%s",type,sptr[nsub]->name+strlen(type));
	      set_node_name(sptr[nsub],tok);
	    }
	  }
	}
      }

    }else if (RTI_is("SET")) {
      p.sep=" "; p.tok=tok; p.mts=sizeof(tok); p.buf=rec;
      if (!aptr) breakout(400,"SETs, but no atoms");
      nsets=0;
      while(!status && UCpgets(rec,MXRS,inp)) {
	if (is_RTI(rec)||is_WNP(rec)) break;
	if (COMMENT(rec)) continue;
	if (blank(rec)) continue;
	p.pos=0;
	setname=Strdup(next(inp,&p));
	statst=streq(next(inp,&p),"STATIC");
	atomset=streq(next(inp,&p),"ATOMS");
	if (statst&&atomset) {
	  nsets++;
	  forcefeed(rec,inp); p.pos=0;
	  nmemb=str2i(next(inp,&p));
	  sprintf(buf,"DfltSetName%d",nsets);
	  s=add_atomset((Mol *)mol,-1,(setname?setname:buf));
	  if (is_atomset(s)) {
	    while (next(inp,&p))	{
	      i=str2i(p.tok);
	      if (i<=natt&&i>=1) {
		if (is_atom(aptr[i])) add_to_atomset(aptr[i],s);
	      }
	      nmemb--;          /* some set definitions contain deliberate garbage... */
	    }
	    if (nmemb!=0) {
	      sprintf(buf,"wrong number of set members: %s",s->name);
	      breakout(401,buf);
	    }
	  }else breakout(402,"failed to add atomset");
	}else{
	  forcefeed(rec,inp); p.pos=0;
	  while (next(inp,&p)) {};
	}
	if (mvld(setname)) free(setname);
      }

    }else if (WNP_is("CHARGES")) {    /* Wit!P extension, implemented as MOL2 comments */
      if (!aptr) breakout(500,"WNP CHARGES, but no atoms");
      while(!status && UCpgets(rec,MXRS,inp)) {
	if (is_RTI(rec)||is_WNP(rec)) break;
	if (blank(rec)) break;
	if (!COMMENT(rec)) breakout(501,"WNP CHARGES, all records must start with '#'");
	if (COMMENT(rec+1)) continue;
	p.pos=1; p.tok=tok; p.mts=sizeof(tok); p.buf=rec; p.sep=":";
	while (token(&p)) {
	  ivalue=INT(p.tok);
	  p.sep="-,;";
	  for (ia=0;token(&p);) {
	    ib=INT(p.tok);
	    if (ib<1||ib>natt) breakout(501,"WNP CHARGES, atom number out of range");
	    ia=(ia==0?ib:ia);
	    for (i=ia;i<=ib;i++) aptr[i]->chrg=ivalue;
	    ia=(p.term=='-'?ib:0);
	    if (p.term==';') break;
	  }
	  p.sep=":";
	}
      }

    }else{
      if (!UCpgets(rec,MXRS,inp)) *rec='\0';
      p.pos=0;
    }
  }

  if (mvld(aptr)) {
    for (i=1;i<=natt;i++) {
      if (mvld(aptr[i])) {
	if (!mvld(aptr[i]->up)) aptr[i]->up=mol;
	if (mvld(aptr[i]->up)) link_node((Node *)aptr[i]);
	else del_node((Node *)aptr[i]);
      }
    }
    free(aptr);
    aptr=(Atom **)NULL;
  }

  if (mvld(sptr)) {
    for (i=1;i<=nsubt;i++) {
      if (mvld(sptr[i])) {
	if (!mvld(sptr[i]->up)) { /* was: del_node(sptr[i]); 26.7.2011 */
	  sptr[i]->up=mol;
	  if (mvld(sptr[i]->up)) link_node((Node *)sptr[i]);
	  else del_node((Node *)sptr[i]);
	}
      }
    }
    free(sptr);
    sptr=(Node **)NULL;
  }

  ForObjs(mol,node,OBJ_MOL) if (strneq(mol->name,"****",4)) set_node_name(mol,"NoName");

  if (nmols==1) {                   /* a single mol file */
    mol=node->fst;
    if (is_mol(mol)) {
      unlink_node(mol);
      while (mvld(mol->fst)) {
	o=mol->fst;
	unlink_node(o);
	o->up=node;
	link_node(o);
      }
      set_node_name(node,mol->name);
      del_node(mol);
    }
  }

  if (own_p) UCpclose(inp);
  return(status);
}
