#include <stdio.h>
#include "mystdlib.h"
#include "object.h"
#include "swdef.h"
#include "strutil.h"
#include "fileutil.h"
#include "errhand.h"
#include "transpor.h"

#define NO 0

static int foreignByteSex(float *dx,int *n);

/*********************************************************************/
Grid *read_grid(char *file)
{
  UCpipe *in;
  int i,size,swap;
  Grid *g;
  char rec[4096];
  int n[3];
  float dx[3],xmin[3],cl[3],ca[3];
  float *iv;
  
  g=(Grid *)NULL;
  in=UCpopen(extfil(rec,file,".cnt",NO));
  if (!in) {
    err_set(1,"read_grid: could not open %s\n",extfil(rec,file,".cnt",NO));
    return(g);
  }
  
  g=emptyGrid();
  if (mvld(g)) {
    g->name=Strdup(file);
    if (fread(xmin,sizeof(float),3,in->fd)==3
	&&fread(dx,sizeof(float),3,in->fd)==3
	&&fread(n,sizeof(int),3,in->fd)==3) {
      swap=foreignByteSex(dx,n);
      for (i=0;i<3;i++) {
	g->xmin[i]=OWN_f(swap,xmin[i]); 
	g->dx[i]=OWN_f(swap,dx[i]);
	g->n[i]=OWN_i(swap,n[i]);
	g->xmax[i]=g->xmin[i]+(g->n[i]-1)*g->dx[i];
      }
      for (size=1,i=0;size>0&&i<3;i++) size*=g->n[i];
      if (size>0) {
	g->val=(float *)malloc(size*sizeof(float));
	if (mvld(g->val)) {
	  if (fread(g->val,sizeof(float),size,in->fd)!=size) {
	    err_set(1,"contour file is short");
	    free(g->val); g->val=(float *)NULL;
	  }else{
	    for (iv=g->val,i=0;i<size;i++) g->val[i]=OWN_f(swap,*iv++);
	    if (fread(cl,sizeof(float),3,in->fd)+fread(ca,sizeof(float),3,in->fd)!=6) {
	      for (i=0;i<3;i++) {
		g->cl[i]=1.0;
		g->ca[i]=90.0;
	      }
	    }else{
	      for (i=0;i<3;i++) {
		g->cl[i]=OWN_f(swap,cl[i]);
		g->ca[i]=OWN_f(swap,ca[i]);
	      }
	    }
	  }
	}else{
	  err_set(1,"failed to allocate memory for grid");
	}
      }else{
	err_set(1,"bad grid specification found in file");
      }
    }else{
      err_set(1,"could not read grid header");
    }
    if (!mvld(g->val)) {
      if (mvld(g->name)) free(g->name);
      free(g); g=(Grid *)NULL;
    }
  }else{
    err_set(1,"could not allocate grid structure");
  }

  UCpclose(in);
  return(g);
}
/*-------------------- foreignByteSex --------------------*/

static int foreignByteSex(float *dx,int *n)
{
  /*return true iff dx,n indicate foreign byte sex */

  int i,swap=0;
  for (i=0;i<3;i++) swap|=dx[i]<0||n[i]<0||n[i]>(2<<16);
  return(swap);
}


