#define _GNU_SOURCE

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "object.h"
#include "mystdlib.h"
#include "topsym.h"

#define MXNB 20
#define FLG1 (1<<0)
#define neighbour(i,a) (a->bnd[i]->f == a ? a->bnd[i]->t : a->bnd[i]->f)

typedef struct iTP_t {
  int i;
  char *str;
} iTP_t;

static int compare(const void *A, const void *B)
{
  int r;
  char *a,*b;

  a=((iTP_t *)A)->str;
  b=((iTP_t *)B)->str;

  r=strcmp(a,b);
  return r;
}

static char *types2str(Atom *a,int *tp,int flag)
{
  int i,j,k,ntp[MXNB];
  char buff[2048];
  Atom *b;

  for (i=0,k=0;i<a->nbnd;i++) {
    b=neighbour(i,a);
    if (b->flg&flag) {
      ntp[k]=tp[b->seqnr];
      for (j=k;j>0;j--) {
	if (ntp[j-1]>ntp[j]) {
	  ntp[j]=ntp[j-1];
	  ntp[j-1]=tp[b->seqnr];
	}
      }
      k++;
    }
  }
  sprintf(buff,"%d",tp[a->seqnr]);
  for (i=0;i<k;i++) sprintf(buff+strlen(buff)," %d",ntp[i]);
  return (strdup(buff));
}

static int str2types(int na,char **str,int *tp)
{
  int i,nxt=0;
  iTP_t *idx;
  char *old="";

  idx=malloc(na*sizeof(iTP_t));
  if (idx) {
    for (i=0;i<na;i++) {
      idx[i].i=i;
      idx[i].str=str[i];
    }
    qsort(idx,na,sizeof(iTP_t),compare);
    for (i=0;i<na;i++) {
      if (strcmp(old,idx[i].str)) {
	old=idx[i].str;
	nxt+=1;
      }
      tp[idx[i].i]=nxt;
    }
    free(idx);
  }
  return nxt;
}

int *uniqueTypes(Atom **A, int na,int flag)
{
  int i,nt,old,*tp=NULL;
  char **str=NULL;

  tp=malloc(na*sizeof(int));
  str=malloc(na*sizeof(char *));

  if (mvld(tp) && mvld(str)) {
    for (i=0;i<na;i++) {
      A[i]->flg|=flag;
      A[i]->seqnr=i;
      if (mvld(A[i]->atp)) tp[i]=A[i]->atp->z;
      else tp[i]=0;
    }
    for (old=0,nt=1;old<nt;) {
      old=nt;
      for (i=0;i<na;i++) str[i]=types2str(A[i],tp,flag);
      nt=str2types(na,str,tp);
      for (i=0;i<na;i++) free(str[i]);
    }
    for (i=0;i<na;i++) A[i]->flg&=~flag;
  }

  if (mvld(str)) free(str);
  return tp;
}
