#if defined (mingw)
#include <stdlib.h>
#include <string.h>
#include <winsock.h>
#else
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/uio.h>
#endif

#include "utlsock.h"

int open_service(char *service)
{

    int i,port;
    int sock,on;
    char hostname[250];
    char lo[4]={127,0,0,1};    /*   loopback IP address   */
    struct sockaddr_in sock_name;
    struct hostent *hostentptr,hostentstruct;
    struct servent *servadd,serv;

    if (strncmp(service,"port_",5)==0&&strlen(service)>5) {
      port=atoi(service+5);
      serv.s_port=htons(port);
    }else{
      servadd=getservbyname(service,"tcp");
      if (servadd) {
	serv = *servadd;
      }else{
        fprintf(stderr,"SW_SERVER: entry %s not found in /etc/services.\n", service);
	return(0);
      }
    }
    if ((hostentptr=gethostbyaddr(lo,4,AF_INET))==NULL) {     /* try loopback  */
      if (gethostname(hostname,sizeof(hostname))) {
        	fprintf(stderr,"SW_SERVER: gethostname(%s) failed\n", hostname);
		return(0);  /* or hostname , if lo fails */
      }
      if ((hostentptr=gethostbyname(hostname))==NULL) {
        	fprintf(stderr,"SW_SERVER: gethostbyname(%s) failed\n", hostname);
 		return(0);
      }
    }
    hostentstruct = *hostentptr;
    if ((sock=socket(PF_INET,SOCK_STREAM,0)) < 0) {
	fprintf(stderr,"SW_SERVER: failed to create the local domain socket\n");
	return(0);
    }

    on=1;setsockopt(sock,SOL_SOCKET,SO_REUSEADDR,(char *)&on,sizeof(on));
    memset((char *)&sock_name,0,sizeof(sock_name));
    sock_name.sin_family = hostentstruct.h_addrtype;
    sock_name.sin_port = serv.s_port ;
    sock_name.sin_addr = *((struct in_addr *)hostentstruct.h_addr_list[0]);
    sock_name.sin_addr.s_addr = htonl(INADDR_ANY);
    for (i=0;i<8;i++) sock_name.sin_zero[i]='\0';
    if (bind(sock,(struct sockaddr *)&sock_name,sizeof(sock_name))) {
       fprintf(stderr,"SW_SERVER: failed to bind on socket\n");
	return(0);
    }
    if (listen(sock,5)) {
       fprintf(stderr,"SW_SERVER: failed to listen on socket\n");
	return(0);
    }
    return(sock);
}

int open_socket_on_port(int port)
{
    int i;
    int sock,on;
    char hostname[250];
    char lo[4]={127,0,0,1};    /*   loopback IP address   */
    struct sockaddr_in sock_name;
    struct hostent *hostentptr,hostentstruct;

    if ((hostentptr=gethostbyaddr(lo,4,AF_INET))==NULL) {     /* try loopback  */
      if (gethostname(hostname,sizeof(hostname))) return(0);  /* or hostname , if lo fails */
      if ((hostentptr=gethostbyname(hostname))==NULL) return(0);
    }
    hostentstruct = *hostentptr;
    if ((sock=socket(PF_INET,SOCK_STREAM,0)) < 0) return(0);
    on=1;setsockopt(sock,SOL_SOCKET,SO_REUSEADDR,(char *)&on,sizeof(on));
    memset((char *)&sock_name,0,sizeof(sock_name));
    sock_name.sin_family = hostentstruct.h_addrtype;
    sock_name.sin_port = htons(port) ;
    sock_name.sin_addr = *((struct in_addr *)hostentstruct.h_addr_list[0]);
    sock_name.sin_addr.s_addr = htonl(INADDR_ANY);
    for (i=0;i<8;i++) sock_name.sin_zero[i]='\0';
    if (bind(sock,(struct sockaddr *)&sock_name,sizeof(sock_name))) return(0);
    if (listen(sock,5)) return(0);
    return(sock);
}

int accept_client(int sock)
{
    int retval;
    struct sockaddr_in addr;
#if defined(linux) || defined(darwin)
    socklen_t addrlen;
#else
    int addrlen;
#endif

    addrlen=sizeof(addr);
    if ((retval=accept(sock,(struct sockaddr *)&addr,&addrlen)) < 0) {
	return(0);
    }
    return(retval);
}

void close_service(int sock)
{
    shutdown(sock,2);
#ifdef mingw
    closesocket(sock);
#else
    close(sock);
#endif
}

int conn_to_service(char *host,char *service)
{
    int i,port;
    int sock;
    struct sockaddr_in sock_name;
    struct hostent *hostentptr,hostentstruct;
    struct servent *servadd,serv;

    if (strncmp(service,"port_",5)==0&&strlen(service)>5) {
      port=atoi(service+5);
      serv.s_port=htons(port);
    }else{
      servadd=getservbyname(service,"tcp");
      if (servadd) {
	serv = *servadd;
      }else{
	return(0);
      }
    }
    if ((sock=socket(PF_INET,SOCK_STREAM,0)) < 0) return(0);
    if ((hostentptr=gethostbyname(host))==NULL) {
	close(sock);
	return(0);
    }
    hostentstruct = *hostentptr;
    sock_name.sin_family = hostentstruct.h_addrtype;
    sock_name.sin_port = serv.s_port;
    sock_name.sin_addr = *((struct in_addr *)hostentstruct.h_addr);
    for (i=0;i<8;i++) sock_name.sin_zero[i]='\0';
    if (connect(sock,(struct sockaddr *)&sock_name,sizeof(sock_name))) {
	shutdown(sock,2);
	close(sock);
	sock=0;
    }
    return(sock);
}
