#ifndef WNPDEFDEF
#define WNPDEFDEF

#define TRUE 1
#define FALSE 0

/* some limits... */

#define WNP_MAXLINE            512
#define WNP_MAXREC            4096
#define WNP_MAXCOL              32
#define WNP_MAXSCOL              5
#define WNP_MAXCCOL              6
#define WNP_DEFAULT_COLOR        5

/* cursor color names... */

#define WNP_CURSOR_BLACK         0
#define WNP_CURSOR_RED           1
#define WNP_CURSOR_GREEN         2
#define WNP_CURSOR_BLUE          3
#define WNP_CURSOR_YELLOW        4
#define WNP_CURSOR_WHITE         5

#define WNP_MAX_CURSOR           5
#define WNP_CURSOR_NONE          0
#define WNP_CURSOR_DOTBOX        1
#define WNP_CURSOR_dotbox        2
#define WNP_CURSOR_ARROW         3
#define WNP_CURSOR_arrow         4

#define WNP_SOLID_LINE           0
#define WNP_DOTTED_LINE          1

/* Mouse functions ... */

#define WNP_MAX_MOUSE_FUNC      64
#define WNP_DEF_MOUSE_FUNC      22

#define WNP_MOUSE_TRACK          0
#define WNP_MOUSE_PICK           1
#define WNP_MOUSE_XYTRANS        2
#define WNP_MOUSE_ZTRANS         3
#define WNP_MOUSE_XYROT          4
#define WNP_MOUSE_ZROT           5
#define WNP_MOUSE_SCALE          6
#define WNP_MOUSE_VIEWDIST       7
#define WNP_MOUSE_AXROT          8
#define WNP_MOUSE_SLABWIDTH      9
#define WNP_MOUSE_SLABPOS       10
#define WNP_MOUSE_USAP          11
#define WNP_MOUSE_STEREOSEP     12
#define WNP_MOUSE_SETPIVOT      13
#define WNP_MOUSE_SETALTPIVOT   14
#define WNP_MOUSE_SELALT        15
#define WNP_MOUSE_SELMALT       16
#define WNP_MOUSE_LIGHTXY       17
#define WNP_MOUSE_LIGHTZ        18
#define WNP_MOUSE_LIGHTROT      19
#define WNP_MOUSE_LIGHTINT      20
#define WNP_MOUSE_LIGHTATTEN    21  

/* pick modes... */
 
#define WNP_PICK_USA            -1
#define WNP_PICK_OFF             0
#define WNP_PICK_OBJECT          1
#define WNP_PICK_ATOM            2
#define WNP_PICK_USA_ON          3
#define WNP_PICK_XYZ             4
#define WNP_PICK_XYZ_ATOM        5
#define WNP_PICK_USA_OFF         6
#define WNP_PICK_TWOD_TEXT       7
#define WNP_PICK_PIVOT           8
#define WNP_PICK_ALTPIVOT        9
#define WNP_PICK_SELALT         10
#define WNP_PICK_SELMALT        11

#define WNP_PICK_BUFFER_SIZE  1024
#define WNP_MAX_PICK_ATOMS      50
#define WNP_MAX_USA_ATOMS        5  
#define WNP_NORMAL_DRAW          0
#define WNP_PLOT_MODE            1

/* Modifier bits... */

#define WNP_MOD_NONE             0

#define WNP_MOD_RIGHT        (1<<0)
#define WNP_MOD_MIDDLE       (1<<1)
#define WNP_MOD_LEFT         (1<<2)
#define WNP_MOD_CTRL         (1<<3)
#define WNP_MOD_ALT          (1<<4)
#define WNP_MOD_SHIFT        (1<<5)

/* Graphics modes ... */
/* Note: WNP_MODE_BUFFER bits used as offset into drawBuffer[] in glbox.c */
#define WNP_MODE_FRONT       (1<<0)
#define WNP_MODE_BACK        (1<<1)
#define WNP_MODE_BANDF       (WNP_MODE_FRONT|WNP_MODE_BACK)
#define WNP_MODE_LEFT        (1<<2)
#define WNP_MODE_RIGHT       (1<<3)
#define WNP_MODE_QUAD        (WNP_MODE_LEFT|WNP_MODE_RIGHT)
#define WNP_MODE_BUFFER      (WNP_MODE_BANDF|WNP_MODE_QUAD)
#define WNP_MODE_ZBUFF       (1<<4)
#define WNP_MODE_BLEND       (1<<5)
#define WNP_MODE_SMOOTH      (1<<6)
#define WNP_MODE_DITHER      (1<<7)
#define WNP_MODE_RDFRONT     (1<<8)
#define WNP_MODE_RDBACK      (1<<9)
#define WNP_MODE_FOG         (1<<10)

/* oGL box types ... */

#define WNP_GL_UNKNOWN            0
#define WNP_GL_NEWSGI             1
#define WNP_GL_OLDSGI             2
#define WNP_GL_MESAX11            3
#define WNP_GL_MMXSGI             4
#define WNP_GL_GDIGEN             5
#define WNP_GL_SAVAGE4            6
#define WNP_GL_SAVAGEMX           7
#define WNP_GL_GEFORCE            8
#define WNP_GL_RADEON7500         9
#define WNP_GL_BROOKDALE_G       10
#define WNP_GL_NVIDIAQUADRO      11
#define WNP_GL_INTEL945G         12
#define WNP_GL_NV_GALLIUM        13

/* Key classes... */

#define WNP_IGNORE_KEY            0
#define WNP_ARROW_KEY             1
#define WNP_FUNC_KEY              2
#define WNP_ASCII_KEY             3

#define WNP_F1_KEY                1  
#define WNP_F2_KEY                2  
#define WNP_F3_KEY                3  
#define WNP_F4_KEY                4   
#define WNP_F5_KEY                5   
#define WNP_F6_KEY                6   
#define WNP_F7_KEY                7    
#define WNP_F8_KEY                8    
#define WNP_F9_KEY                9    
#define WNP_F10_KEY              10     
#define WNP_F11_KEY              11     
#define WNP_F12_KEY              12   

#define WNP_LEFT_KEY             13 
#define WNP_RIGHT_KEY            14 
#define WNP_UP_KEY               15 
#define WNP_DOWN_KEY             16 

#define WNP_PGUP_KEY             17
#define WNP_PGDOWN_KEY           18

#define WNP_VIEW_PERSPECTIVE      1
#define WNP_VIEW_ORTHO            2

#define WNP_LEFT_VIEW            -1
#define WNP_MIDDLE_VIEW           0
#define WNP_RIGHT_VIEW            1

#define WNP_STEREO_PREVIOUS      -1
#define WNP_STEREO_NO             0
#define WNP_STEREO_RELAXED        1
#define WNP_STEREO_LEFT           2
#define WNP_STEREO_RIGHT          3
#define WNP_STEREO_CROSSED        4
#define WNP_STEREO_CRYSTAL        5
#define WNP_STEREO_QUADBUFF       6

#define WNP_VWP_NONE              0
#define WNP_VWP_FULL              1
#define WNP_VWP_LEFT              2
#define WNP_VWP_RIGHT             3
#define WNP_VWP_TOP               4
#define WNP_VWP_BOTTOM            5

#define WNP_MAX_FONTS           100
#define WNP_FNT_COURIER        1<<0
#define WNP_FNT_HELV           1<<1
#define WNP_FNT_HARD           1<<2
#define WNP_FNT_STEREO         1<<3

#define WNP_KBD_NONE              0
#define WNP_KBD_LOCAL             1
#define WNP_KBD_REMOTE            2
#define WNP_KBD_IGNORE            3

#define WNP_MAX_MENUBUTTON_TEXT  60
#define WNP_THREED_BACKGROUND     0
#define WNP_MENU_COLOR_BCKG       1
#define WNP_MENU_COLOR_TEXT       2
#define WNP_MENU_COLOR_HBCK       3
#define WNP_MENU_COLOR_HTXT       4
#define WNP_MENU_COLOR_CURSOR     5

#define WNP_MENU_LINES           46
#define WNP_MENU_BUTTONS        256

/* the following flags must match the corresponding definitions in the client */
#define DSP_ROOT              (1<<0)
#define DSP_GLBL              (1<<1)
#define DSP_MDL               (1<<2)
#define DSP_CSO               (1<<3)
#define DSP_CNT               (1<<4)      /* implemented as CSO/MDS */
#define DSP_TRACE             (1<<5)      /*      "      "     "    */
#define DSP_TRG               (1<<6)
#define DSP_HHDIST            (1<<7)      /* implemented as CSO/MDS */

#define WNP_LST_DOTS              1
#define WNP_LST_MON               2
#define WNP_LST_MDS               3
#define WNP_LST_TOBJ              4
#define WNP_LST_TRG               5
#define WNP_LST_NOE               6

#define ATM_FLG_DSP           (1<<0)
#define ATM_FLG_LDSP          (1<<1)
#define ATM_FLG_MARK          (1<<2)
#define ATM_FLG_REMOVE        (1<<3)
#define ATM_FLG_SPHERE        (1<<4)
#define ATM_FLG_ISO           (1<<5)

#define ATM_LAB_NONE              0
#define ATM_LAB_NAME              1
#define ATM_LAB_RESIDUE           2
#define ATM_LAB_TYPE              3
#define ATM_LAB_Q                 4
#define ATM_LAB_GEOMETRY          5
#define ATM_LAB_SYMBOL            6
#define ATM_LAB_VALENCE           7
#define ATM_LAB_LIGANCE           8
#define ATM_LAB_CHARGE            9
#define ATM_LAB_AROMATICITY      10
#define ATM_LAB_GROUP            11
#define ATM_LAB_SWITCH           12
#define ATM_LAB_OOPFLAG          13
#define ATM_LAB_TEXT             14
#define ATM_LAB_BISO             15
#define ATM_LAB_SOF              16
#define ATM_LAB_SEQNR            17
#define ATM_LAB_SHIFT            18
#define ATM_LAB_FULLNAME         19
#define ATM_LAB_MOLECULE         20
#define ATM_LAB_LOCATIONS        21

#define BND_LAB_NONE              0
#define BND_LAB_PI                1
#define BND_LAB_ORDER             2
#define BND_LAB_TYPE              3
#define BND_LAB_TEXT              4

#define BND_FLG_REMOVE        (1<<0)
#define BND_FLG_CYLINDER      (1<<1)
#define BND_FLG_LDSP          (1<<2)

/* the following flags must match the corresponding definitions in the client */
#define OBJ_FLG_DSP           (1<<0)
#define OBJ_FLG_RBLD          (1<<1)
#define OBJ_FLG_MOD           (1<<2)
#define OBJ_FLG_ACTIVE        (1<<3)

#define DOT_OFF                   0
#define DOT_IFATOM                1
#define DOT_ON                    2
#define DOT_BYATOM               -2
#define DOT_BYPROPERTY           -1
#define DOT_SMALL                 0

#define WNP_MAX_SPHERE_QUALITY  256
#define WNP_MAX_iSPHERE_QUALITY  21

#define WNP_SPHERE_GLU            1
#define WNP_SPHERE_ICO            2
#define WNP_SPHERE_HALF           0
#define WNP_SPHERE_FULL           1
#define WNP_SPHERE_QUALITY        2

#define WNP_MAX_CYLINDER_QUALITY 256
#define WNP_CYLINDER_HALF         0
#define WNP_CYLINDER_FULL         1
#define WNP_CYLINDER_QUALITY      2

#define WNP_SOLID_RENDERED        0
#define WNP_SOLID_LINES           1
#define WNP_SOLID_POINTS          2

#define WNP_TRG_RENDERED          1
#define WNP_TRG_MESH              2
#define WNP_TRG_NORMALS           3
#define WNP_TRG_DOTS              4

#define WNP_CSO_LINES             1
#define WNP_CSO_POINTS            2

#define WNP_NOE_LAB_NONE          0
#define WNP_NOE_LAB_VIOL          1
#define WNP_NOE_LAB_LIM           2

#define WNP_NOE_DOTTED        (1<<0)
#define WNP_NOE_BROKEN        (1<<1)

#define WNP_TXT_HARD              1
#define WNP_TXT_STROKE            2
#define WNP_TXT_LIB               3

#define WNP_COLOR_BYATOM         -1

#define WNP_GRD_MISSING       1.e30

#endif
