#ifndef XBHTREEDEF
#define XBHTREEDEF

typedef struct xBHnode {
  struct xBHnode *left,*right;
  float  **atom;
  int    *nr;
  float  cut;
  int    dim,n,marked;
} xBHnode;  

typedef struct xBHtree {
  struct xBHnode *root;
  float **atom;
  int   *nr;
  float xmin[3];
  float xmax[3];
  int n;
} xBHtree;

#define xBH_CUT_MIDDLE 1
#define xBH_CUT_MEDIAN 2

xBHtree *GeneratexBHtree(int N,float **atoms,int granularity);
xBHnode *findxBHnode(xBHtree *tree,float *x);
void     freexBHtree(xBHtree *tree);
void     freexBHnode(xBHnode *node);
void     dividexBHnode(xBHnode *node,float *xmin,float *xmax,int granularity);
float    findxBHmindist(xBHtree *tree,float *x);
float   *findxBHclosest(xBHtree *tree,float *x,float dmax,float *d);
int      findIxBHclosest(xBHtree *tree,float *x,float dmax,float *d);
int      findxBHclosePoints(xBHtree *tree,float *x,float cutoff,
		            float **atom,float *dist,int maxn);
int      nrfindxBHclosePoints(xBHtree *tree,int idx,float cutoff,
		              float **atom,float *dist,int maxn);
int      set_xbh_cut_method(int m);

#endif
