#include <math.h>
#include "strutil.h"
#include "swdef.h"
#include "mystdlib.h"
#include "parser.h"
#include "object.h"
#include "gcalc.h"
#include "transpor.h"
#include "errhand.h"
#include "xtal.h"

extern int graphix;
extern Node *MolRoot;
extern Dspobj *DspRoot;
extern Node *DefaultNode;

#define LOOP 1
#define DONE 2

#define HYD_NO    0
#define HYD_POLAR 1
#define HYD_YES   2

#define key_is(x) (streq(key->key,x))

/*========================================================================*/

void cmd_xray(void)
{
  Token *key=(Token *)NULL;
  int state;
  char *main_keys = "genlig '' end";


  state=LOOP;

  while (state!=DONE) {
    err_dump();
    key=free_Token(key);
    key=Get_Kwd("XRay> ",";",main_keys);
    if (key->status==TOK_OK) {
      if (key_is("genlig")) {
	cmd_genlig();
      }else if (key_is("end")) {
	state=DONE;
      }
    }else if (key->status==TOK_NOK) {
      err_set(1,"unknown XRay command: %s\n",key->text);
    }else state=DONE;
    if (end_parse()!=TOK_OK) 
      err_set(1,"extra characters at end of command ignored.");
    if (state==LOOP) start_parse();
  }
  key=free_Token(key);
}

