#ifndef XTALDEF
#define XTALDEF

#ifndef OBJECTDEF
#include "object.h"
#endif

#define A_latt 5
#define B_latt 6
#define C_latt 7
#define I_latt 2
#define F_latt 4
#define P_latt 1
#define H_latt 3
#define R_latt 1

mat_4 fract_to_angstrom(float *cl,float *ca);
mat_4 PDB_fta_matrix(float *cl,float *a);
Symop str2sym(char *string);
Symop csd2sym(char *string);
Symop symA(Xcn *x,Symop s);
Symop symF(Xcn *x,Symop s);
Symop symClosest(Xcn *xcn,vec_3 X_in,vec_3 x_in,float *d);
int   symopequiv(Symop a,Symop s);
int   symopexp(Xcn *x);
void  symopreduce(Xcn *x);
char *sym2str(char *string,Symop s);
vec_3 F2cell(vec_3 x);
vec_3 A2cell(Xcn *c,vec_3 x);
vec_3 symdo(Symop s,vec_3 x);
vec_3 Fxyz(Xcn *c,vec_3 x);
vec_3 Axyz(Xcn *c,vec_3 x);
Symop symtra(Symop s,vec_3 tra);
float lattice_dist(Xcn *xcn,vec_3 a,vec_3 b);
float recell(float *cl,float *ca,float *rl,float *ra);
void  RotTfact(Symop s,float b[6]);
float cell_volume(float *l,float *a);
void  xcn_transform(mat_4 M,Xcn *xcn);
float fix_fta_matrix(Xcn *xcn);
float check_fta_matrix(mat_4 fta,float *cl,float *ca);

#endif
