	logical function add_chiral()
c
c Automatically add chirality constraint for each atom with 4 bonds.
c
	implicit none

#include "sizes.h"
#include "apara.h"
#include "atom.h"
#include "energy.h"
#include "option.h"

	integer nn(matot),n(4,matot),i,j,k,l
	real*8 v(3,3),vv(3,3),vol
	
	add_chiral=.TRUE.
	do i=1,nat
	   nn(i)=0
	end do
	do i=1,nbnd
	   nn(bnd(1,i))=nn(bnd(1,i))+1
	   if (nn(bnd(1,bnd(1,i))).le.4) 
     1		n(nn(bnd(1,i)),bnd(1,i))=bnd(2,i)
	   nn(bnd(2,i))=nn(bnd(2,i))+1
	   if (nn(bnd(1,bnd(2,i))).le.4) 
     1		n(nn(bnd(2,i)),bnd(2,i))=bnd(1,i)
	end do
c
	do i=1,nat
	   if (nn(i).eq.4) then
	      if (nconc.lt.mconstc) then
		 nconc=nconc+1
		 do j=1,4
		    atconc(j,nconc)=n(j,i)
		 end do
		 volmin(nconc)=4.0
		 kconc(nconc)=100.0
		 do k=1,3
		    do l=1,3
		       v(k,l)=xyz(k,n(l,i))-xyz(k,n(4,i))
		    end do
		 end do
		 do k=1,3
		    j=mod(k,3)+1
		    l=mod(j,3)+1
		    vv(1,k)=v(2,j)*v(3,l)-v(3,j)*v(2,l)
		    vv(2,k)=v(3,j)*v(1,l)-v(1,j)*v(3,l)
		    vv(3,k)=v(1,j)*v(2,l)-v(2,j)*v(1,l)
		 end do
		 vol=-(v(1,1)*vv(1,1)+v(2,1)*vv(2,1)+v(3,1)*vv(3,1))
		 if (vol.lt.0) then
		    k=atconc(1,nconc)
		    atconc(1,nconc)=atconc(2,nconc)
		    atconc(2,nconc)=k
		 end if
	      else
		 add_chiral=.false.
	      end if
	   end if
	end do
c
	return
	end
