#include <stdlib.h>
#include <string.h>

/* Provides FORTRAN callable X-Plor style wildcard match routine   */
/* The function 'wild_xmatch' is a copy from the one used in Wit!P,*/
/* except that this version is case-sensitive.                     */

int wild_xmatch(char *reg,char *wild);

/*------------------------------------------------------------------------*/

int cwldmatch_(char *reg,int *lreg,char *wld,int *lwld)
{
  char *tr=(char *)NULL,*tw=(char *)NULL;
  int r=0;
  
  if (*lreg>=0) tr=malloc(*lreg+1);
  if (*lwld>=0) tw=malloc(*lwld+1);
  if (tr&&tw) {
    strncpy(tr,reg,*lreg);tr[*lreg]='\0';
    strncpy(tw,wld,*lwld);tw[*lwld]='\0';
    r=wild_xmatch(tr,tw);
  }else r=0;
  if (tr) free(tr);
  if (tw) free(tw);
  return(r);
}

/*------------------------------------------------------------------------*/
#define TRUE 1
#define FALSE 0
#define ANY '*'
#define ONE '?'
#define XONE '%'
#define XONE2 '?'
#define DIG '+'
#define DIGS '#'
#define QUO '\\'
#define FALSE 0
#define TRUE 1
#define YES 1
#define NO 0

#define is_special(c) ((c) == ANY || (c) == ONE || (c) == QUO)
#define is_xspecial(c) ((c) == ANY || (c) == XONE || (c) == XONE2 || (c) == DIG || (c) == DIGS || (c) == QUO)
#define is_normal(c) (!is_special(c))
#define is_xnormal(c) (!is_xspecial(c))
#define is_wild(c) ((c) == ANY || (c) == ONE)
#define is_xwild(c) ((c) == ANY || (c) == DIG || (c) == DIGS || (c) == XONE || (c) == XONE2)

int wild_xmatch(char *reg,char *wild)
{
/*   Return 1 if "reg" matches "wild" with wildcards '*' and '?', else 0.
     
     This is an X-Plor - like wild match routine.

     '\' is used as a quote character in "wild".
     '*' matches any number of arbitrary characters.
     '%' and '?' match a single arbitrary character.
     '+' matches a single digit.
     '#' matches a sequence of digits (incl. zero length)

*/

  if (!reg || !wild) {
    if (!reg && !wild) return(TRUE);
    if (!reg && strcmp(wild,"*")==0) return(TRUE);
    else return(FALSE);
  }

  while (*wild || *reg) {
    if (is_xnormal(*wild)) {
      if (*wild != *reg) return(FALSE);
    }else if (*wild == QUO) {
      wild++;
      if (*wild != *reg) return(FALSE);
    }else if (*wild == DIG) {
      if (*reg < '0' || *reg > '9') return(FALSE);
    }else if (*wild == XONE || *wild == XONE2 ) {
      if (*reg == '\0') return(FALSE);
    }else if (*wild == DIGS) {
      wild++;
      if (*wild == '\0') {
	for (;*reg;reg++) if (*reg < '0' || *reg > '9') return(FALSE);
	return(TRUE);
      }else{
	do {
	  if (wild_xmatch(reg,wild)) return(TRUE);
	  if (*reg < '0' || *reg > '9') return(FALSE);
	} while (*(reg++));
	return(FALSE);
      }
    }else if (*wild == ANY) {
      wild++;
      if (*wild == '\0') return(TRUE);
      do {
	if (wild_xmatch(reg,wild)) return(TRUE);
      } while (*(reg++));
      return(FALSE);
    }
    wild++;reg++;
  }
  return(TRUE);
}
