        recursive subroutine egang_1p(p,w,n,x,eg,gr)
c
c   Compute energy due to angle bending and update gradient 'gr'.
c
        implicit none
#include "sizes.h"
#include "constants.h"
#include "energy.h"
#include "option.h"
        real*8  x(3,*)
        real*8  gr(3,*),e
        real*8  eg
        real*8  x21(3),x23(3),s,r21,r23,d,f,f21,f23,r21s,r23s
        integer i,w,m,from,to,p,n,i1,i2,i3      
c
c   Initialize energy
c
        e=0.0
c
c   Compute angle / out of plane energy
c
c
        from=((p-1)*nang)/w+1
        to=(p*nang)/w
c
        do i=from,to
c
c   Bondangle
c
           i1=ang(1,i)
           i2=ang(2,i)
           i3=ang(3,i)
           s=0.0
           r21s=0.0
           r23s=0.0
           do m=1,3
              x21(m)=x(m,i1)-x(m,i2)
              x23(m)=x(m,i3)-x(m,i2)
              s=s+x21(m)*x23(m)
              r21s=r21s+x21(m)*x21(m)
              r23s=r23s+x23(m)*x23(m)
           end do
           r21s=1/r21s
           r23s=1/r23s
           r21=sqrt(r21s)
           r23=sqrt(r23s)
           s=max(-1.0D0,min(1.0D0,s*r21*r23))
           angl(i)=acos(s)*RAD2DEG
           if (angl0(i).lt.-0.1) angl0(i)=angl(i)
c
c   Energy
c
           d=angl0(i)-angl(i)
           e=e+0.5*kang(i)*d**2
c
c   Gradient
c
           if (1-s**2.gt.1.e-25) then
              f=RAD2DEG*(kang(i)*d)/sqrt(1-s**2)
              do m=1,3
                 f21=f*(x23(m)*r21*r23-s*x21(m)*r21s)
                 f23=f*(x21(m)*r21*r23-s*x23(m)*r23s)
                 gr(m,i1)=gr(m,i1)+f21
                 gr(m,i3)=gr(m,i3)+f23
                 gr(m,i2)=gr(m,i2)-f21-f23
              end do
           end if
        end do
c
c   done...
c
        eg=e
        return
        end
