      subroutine egbend(n,x,e)
c     
c     Compute energy due to out of plane deformations for neighbours of
c     pi-centers and update gradient.
c     
      implicit none
#include "sizes.h"
#include "energy.h"
#include "option.h"
c     
      real*8  x(3,*)
      real*8  e
      integer n,i
      integer nt,omp_get_num_threads,omp_get_thread_num
c     
      e=0.0
      if (npla.eq.0) return
c     
#ifdef USEOMP
C$OMP PARALLEL PRIVATE(i), SHARED(nt,n)
      nt=omp_get_num_threads()
      i=omp_get_thread_num()+1        
#else 
      nt=1
      i=1
#endif
      call egbend_1p(i,nt,n,x,e_1p(i),gr_1p(1,1,i))
#ifdef USEOMP
C$OMP END PARALLEL
#endif
      do i=1,nt
         e=e+e_1p(i)
      end do
c     
      return
      end
