      recursive subroutine egbend_1p(p,w,n,x,eg,gr)
c
c     Driver for of plane deformation / iproper torsion energy
c     and gradient.
c
      implicit none
#include "option.h"
      real*8  x(3,*)
      real*8  gr(3,*),e
      real*8  eg
      integer p,w,n
c
      if (fftype.eq.'TAFF') then
         call taff_egbend_1p(p,w,n,x,eg,gr)
      else if (fftype.eq.'CHARMM') then
         call charmm_egbend_1p(p,w,n,x,eg,gr)
      else
         eg=0
      end if
c
      return
      end
c------------------------------------------------------------------------
         
      recursive subroutine taff_egbend_1p(p,w,n,x,eg,gr)
c     
c     
c     Compute energy due to out of plane deformations for neighbours of
c     pi-centers and update gradient.
c     
      implicit none
#include "sizes.h"
#include "energy.h"
#include "option.h"
c     
      real*8  x(3,*)
      real*8  gr(3,*),e
      real*8  eg
      integer n,w,from,to,p
c     
      integer i
      real*8 A,B,C,D,x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,S,S2
      real*8 def,f

c     
      e=0.0
c     
      from=((p-1)*npla)/w+1
      to=(p*npla)/w
      do i=from,to
c     
c     Before we do it, we copy the coordinates (just for fun...) BAD !!!
c     
         x1=x(1,pla(2,i))
         x2=x(1,pla(3,i))
         x3=x(1,pla(4,i))
         x4=x(1,pla(1,i))
         y1=x(2,pla(2,i))
         y2=x(2,pla(3,i))
         y3=x(2,pla(4,i))
         y4=x(2,pla(1,i))
         z1=x(3,pla(2,i))
         z2=x(3,pla(3,i))
         z3=x(3,pla(4,i))
         z4=x(3,pla(1,i))

c     
c     Energy and gradient of oop term (new definition [Sybyl 5.x]).
c     -----------------------------------------------------------
c     
c     A*x + B*y + C*z +D = 0     
c     
         A=y1*z2+y2*z3+y3*z1-y1*z3-y2*z1-y3*z2
         B=x1*z3+x2*z1+x3*z2-x1*z2-x2*z3-x3*z1
         C=x1*y2+x2*y3+x3*y1-x1*y3-x2*y1-x3*y2
         D=x1*y3*z2+x2*y1*z3+x3*y2*z1-x1*y2*z3-x2*y3*z1-x3*y1*z2
c     
c     Distance (signed) def from plane
c     
         S2=A*A+B*B+C*C
         S=sqrt(S2)
         def=(A*x4+B*y4+C*z4+D)/S
         if (S.gt.1.e-8) then
c     
c     Energy
c     
            e=e+0.5*kpla(i)*def*def
            f=kpla(i)*def
            plad(i)=def
c     
c     Gradient
c     
            gr(1,pla(1,i))=gr(1,pla(1,i)) + f*A/S
            gr(1,pla(2,i))=gr(1,pla(2,i)) + 
     .           f*(((z3-z2)*y4+(y2-y3)*z4+(y3*z2-y2*z3))/S
     .           - def*(B*(z3-z2)+C*(y2-y3))/S2)
            gr(1,pla(3,i))=gr(1,pla(3,i)) + 
     .           f*(((z1-z3)*y4+(y3-y1)*z4+(y1*z3-y3*z1))/S
     .           - def*(B*(z1-z3)+C*(y3-y1))/S2)
            gr(1,pla(4,i))=gr(1,pla(4,i)) + 
     .           f*(((z2-z1)*y4+(y1-y2)*z4+(y2*z1-y1*z2))/S
     .           - def*(B*(z2-z1)+C*(y1-y2))/S2)
            
            gr(2,pla(1,i))=gr(2,pla(1,i)) + f*B/S
            gr(2,pla(2,i))=gr(2,pla(2,i)) +   
     .           f*(((x3-x2)*z4+(z2-z3)*x4+(z3*x2-z2*x3))/S
     .           -def*(C*(x3-x2)+A*(z2-z3))/S2)
            gr(2,pla(3,i))=gr(2,pla(3,i)) +
     .           f*(((x1-x3)*z4+(z3-z1)*x4+(z1*x3-z3*x1))/S
     .           -def*(C*(x1-x3)+A*(z3-z1))/S2)
            gr(2,pla(4,i))=gr(2,pla(4,i)) +
     .           f*(((x2-x1)*z4+(z1-z2)*x4+(z2*x1-z1*x2))/S
     .           -def*(C*(x2-x1)+A*(z1-z2))/S2)
            
            gr(3,pla(1,i))=gr(3,pla(1,i)) + f*C/S
            gr(3,pla(2,i))=gr(3,pla(2,i)) + 
     .           f*(((y3-y2)*x4+(x2-x3)*y4+(x3*y2-x2*y3))/S
     .           -def*(A*(y3-y2)+B*(x2-x3))/S2)
            gr(3,pla(3,i))=gr(3,pla(3,i)) +
     .           f*(((y1-y3)*x4+(x3-x1)*y4+(x1*y3-x3*y1))/S
     .           -def*(A*(y1-y3)+B*(x3-x1))/S2)
            gr(3,pla(4,i))=gr(3,pla(4,i)) +
     .           f*(((y2-y1)*x4+(x1-x2)*y4+(x2*y1-x1*y2))/S
     .           -def*(A*(y2-y1)+B*(x1-x2))/S2)
         else
            plad(i)=0.0
         end if
      end do
c     
      eg=e
      return
      end
c------------------------------------------------------------------------

      recursive subroutine charmm_egbend_1p(p,w,n,x,eg,gr)
c
c     Implements CHARMM's harmonic improper torsion potential
c
      implicit none
#include "sizes.h"
#include "constants.h"
#include "energy.h"
#include "option.h"
      real*8  x(3,*)
      real*8  gr(3,*),e
      real*8  eg
      integer p,w,n
c     
      integer i1,i2,i3,i4,i,j,l,from,to,tr,trm
      real*8  r32,ta1,ta2,ta3,tb1,tb2,tb3,tan,tbn,sigma,t,sp,f,
     .     f1,f2,f3,f4,s2,s3,d
c     
c     Initialize energy
c     
      e=0.0
c     
c     Compute torsion angles and directions of forces 'ta' and 'tb'
c     
      from = ((p-1)*npla)/w+1
      to = (p*npla)/w
      do i=from,to
         i1=pla(1,i)
         i2=pla(2,i)
         i3=pla(3,i)
         i4=pla(4,i)
         r32=0
         do j=1,3
            r32=r32+(x(j,i2)-x(j,i3))**2
         end do
         r32=sqrt(r32)
         ta1=(x(2,i2)-x(2,i3))*(x(3,i2)-x(3,i1))-
     *        (x(3,i2)-x(3,i3))*(x(2,i2)-x(2,i1))
c     
         ta2=(x(3,i2)-x(3,i3))*(x(1,i2)-x(1,i1))-
     *        (x(1,i2)-x(1,i3))*(x(3,i2)-x(3,i1))
c     
         ta3=(x(1,i2)-x(1,i3))*(x(2,i2)-x(2,i1))-
     *        (x(2,i2)-x(2,i3))*(x(1,i2)-x(1,i1))
c     
         tb1=(x(2,i2)-x(2,i3))*(x(3,i3)-x(3,i4))-
     *        (x(3,i2)-x(3,i3))*(x(2,i3)-x(2,i4))
c     
         tb2=(x(3,i2)-x(3,i3))*(x(1,i3)-x(1,i4))-
     *        (x(1,i2)-x(1,i3))*(x(3,i3)-x(3,i4))
c     
         tb3=(x(1,i2)-x(1,i3))*(x(2,i3)-x(2,i4))-
     *        (x(2,i2)-x(2,i3))*(x(1,i3)-x(1,i4))
c     
         tan=sqrt(ta1*ta1+ta2*ta2+ta3*ta3)
         tbn=sqrt(tb1*tb1+tb2*tb2+tb3*tb3)
         if (tan.lt.1.e-25.or.tbn.lt.1.e-25) then
            plad(i)=0.0
         else
            ta1=ta1/tan
            ta2=ta2/tan
            ta3=ta3/tan
            tb1=tb1/tbn
            tb2=tb2/tbn
            tb3=tb3/tbn
            sigma=sign(1.0D0,(ta2*tb3-ta3*tb2)*(x(1,i2)-x(1,i3))+
     *           (ta3*tb1-ta1*tb3)*(x(2,i2)-x(2,i3))+
     *           (ta1*tb2-ta2*tb1)*(x(3,i2)-x(3,i3)))
            sp=max(-1.0D0,min(1.0D0,ta1*tb1+ta2*tb2+ta3*tb3))
            t=-sigma*acos(sp)
            plad(i)=t*RAD2DEG
            s2=0.0
            s3=0.0
            do l=1,3
               s2=s2+(x(l,i2)-x(l,i3))*(x(l,i2)-x(l,i1))
               s3=s3+(x(l,i2)-x(l,i3))*(x(l,i3)-x(l,i4))
            end do
c     
c     Energy
c     
            d=t-pla0(i)
            e=e+kpla(i)*d*d
            f=2*kpla(i)*d
c     
c     Gradient
c     
            if (f.ne.0.0) then
               f1=-f*r32/tan
               f2=f*s2/(tan*r32)
               f3=f*s3/(tbn*r32)
               f4=-f*r32/tbn
               gr(1,i1)=gr(1,i1)+f1*ta1
               gr(1,i2)=gr(1,i2)-(f1+f2)*ta1+f3*tb1
               gr(2,i1)=gr(2,i1)+f1*ta2
               gr(2,i2)=gr(2,i2)-(f1+f2)*ta2+f3*tb2
               gr(3,i1)=gr(3,i1)+f1*ta3
               gr(3,i2)=gr(3,i2)-(f1+f2)*ta3+f3*tb3
               gr(1,i3)=gr(1,i3)+(f4-f3)*tb1+f2*ta1
               gr(1,i4)=gr(1,i4)-f4*tb1
               gr(2,i3)=gr(2,i3)+(f4-f3)*tb2+f2*ta2
               gr(2,i4)=gr(2,i4)-f4*tb2
               gr(3,i3)=gr(3,i3)+(f4-f3)*tb3+f2*ta3
               gr(3,i4)=gr(3,i4)-f4*tb3
            end if
         end if
      end do
c     
c     done...
c     
      eg=e
      return
      end
