	subroutine egbond(n,x,e)
c
c   Compute bondstretching energy 'e' for the molecule whose coordinates
c   are stored in x (n atoms). At the same time the gradient resulting from
c   the bondstretching potentials will be added to 'gr'.
c
	implicit none
#include "sizes.h"
#include "energy.h"
#include "option.h"
	real*8	x(3,*)
	real*8  e
	integer i,n
	integer nt,omp_get_num_threads,omp_get_thread_num
c
c   Initialize energy
c
	e=0.0
	if (nbnd.lt.1) return
c
c   Compute bondlengths
c
#ifdef USEOMP
C$OMP PARALLEL PRIVATE(i), SHARED(nt,n)
	nt=omp_get_num_threads()
	i=omp_get_thread_num()+1	
#else
	nt=1
	i=1
#endif
	call egbond_1p(i,nt,n,x,e_1p(i),gr_1p(1,1,i))
#ifdef USEOMP
C$OMP END PARALLEL
#endif
	do i=1,nt
	   e=e+e_1p(i)
	end do
c
c   done...
c
	return
	end
