	recursive subroutine egbond_1p(p,w,n,x,eg,gr)
c
c   Compute bondstretching energy 'e' for the molecule whose coordinates
c   are stored in x (n atoms). At the same time the gradient resulting from
c   the bondstretching potentials will be added to 'gr'.
c
	implicit none
#include "sizes.h"
#include "energy.h"
#include "option.h"
	real*8	x(3,*)
	real*8  gr(3,*),e
	real*8  dx(3),de,f,d
	real*8  eg
	integer i,w,l,from,to,p,n
c
c   Initialize energy
c
	e=0.0
c
c   Compute bondlengths
c
	from=((p-1)*nbnd)/w+1
	to=(p*nbnd)/w
	do i=from,to
	    dx(1)=x(1,bnd(1,i))-x(1,bnd(2,i))		
	    dx(2)=x(2,bnd(1,i))-x(2,bnd(2,i))		
	    dx(3)=x(3,bnd(1,i))-x(3,bnd(2,i))		
	    bndl(i)=dx(1)*dx(1)+dx(2)*dx(2)+dx(3)*dx(3)
	    bndl(i)=sqrt(bndl(i))
	    if (bndl0(i).lt.-0.1) bndl0(i)=bndl(i)
c
	   d=bndl(i)-bndl0(i)	   
	   de=d*d*kbnd(i)*0.5
	   f=kbnd(i)*d/bndl(i)
	   do l=1,3
	      gr(l,bnd(1,i))=gr(l,bnd(1,i))+dx(l)*f
	      gr(l,bnd(2,i))=gr(l,bnd(2,i))-dx(l)*f
	   end do
	   e=e+de
	end do
c
c   done...
c
	eg=e
	return
	end
