      recursive subroutine egcona_1p(p,w,n,x,eg,gr)
c     
c     Compute angle constraint energy 'e' for the molecule whose coordinates
c     are stored in x (n atoms). At the same time the gradient resulting from
c     the constraint potentials will be added to 'gr'.
c     
      implicit none
#include "sizes.h"
#include "constants.h"
#include "energy.h"
#include "option.h"
      real*8  x(3,*)
      real*8  gr(3,*),eg
      real*8  x21(3),x23(3),s,r21,r23,d,f,f21,f23,r21s,r23s,e
      integer i,w,m,from,to,p,n,i1,i2,i3
c     
      e=0
      from = ((p-1)*ncona)/w+1
      to = (p*ncona)/w
      do i=from,to
         i1=atcona(1,i)
         i2=atcona(2,i)
         i3=atcona(3,i)
         s=0.0
         r21s=0.0
         r23s=0.0
         do m=1,3
            x21(m)=x(m,i1)-x(m,i2)
            x23(m)=x(m,i3)-x(m,i2)
            s=s+x21(m)*x23(m)
            r21s=r21s+x21(m)*x21(m)
            r23s=r23s+x23(m)*x23(m)
         end do
         r21s=1/r21s
         r23s=1/r23s
         r21=sqrt(r21s)
         r23=sqrt(r23s)
         s=max(-1.0D0,min(1.0D0,s*r21*r23))
         dcona(i)=acos(s)*RAD2DEG
c     
c     Energy
c     
         d=0.0
         epena(i)=0.0
         if (dcona(i).lt.dlowa(i))  d=dlowa(i)-dcona(i)
         if (dcona(i).gt.dhigha(i)) d=dhigha(i)-dcona(i)
         if (abs(d).gt.1.e-25) then
            epena(i)=d*d*kcona(i)*0.5
            e=e+epena(i)
c     
c     Gradient
c     
            if (1-s**2.gt.1.e-25) then
               f=RAD2DEG*(kcona(i)*d)/sqrt(1-s**2)
               do m=1,3
                  f21=f*(x23(m)*r21*r23-s*x21(m)*r21s)
                  f23=f*(x21(m)*r21*r23-s*x23(m)*r23s)
                  gr(m,i1)=gr(m,i1)+f21
                  gr(m,i3)=gr(m,i3)+f23
                  gr(m,i2)=gr(m,i2)-f21-f23
               end do
            end if
         end if
      end do
c     
c     done...
c     
      eg=e
      return
      end
