	recursive subroutine egconchi_1p(p,w,n,x,eg,gr)
c
c   Compute chirality constraint energy 'e' for the molecule whose coordinates
c   are stored in x (n atoms). At the same time the gradient resulting from
c   the constraint potentials will be added to 'gr'.
c
	implicit none
#include "sizes.h"
#include "energy.h"
#include "option.h"
	real*8	x(3,*)
	real*8  gr(3,*),eg
	real*8  e
	integer n,w,i,j,k,l,from,to,p
	real*8 frc,d,v(3,3),vv(3,3)
c       
	e=0
	from = ((p-1)*nconc)/w+1
	to = (p*nconc)/w
	do i=from,to
	   do k=1,3
	      do l=1,3
		 v(k,l)=x(k,atconc(l,i))-x(k,atconc(4,i))
	      end do
	   end do
	   do k=1,3
	      j=mod(k,3)+1
	      l=mod(j,3)+1
	      vv(1,k)=v(2,j)*v(3,l)-v(3,j)*v(2,l)
	      vv(2,k)=v(3,j)*v(1,l)-v(1,j)*v(3,l)
	      vv(3,k)=v(1,j)*v(2,l)-v(2,j)*v(1,l)
	   end do
	   vcon(i)=-(v(1,1)*vv(1,1)+v(2,1)*vv(2,1)+v(3,1)*vv(3,1))
	   epenc(i)=0.0
	   if (vcon(i).lt.volmin(i)) then
	      d=volmin(i)-vcon(i)
	      epenc(i)=kconc(i)*d*d
	      e=e+epenc(i)
	      frc=-2*kconc(i)*d
	      do k=1,3
		 do j=1,3
		    gr(j,atconc(k,i))=gr(j,atconc(k,i))-frc*vv(j,k)
		    gr(j,atconc(4,i))=gr(j,atconc(4,i))+frc*vv(j,k)
		 end do
	      end do
	   end if
	end do
c       
c   done...
c
	eg=e
	return
	end
