	recursive subroutine egcondi_1p(p,w,n,x,eg,gr)
c
c   Compute distance constraint energy 'e' for the molecule whose coordinates
c   are stored in x (n atoms). At the same time the gradient resulting from
c   the constraint potentials will be added to 'gr'.
c
	implicit none
#include "sizes.h"
#include "energy.h"
#include "option.h"
	real*8	x(3,*)
	real*8  gr(3,*),eg
	real*8  f,d,e
	integer i,w,j,i1,i2,l,from,to,p,n
c
	e=0
	from = ((p-1)*ncon)/w+1
	to = (p*ncon)/w
	do i=from,to
	   dcon(i)=0
	   do j=1,3
	      dcon(i)=dcon(i)+(x(j,atcon(1,i))-x(j,atcon(2,i)))**2
	   end do
	   dcon(i)=sqrt(dcon(i))
	   i1=atcon(1,i)
	   i2=atcon(2,i)
c
c   Energy
c
	   d=0.0
	   epen(i)=0.0
	   if (dcon(i).lt.dlow(i)) d=dcon(i)-dlow(i)
	   if (dcon(i).gt.dhigh(i)) d=dcon(i)-dhigh(i)
	   if (abs(d).gt.1.e-25) then
	      epen(i)=d*d*kcon(i)*0.5
	      e=e+epen(i)
c
c   Gradient
c
	      f=kcon(i)*d/dcon(i)
	      do l=1,3
	         gr(l,i1)=gr(l,i1)+(x(l,i1)-x(l,i2))*f
	         gr(l,i2)=gr(l,i2)-(x(l,i1)-x(l,i2))*f
	      end do
	   end if
	end do
c
c   done...
c
	eg=e
	return
	end
