	subroutine egconp(n,x,e)
c
c   Compute xy-projection constraint energy 'e' for the molecule whose coordinates
c   are stored in x (n atoms). At the same time the gradient resulting from
c   the constraint potentials will be added to 'gr'.
c
c   Note: All on one processor...
c
	implicit none
#include "sizes.h"
#include "energy.h"
#include "option.h"
	real*8	x(3,*)
	real*8  e,n
	real*8  dx(2),de,f,d,s,t
	integer i,l
c
c  Compute best scale
c
	s=0.0
	t=0.0
	do i=1,nconp
	   dx(1)=x(1,atconp(1,i))-x(1,atconp(2,i))		
	   dx(2)=x(2,atconp(1,i))-x(2,atconp(2,i))		
	   dconp(i)=dx(1)*dx(1)+dx(2)*dx(2)
	   dconp(i)=sqrt(dconp(i))
	   s=s+kconp(i)*dconp(i)*dtargp(i)
	   t=t+kconp(i)*dtargp(i)*dtargp(i)
	end do
	if (t.gt.0) then
	   sprj=s/t
	else
	   sprj=1.0
	end if
c
c  Compute energy and gradient      
c
	do i=1,nconp
	   d=dconp(i)-sprj*dtargp(i)	   
	   epenp(i)=d*d*kconp(i)*0.5
	   f=kconp(i)*d/dconp(i)
	   do l=1,2
	      dx(l)=x(l,atconp(1,i))-x(l,atconp(2,i))
	      gr_1p(l,atconp(1,i),1)=gr_1p(l,atconp(1,i),1)+dx(l)*f
	      gr_1p(l,atconp(2,i),1)=gr_1p(l,atconp(2,i),1)-dx(l)*f
	   end do
	   e=e+epenp(i)
	end do
c
c   done...
c
	return
	end
