      recursive subroutine egconto_1p(p,w,n,x,eg,gr)
c     
c     Compute torsional constraint energy and update gradient 'gr'. 
c     
      implicit none
#include "sizes.h"
#include "constants.h"
#include "energy.h"
#include "option.h"
      real*8  x(3,*)
      real*8  gr(3,*),eg
      integer p,w,n,i1,i2,i3,i4,i,j,l,from,to
      real*8  r32,ta1,ta2,ta3,tb1,tb2,tb3,tan,tbn,sigma,t,sp,f,
     .     f1,f2,f3,f4,s2,s3,dl,dh,dt,dmid,e
c     
c     Compute torsion angles and directions of forces 'ta' and 'tb'
c     
      e=0
      from=((p-1)*ncond)/w+1
      to=(p*ncond)/w
      do i=from,to
         i1=atcond(1,i)
         i2=atcond(2,i)
         i3=atcond(3,i)
         i4=atcond(4,i)
         r32=0
         do j=1,3
            r32=r32+(x(j,i2)-x(j,i3))**2
         end do
         r32=sqrt(r32)
         ta1=(x(2,i2)-x(2,i3))*(x(3,i2)-x(3,i1))-
     *        (x(3,i2)-x(3,i3))*(x(2,i2)-x(2,i1))
c     
         ta2=(x(3,i2)-x(3,i3))*(x(1,i2)-x(1,i1))-
     *        (x(1,i2)-x(1,i3))*(x(3,i2)-x(3,i1))
c     
         ta3=(x(1,i2)-x(1,i3))*(x(2,i2)-x(2,i1))-
     *        (x(2,i2)-x(2,i3))*(x(1,i2)-x(1,i1))
c     
         tb1=(x(2,i2)-x(2,i3))*(x(3,i3)-x(3,i4))-
     *        (x(3,i2)-x(3,i3))*(x(2,i3)-x(2,i4))
c     
         tb2=(x(3,i2)-x(3,i3))*(x(1,i3)-x(1,i4))-
     *        (x(1,i2)-x(1,i3))*(x(3,i3)-x(3,i4))
c     
         tb3=(x(1,i2)-x(1,i3))*(x(2,i3)-x(2,i4))-
     *        (x(2,i2)-x(2,i3))*(x(1,i3)-x(1,i4))
c     
         tan=sqrt(ta1*ta1+ta2*ta2+ta3*ta3)
         tbn=sqrt(tb1*tb1+tb2*tb2+tb3*tb3)
         if (tan.lt.1.e-6.or.tbn.lt.1.e-6) then
            dcond(i)=0.0
         else
            ta1=ta1/tan
            ta2=ta2/tan
            ta3=ta3/tan
            tb1=tb1/tbn
            tb2=tb2/tbn
            tb3=tb3/tbn
            sigma=sign(1.0D0,(ta2*tb3-ta3*tb2)*(x(1,i2)-x(1,i3))+
     *           (ta3*tb1-ta1*tb3)*(x(2,i2)-x(2,i3))+
     *           (ta1*tb2-ta2*tb1)*(x(3,i2)-x(3,i3)))
            sp=max(-1.0D0,min(1.0D0,ta1*tb1+ta2*tb2+ta3*tb3))
            t=-sigma*acos(sp)
            dcond(i)=t*RAD2DEG
c     
c     normalize constraint...
c     
            if (dlowd(i).gt.0.0) then
               dl=dlowd(i)-360.0
               dh=dhighd(i)-360.0
            else
               dl=dlowd(i)
               dh=dhighd(i)
            end if
            dmid=(dl+dh+360.0)*0.5
            dt=0.0
            if (dcond(i).gt.dmid) then
               if (dcond(i).lt.dl+360.0) dt=dcond(i)-dl-360.0
               if (dcond(i).gt.dh+360.0) dt=dcond(i)-dh-360.0
            else
               if (dcond(i).lt.dl)       dt=dcond(i)-dl
               if (dcond(i).gt.dh)       dt=dcond(i)-dh
            end if
            dt=dt/RAD2DEG
c     
c     Energy
c     
            epend(i)=0.5*kcond(i)*dt*dt
            e=e+epend(i)
            f=kcond(i)*dt
c     
c     Gradient
c     
            if (f.ne.0.0) then
               s2=0.0
               s3=0.0
               do l=1,3
                  s2=s2+(x(l,i2)-x(l,i3))*(x(l,i2)-x(l,i1))
                  s3=s3+(x(l,i2)-x(l,i3))*(x(l,i3)-x(l,i4))
               end do
               f1=-f*r32/tan
               f2=f*s2/(tan*r32)
               f3=f*s3/(tbn*r32)
               f4=-f*r32/tbn
               gr(1,i1)=gr(1,i1)+f1*ta1
               gr(1,i2)=gr(1,i2)-(f1+f2)*ta1+f3*tb1
               gr(2,i1)=gr(2,i1)+f1*ta2
               gr(2,i2)=gr(2,i2)-(f1+f2)*ta2+f3*tb2
               gr(3,i1)=gr(3,i1)+f1*ta3
               gr(3,i2)=gr(3,i2)-(f1+f2)*ta3+f3*tb3
               gr(1,i3)=gr(1,i3)+(f4-f3)*tb1+f2*ta1
               gr(1,i4)=gr(1,i4)-f4*tb1
               gr(2,i3)=gr(2,i3)+(f4-f3)*tb2+f2*ta2
               gr(2,i4)=gr(2,i4)-f4*tb2
               gr(3,i3)=gr(3,i3)+(f4-f3)*tb3+f2*ta3
               gr(3,i4)=gr(3,i4)-f4*tb3
            end if
         end if
      end do
c     
c     done...
c     
      eg=e
      return
      end
