        recursive subroutine egconx_1p(p,w,n,x,eg,gr)
c
c   Compute positional constraint energy 'e' for the molecule whose coordinates
c   are stored in x (n atoms). At the same time the gradient resulting from
c   the constraint potentials will be added to 'gr'.
c
        implicit none
#include "sizes.h"
#include "energy.h"
#include "option.h"
        real*8  x(3,*)
        real*8  gr(3,*),eg
        real*8  f,d,e
        integer i,w,j,i1,l,from,to,p,n
c
        e=0
        from = ((p-1)*nconx)/w+1
        to = (p*nconx)/w
        do i=from,to
           dconx(i)=0
           do j=1,3
              dconx(i)=dconx(i)+(x(j,atconx(i))-xconx(j,i))**2
           end do
           dconx(i)=sqrt(dconx(i))
           i1=atconx(i)
c
c   Energy
c
           epenx(i)=0.0
           d=dconx(i)
           if (d.gt.uconx(i)) d=uconx(i)
           d=d-tconx(i)
           if (d.gt.1.e-25) then
              epenx(i)=d*d*kconx(i)*0.5
              if (dconx(i).gt.uconx(i)) 
     .             epenx(i)=epenx(i)+kconx(i)*(dconx(i)-uconx(i))
              e=e+epenx(i)
c
c   Gradient
c
              f=kconx(i)*d/dconx(i)
              do l=1,3
                 gr(l,i1)=gr(l,i1)+(x(l,i1)-xconx(l,i))*f
              end do
           end if
        end do
c
c   done...
c
        eg=e
        return
        end
