        subroutine egnbnd(n,x,ev,ec)
c
c   Compute non-bonded energy evW & eCou  for the molecule whose coordinates
c   are stored in x (n atoms). At the same time the gradient resulting from
c   the van der Waals potentials will be added to 'gr_1p' (per processor).
c
	implicit none
#include "sizes.h"
#include "energy.h"
#include "atom.h"
#include "apara.h"
#include "option.h"
        real*8  x(3,*)
	real*8  ev,ec
	integer i,n
	integer nt,omp_get_num_threads,omp_get_thread_num
c
c   Initialize energy
c
        ev=0.0
        ec=0.0
c
#ifdef USEOMP
C$OMP PARALLEL PRIVATE(i), SHARED(nt,n)
	nt=omp_get_num_threads()
	i=omp_get_thread_num()+1	
#else
	nt=1
	i=1
#endif
	call egnbnd_1p(i,nt,n,x,e_1p(i),e_1pc(i),gr_1p(1,1,i))
#ifdef USEOMP
C$OMP END PARALLEL
#endif
c
c   Sum up partial energies
c
	do i=1,nt
	    ev=ev+e_1p(i)
            ec=ec+e_1pc(i)
	end do
c
c   done...
c
        return
        end
