      recursive subroutine egtors_1p(p,w,n,x,eg,gr)
c     
c     Compute torsional energy and update gradient 'gr'. 
c     
      implicit none
#include "sizes.h"
#include "constants.h"
#include "energy.h"
#include "option.h"
      real*8  eg
      integer p,w,n,i1,i2,i3,i4,i,j,l,from,to,tr,trm
      real*8  r32,ta1,ta2,ta3,tb1,tb2,tb3,tan,tbn,sigma,t,sp,f,
     .     f1,f2,f3,f4,s2,s3,ct

      real*8 e,x(3,n),gr(3,n)
c     
c     Initialize energy
c     
      e=0.0
c     
c     Compute torsion angles and directions of forces 'ta' and 'tb'
c     
      from = ((p-1)*ntor)/w+1
      to = (p*ntor)/w
      do i=from,to
         i1=tor(1,i)
         i2=tor(2,i)
         i3=tor(3,i)
         i4=tor(4,i)
         r32=0
         do j=1,3
            r32=r32+(x(j,i2)-x(j,i3))**2
         end do
         r32=sqrt(r32)
         ta1=(x(2,i2)-x(2,i3))*(x(3,i2)-x(3,i1))-
     *        (x(3,i2)-x(3,i3))*(x(2,i2)-x(2,i1))
c     
         ta2=(x(3,i2)-x(3,i3))*(x(1,i2)-x(1,i1))-
     *        (x(1,i2)-x(1,i3))*(x(3,i2)-x(3,i1))
c     
         ta3=(x(1,i2)-x(1,i3))*(x(2,i2)-x(2,i1))-
     *        (x(2,i2)-x(2,i3))*(x(1,i2)-x(1,i1))
c     
         tb1=(x(2,i2)-x(2,i3))*(x(3,i3)-x(3,i4))-
     *        (x(3,i2)-x(3,i3))*(x(2,i3)-x(2,i4))
c     
         tb2=(x(3,i2)-x(3,i3))*(x(1,i3)-x(1,i4))-
     *        (x(1,i2)-x(1,i3))*(x(3,i3)-x(3,i4))
c     
         tb3=(x(1,i2)-x(1,i3))*(x(2,i3)-x(2,i4))-
     *        (x(2,i2)-x(2,i3))*(x(1,i3)-x(1,i4))
c     
         tan=sqrt(ta1*ta1+ta2*ta2+ta3*ta3)
         tbn=sqrt(tb1*tb1+tb2*tb2+tb3*tb3)
         if (tan.lt.1.e-25.or.tbn.lt.1.e-25) then
            tora(i)=0.0
         else
            ta1=ta1/tan
            ta2=ta2/tan
            ta3=ta3/tan
            tb1=tb1/tbn
            tb2=tb2/tbn
            tb3=tb3/tbn
            sigma=sign(1.0D0,(ta2*tb3-ta3*tb2)*(x(1,i2)-x(1,i3))+
     *           (ta3*tb1-ta1*tb3)*(x(2,i2)-x(2,i3))+
     *           (ta1*tb2-ta2*tb1)*(x(3,i2)-x(3,i3)))
            sp=max(-1.0D0,min(1.0D0,ta1*tb1+ta2*tb2+ta3*tb3))
            t=-sigma*acos(sp)
            tora(i)=t*RAD2DEG
            if (tor0(i).lt.-300) tor0(i)=tora(i)
            s2=0.0
            s3=0.0
            do l=1,3
               s2=s2+(x(l,i2)-x(l,i3))*(x(l,i2)-x(l,i1))
               s3=s3+(x(l,i2)-x(l,i3))*(x(l,i3)-x(l,i4))
            end do
c     
c     Sum up Fourier terms...
c     
            do tr=1,ntortrm(i)  ! sum up fourier terms...
               trm=tortp(tr,i)
c     
c     Energy
c     
               if (kzf(trm).eq.-1) then
                  ct=t-tor0(i)/RAD2DEG
                  e=e+kzt(trm)*(1.0+cos(ct))
                  f=-kzt(trm)*sin(ct)
               else
                  ct=kzf(trm)*t-kzs(trm)
                  e=e+kzt(trm)*(1.0+cos(ct))
                  f=-kzt(trm)*kzf(trm)*sin(ct)
               end if
c     
c     Gradient
c     
               if (f.ne.0.0) then
                  f1=-f*r32/tan
                  f2=f*s2/(tan*r32)
                  f3=f*s3/(tbn*r32)
                  f4=-f*r32/tbn
                  gr(1,i1)=gr(1,i1)+f1*ta1
                  gr(1,i2)=gr(1,i2)-(f1+f2)*ta1+f3*tb1
                  gr(2,i1)=gr(2,i1)+f1*ta2
                  gr(2,i2)=gr(2,i2)-(f1+f2)*ta2+f3*tb2
                  gr(3,i1)=gr(3,i1)+f1*ta3
                  gr(3,i2)=gr(3,i2)-(f1+f2)*ta3+f3*tb3
                  gr(1,i3)=gr(1,i3)+(f4-f3)*tb1+f2*ta1
                  gr(1,i4)=gr(1,i4)-f4*tb1
                  gr(2,i3)=gr(2,i3)+(f4-f3)*tb2+f2*ta2
                  gr(2,i4)=gr(2,i4)-f4*tb2
                  gr(3,i3)=gr(3,i3)+(f4-f3)*tb3+f2*ta3
                  gr(3,i4)=gr(3,i4)-f4*tb3
               end if
            end do
         end if
      end do
c     
c     done...
c     
      eg=e
      return
      end
