	real*8 function egf(n,p,gr)
c
c   Compute total MM-energy and forces for molecule whose coordinates are
c   given by optimization parameters p(1...n).
c
	implicit none
#include "sizes.h"
#include "energy.h"
#include "option.h"
	real*8 	p(*),gr(*),etot,x(3,matot)
	real*8  egfd
        real etime,tnow,ttnow
        logical gnblst
	character*40 fmt
c
	integer i,j,k,n
c
c   Initialize energy and gradient (forces)
c
        ttnow=etime(tarray)
	egfd=0.0
	do k=1,nproc
	   do  j=1,ntot
	      do  i=1,3
	         gr_1p(i,j,k)=0.0
	      end do
	   end do
	end do
	call par2xyz(p,x)
c
        if (.not.gnblst(ntot,x)) then
           write(6,'(a)')  ' non-bonded list overflow, STOP'
           write(21,'(a)') ' non-bonded list overflow, STOP'
	   call putmol(n/3,x)
           call exit(5)
        end if
c
c  Sum energies and forces
c
        tnow=etime(tarray)
	call egbond(ntot,x,ebnd)
        tebond=tebond+etime(tarray)-tnow
	egfd=egfd+ebnd
        tnow=etime(tarray)
	call egang(ntot,x,eang)
        teang=teang+etime(tarray)-tnow
	egfd=egfd+eang
        tnow=etime(tarray)
	call egbend(ntot,x,epla)
        tebend=tebend+etime(tarray)-tnow
	egfd=egfd+epla
        tnow=etime(tarray)
	call egtors(ntot,x,etors)
        tetors=tetors+etime(tarray)-tnow
	egfd=egfd+etors
        tnow=etime(tarray)
	call egnbnd(ntot,x,evdw,ecou)
        tevdw=tevdw+etime(tarray)-tnow
	egfd=egfd+evdw+ecou
        tnow=etime(tarray)
	call egcons(ntot,x,econ)
        tecon=tecon+etime(tarray)-tnow
	egfd=egfd+econ
	egf=egfd
c
c   Energy printout if requested
c
	ncalls=ncalls+1
	if (nenout.ne.0.and.ncalls.gt.0) then
	   if (abs(egf).lt.1D6) then
	      fmt='(i5,7(f10.2))'
	   else
	      fmt='(i5,7(e10.3))'
	   end if
	   if (mod(ncalls,nenout).eq.1.or.nenout.eq.1) then
	      if (negr.gt.0) write(21,fmt) ncalls,
     *                           egf,
     *                           ebnd,
     *                           eang,
     *                           etors,
     *                           epla,
     *                           evdw,
     *                           ecou

	      write(6,fmt) ncalls,
     .	            egf,
     .              ebnd,
     .              eang,
     .              etors,
     .              epla,
     .              evdw,
     .	            ecou
	      if (xout) then
		 call xputmol(ntot,x)
	      end if
#ifndef altix
	      call flush(6)
#endif
	      if (save.and.ebest.gt.egf) then
	         call putmol(ntot,x)
	         ebest=egf
	      end if
	   end if
	end if
c
c   Sum partial gradient to total gradient, convert to generalized coordinates
c
	do i=1,3
	   do j=1,ntot
	      do k=2,nproc
	         gr_1p(i,j,1)=gr_1p(i,j,1)+gr_1p(i,j,k)
	      end do
	   end do
	end do
	call dxyz2dpar(gr_1p,gr)
c
c   done...
c
        tetot=tetot+etime(tarray)-ttnow
	return
	end
