c     Bondlist
c     
      integer nbnd              ! number of bonds
      integer bnd(2,mbtot)      ! 2 atoms that form bond
      integer bndt(mbtot)       ! numeric bond type
      real*8  bndl0(mbtot)      ! equilibrium bondlength
      real*8  bndl(mbtot)       ! effective bondlength
      real*8  kbnd(mbtot)       ! force constant
c     
      common /bond/ bndl0,bndl,kbnd,nbnd,bnd,bndt
c     
c     List of bondangles
c     
      integer nang              ! number of bondangles
      integer ang(3,mantot)     ! atoms that form angle
      real*8  angl0(mantot)     ! equilibrium angle
      real*8  angl(mantot)      ! effective angle
      real*8  kang(mantot)      ! force constant
c     
      common /angle/ ang,angl0,angl,kang,nang
c     
c     List of torsionangles
c     
      integer ntor              ! number of torsionangles
      integer tor(4,mtotot)     ! 4 atoms that form angle
      integer tort(mtotot)      ! bnd type of central bond
      real*8  tora(mtotot)      ! torsion angle
      real*8  tor0(mtotot)      ! equlibrium angle (for kzf .eq. -1)
      integer ntortrm(mtotot)   ! number of fourier terms
      integer tortp(mxft,mtotot)! types of fourier terms
c
      integer ntortp            ! number of torsion types
      real*8  kzt(mtotyp)       ! forceconstant
      real*8  kzs(mtotyp)       ! phase shift
      integer kzf(mtotyp)       ! frequency of potential
c     
      common /tors/ tora,tor0,kzt,kzs,kzf,ntor,tor,tort,
     .     ntortrm,tortp,ntortp
c     
c     List of out of plane bends / improper torsions
c     
      integer npla              ! number of planes
      integer pla(4,mplane)     ! 4 atoms of plane
      real*8  plad(mplane)      ! plane deformation
      real*8  kpla(mplane)      ! forceconstant
      real*8  pla0(mplane)      ! equilibrium value (improper torsion)
c     
      common /plane/ plad,kpla,pla0,npla,pla
c     
c     List of distance constraints
c     
      integer ncon              ! number of distance constraints
      integer atcon(2,mconst)   ! atomnumbers of const. pair
      real*8  dlow(mconst)      ! lower bound on distance
      real*8  dhigh(mconst)     ! upper bound
      real*8  kcon(mconst)      ! force constant
      real*8  dcon(mconst)      ! distance 
      real*8  epen(mconst)      ! energy
c     
      common /constr/ dlow,dhigh,kcon,dcon,epen,ncon,atcon
c     
c     List of angle constraints
c     
      integer ncona             ! number of distance constraints
      integer atcona(3,mconsta) ! atomnumbers of const. pair
      real*8  dlowa(mconsta)    ! lower bound on distance
      real*8  dhigha(mconsta)   ! upper bound
      real*8  kcona(mconsta)    ! force constant
      real*8  dcona(mconsta)    ! angle
      real*8  epena(mconsta)    ! energy
c     
      common /constra/ dlowa,dhigha,kcona,dcona,epena,ncona,atcona
c     
c     List of xy-projection distance constraints
c     
      integer nconp             ! number of distance constraints
      integer atconp(2,mconstp) ! atomnumbers of const. pair
      real*8  dtargp(mconstp)   ! target for distance in xy-proj.
      real*8  kconp(mconstp)    ! force constant
      real*8  dconp(mconstp)    ! distance 
      real*8  epenp(mconstp)    ! energy
      real*8  sprj              ! global scale for dtargp
c     
      common /constrp/ dtargp,kconp,dconp,epenp,sprj,nconp,atconp
c     
c     List of dihedral constraints
c     
      integer ncond             ! number of dihedral constraints
      integer atcond(4,mconstd) ! atomnumbers of const.
      real*8  dlowd(mconstd)    ! lower bound on dihedral
      real*8  dhighd(mconstd)   ! upper bound
      real*8  kcond(mconstd)    ! force constant
      real*8  dcond(mconstd)    ! dihedral angle 
      real*8  epend(mconstd)    ! energy
c     
      common /constrd/ dlowd,dhighd,kcond,dcond,epend,ncond,atcond
c     
c     List of chirality constraints
c     
      integer nconc             ! number of chirality constraints
      integer atconc(4,mconstc) ! atomnumbers of constraints
      real*8  volmin(mconstc)   ! minimum volume
      real*8  vcon(mconstc)     ! volume (current geometry)
      real*8  epenc(mconstc)    ! penalty
      real*8  kconc(mconstc)    ! force constant
c     
      common /constrc/ volmin,vcon,epenc,kconc,atconc,nconc
c
c     Definition of harmonic positional constraints
c
      integer nconx             ! number of positional constraints
      integer atconx(matot)     ! atom numbers involved in constraints
      real*8  xconx(3,matot)    ! target position
      real*8  kconx(matot)      ! force constant
      real*8  dconx(matot)      ! distance from target
      real*8  tconx(matot)      ! tolerated deviation from target
      real*8  uconx(matot)      ! switch to linear penalty beyond this point
      real*8  epenx(matot)      ! penalty
c
      common /constrx/ xconx,kconx,dconx,tconx,uconx,epenx,nconx,atconx
c     
c     Definition of Aggregates... (currently only 1)
c     
      integer ntot              ! total number of atoms
      integer nfix              ! number of fixed (agg=1)
      integer agg(matot)        ! aggregate number of atom
c     
      common /aggdef/ ntot,nfix,agg
c     
c     Partial energies due to bonds, angles, torsions...
c     
      real*8  ebnd,eang,etors,evdw,ecou,epla,econ,rms_g,fmax_g
      real*8  ebest
c     
      common /energy/ ebnd,eang,etors,evdw,ecou,epla,econ,
     .     rms_g,fmax_g,ebest
c     
c     Non-bonded list
c     
      real*8  xnbl(3,matot)     ! x for which nblst is valid
      logical*4 nbl_valid       ! valid nb-list ?
      integer nexcl             ! number of exclusions
      integer nhb14             ! number of 1-4 HBs or other special
      integer LJ(matot)         ! LJ atom type
      integer iij(mxexcl)       ! exclusion pair
      integer hb14(mtotot)      ! 1-4 HB or other special
      integer expt(0:matot)     ! pointer into exclusion list
      integer hbpt(0:matot)     ! pointer into hb14 list
      real*8 FPEPS0             ! 1/4piEpsilon0 (almost a constant...)
c     
      common /nonbnd/ FPEPS0,xnbl,nbl_valid,nexcl,nhb14,LJ,
     .     hb14,iij,expt,hbpt
c     
c     Per processor buffers for energy and gradient
c     
      real*8  e_1p(mxproc),gr_1p(3,matot,mxproc)
      real*8  e_1pc(mxproc)
c     
      common /multip/ e_1p,e_1pc,gr_1p
c     
c     Timing common
c     
      real tetot,tebond,tebend,teang,tetors,tecou,tevdw,
     .     tecon,tarray(2),tgnblst
      common /times/ tetot,tebond,tebend,teang,tetors,
     .     tecon,tecou,tevdw,tarray,tgnblst
