      logical function getmol(nat,name,coord,nres,respt,
     .                    ntype,chr,chrgok,nbnds,bnd,bndt)
c
c   Copy molecular description from SYBYL-common to internal data structure
c
#include "sizes.h"
#include "sybcom.h"             
#include "option.h"
#include "apara.h"
#include "renumber.h"
c
      integer*4    nat,ntype(matot),nbnds,bnd(2,mbtot),bndt(mbtot)
      integer*4    nres,respt(matot)
      real*8       coord(3,matot),chr(matot)
      character    name(matot)*8
      logical      chrgok
c     
c     Assume no dummy atoms etc...
c     
      getmol=.TRUE.
      nat=nnew
      if (nat.gt.matot) then
         write(6,'(a)') ' Too many atoms for Minimax'
         getmol=.FALSE.
         return
      end if
      do i=1,nold
         nr=new(i)
         if (new(i).gt.0) then
            do k=1,3
               coord(k,nr)=xyz(k,i)
            end do
            name(nr)=natlab(i)
            ntype(nr)=natp(i)
            if (chfl) chr(nr)=chrg(i)
         end if
      end do
c     
c     Convert old (3.x) numeric atomtypes to new (5.x) atomtypes
c     
      do i=1,nat
         do j=1,n_atype
            if (old_type(j).eq.ntype(i)) then
               ntype(i)=j
               go to 10
            end if
         end do
         write(6,*) 'Error : unknown atomtype : ',ntype(i)
         getmol=.FALSE.
         return
 10      continue
      end do
c     
c     Renumber and copy bonds; ignore non-chemical bonds...
c     
      nbnds=0 
      do j=1,nbond
         if (new(nbnd(1,j)).gt.0.and.new(nbnd(2,j)).gt.0) then
            nbnds=nbnds+1
            if (nbnds.le.mbtot) then
               bnd(1,nbnds)=new(nbnd(1,j))
               bnd(2,nbnds)=new(nbnd(2,j))
               do k=1,n_btype
                  if (nbndtp(j).eq.bnd_id(k)) then
                     bndt(nbnds)=k
                     go to 20
                  end if
               end do
               write(6,*) 'Error : unknown bond type : ',nbndtp(j)
               getmol=.FALSE.
               return
 20            continue
               if (.not.chem_bnd(bndt(nbnds))) nbnds=nbnds-1
            end if
         end if
      end do
      if (nbnds.gt.mbtot) then
         write(6,'(a)') ' Too many bonds for Minimax'
         getmol=.FALSE.
         return
      end if
c
c     Initialize some data in /apara/ common
c
      do j=1,n_atype
         rvdw(j)=-1    ! "missing" value (for normal and 1-4)
      end do
c     
c     Does the molecule have valid charges ?
c     
      chrgok=chfl
c     
c     done...
c     
      getmol=.TRUE.
      return
      end
