      logical recursive function gnblst_1p(p,w)
c     
c     Generate non bonded interaction list (1 processor slice)
c     
      implicit none
c     
#include "sizes.h"
#include "energy.h"
#include "option.h"
#include "atom.h"
#include "apara.h"
c     
      integer p,w,i,j,k,l,n
      integer lsat(matot),nbliststore
      real*8 dx,dy,dz,d,cs
c     
      gnblst_1p=.TRUE.
      cs=(cutoff+cutmrg)*(cutoff+cutmrg)
c      
      do i=p+1,nat,w
         if (hbs(i).lt.0) then        ! note hbs(i).ne.0 ony for TAFF
            do j=1,i-1
               if (hbs(j).gt.0) then
                  lsat(j)=2
               else
                  lsat(j)=1
               end if
            end do
            do k=hbpt(i-1)+1,hbpt(i)
               lsat(hb14(k))=1
            end do
            do k=expt(i-1)+1,expt(i)
               lsat(iij(k))=0
            end do
         else if (hbs(i).gt.0) then
            do j=1,i-1
               if (hbs(j).lt.0) then
                  lsat(j)=2
               else
                  lsat(j)=1
               end if
            end do
            do k=hbpt(i-1)+1,hbpt(i)
               lsat(hb14(k))=1
            end do
            do k=expt(i-1)+1,expt(i)
               lsat(iij(k))=0
            end do
         else
            do j=1,i-1
               lsat(j)=1
            end do
            if (fftype.eq.'CHARMM') then
               do k=hbpt(i-1)+1,hbpt(i)
                  lsat(hb14(k))=2      ! mark 1-4 interactions
               end do
            end if
            do k=expt(i-1)+1,expt(i)
               lsat(iij(k))=0
            end do
         end if
         if (agg(i).ne.0) then
            do j=1,i-1
               if (agg(j).eq.agg(i)) lsat(j)=0
            end do
         end if
         if (cutoff.lt.1.e30) then
            n=i-1
            do j=1,i-1
               if (lsat(j).gt.0) then
                  dx=xnbl(1,i)-xnbl(1,j)
                  dy=xnbl(2,i)-xnbl(2,j)
                  dz=xnbl(3,i)-xnbl(3,j)
                  d=dx*dx+dy*dy+dz*dz
                  if (d.ge.cs) lsat(j)=0
               end if
               if (lsat(j).eq.0) n=n-1
            end do
         else
            n=i-1
            do j=1,i-1
               if (lsat(j).eq.0) n=n-1
            end do
         end if
c     
         gnblst_1p=gnblst_1p.and.(n.eq.nbliststore(i,lsat))
      end do
c
      return
      end
