#ifdef noBLAS

/* Minimum BLAS needed by by some minimizers, included if BLAS lib. no available */
/* We expect these functions to be called from FORTRAN...                        */

double ddot_(int *n,double *x,int *incx,double *y,int *incy)
{
  /* scalar product of two vectors */

  double r=0.0;
  int i,j,ix,iy;

  if (*n>0) {
    if (*incx==1 && *incy==1) {
      for (i=0;i<*n%4;i++) r+=x[i]*y[i];
      for (j=0;j<*n/4;j++) 
	for (;i<*n;i+=4) 
	  r+=x[i]*y[i]+x[i+1]*y[i+1]+x[i+2]*y[i+2]+x[i+3]*y[i+3];
    }else{
      ix=(incx<0 ? (-*n+1) * *incx : 0);
      iy=(incy<0 ? (-*n+1) * *incy : 0);
      for (i=0;i<*n;i++) {
	r+=x[ix]*y[iy];
	ix+=*incx;
	iy+=*incy;
      }
    }
  }
  return(r);
}

void daxpy_(int *n,double *a,double *x,int *incx,double *y,int *incy)
{
  int i,j,ix,iy;

  /* y=a*x+y, for scalar a and vecrors x,y */

  if (*n>0 && *a != 0.0) {
    if (*incx==1 && *incy==1) {
      for (i=0;i<*n%4;i++) y[i]+=*a*x[i];
      for (j=0;j<*n/4;j++) {
	for (;i<*n;i+=4) {
	  y[i]+=*a*x[i];
	  y[i+1]+=*a*x[i+1];
	  y[i+2]+=*a*x[i+2];
	  y[i+3]+=*a*x[i+3];
	}
      }
    }else{
      ix=(incx<0 ? (-*n+1) * *incx : 0);
      iy=(incy<0 ? (-*n+1) * *incy : 0);
      for (i=0;i<*n;i++) {
	y[iy]+=*a*x[ix];
	ix+=*incx;
	iy+=*incy;
      }
    }
  }
  return;
}

#endif
