      integer*4 function mol2wr(nin,nout)
c
c     write new generation of sybyl.mol2 file.
c
      implicit none
#include "sizes.h"
#include "sybcom.h"
c
      integer*4 nin,nout
      character*4096 large
      character*80 fld,afld(10)
      integer nat_x,in,pos,ciogetrec,alen(10),ciogetfld,ciofgets,
     .     i
      logical in_atom_section,in_wnp
c
      mol2wr=1
c
c write comment records at the beginning...
c
      call ciofputs(nout,'#   MOL2 File generated by MINIMAX',34)
      call ciofputs(nout,char(10),1)
c
c copy all records, if atom data, merge with new coordinates...
c
      nat_x=0
      mol2wr=0
      in=1
      in_atom_section=.false.
      in_wnp=.false.
      do while (mol2wr.eq.0.and.in.gt.0) 
         if (in_atom_section) then
            in=ciogetfld(nin,fld,80)
            if (in.gt.0) then
               if (fld(1:8).eq.'#<Wit!P>') then
                  in_wnp=.true.
                  call ciofputs(nout,fld,in)
                  in=ciogetrec(nin,large,4096)
                  if (in.gt.0) then
                     call ciofputs(nout,' ',1)
                     call cioputrec(nout,large)
                  else
                     call ciofputs(nout,char(10),1)
                  end if
               else if (fld(1:1).eq.'@') then
                  call ciofputs(nout,fld,in)
                  call ciofputs(nout,char(10),1)
                  call str_upcase(fld(1:13),fld(1:13))
                  in_atom_section=(fld(1:13).eq.'@<TRIPOS>ATOM')
                  in_wnp=.false.
               else if (fld(1:1).eq.'#'.and.in_wnp) then
                  call ciofputs(nout,fld,in)
                  in=ciogetrec(nin,large,4096)
                  if (in.gt.0) then
                     call ciofputs(nout,' ',1)
                     call cioputrec(nout,large)
                  else
                     call ciofputs(nout,char(10),1)
                  end if
               else if (fld(1:1).ne.'#') then
                  in_wnp=.false.
                  nat_x=nat_x+1
                  pos=0
                  do i=1,10
                     if (in.gt.0) then
                        if (mod(pos,6).ne.0.and.i.gt.1) then
                           alen(i-1)=alen(i-1)+6-mod(pos,6)
                           pos=pos+6-mod(pos,6)
                        end if
                        afld(i)=fld
                        alen(i)=in+1
                     else
                        alen(i)=0
                        afld(i)=' '
                     end if
                     pos=pos+alen(i)
                     in=ciogetfld(nin,fld,80)
                  end do
                  do i=1,3
                     write(afld(2+i),'(f9.5,1x)') xyz(i,nat_x)
                     alen(2+i)=10
                     if (afld(2+i)(1:1).eq.'*') then
                        write(afld(2+i),'(f18.5,1x)') xyz(i,nat_x)
                        alen(2+i)=19
                     end if
                  end do
                  alen(10)=alen(10)-1       ! trailing space would be fatal
                  do i=1,10
                     if (afld(i)(1:1).ne.' '.or.i.le.5) then
                        call ciofputs(nout,afld(i),alen(i))
                     end if
                  end do
                  call ciofputs(nout,char(10),1)
                  in=alen(6)-1
               end if
            else if (in.eq.0) then
               in=1
               in_wnp=.false.
               call ciofputs(nout,char(10),1)
            end if
            if (.not.in_wnp) call ciofskip(nin,1) ! in_wnp: \n is consumed
         else
            in=ciogetrec(nin,large,4096)
            if (in.gt.0) then 
               if (large(1:8).eq.'#<Wit!P>') in_wnp=.true.
               if (in_wnp) then
                  if (large(1:1).eq.'#') then
                     call cioputrec(nout,large)
                  else
                     in_wnp=.false.
                  end if
               end if
               if (large(1:1).ne.'#') call cioputrec(nout,large)
               if (large(1:1).eq.'@') then
                  call str_upcase(fld,large(1:13))
                  in_atom_section=(fld(1:13).eq.'@<TRIPOS>ATOM')
               end if
            else 
               in_wnp=.false.
            end if
         end if
      end do
c      
      return
c
 999  continue
      mol2wr=1
      return
      end
