      subroutine moldmp
c
      implicit none
#include "sizes.h"
#include "renumber.h"
c
      call moldmp_do_it(new,old)
      return
      end
c
      subroutine moldmp_do_it(new,old)
c     
c     Dump molecular data to printfile
c     
      implicit none
#include "sizes.h"
#include "atom.h"
#include "energy.h"
#include "apara.h"
#include "worksp.h"
c     
      integer new(*),old(*)
      real*8     force(3,matot),rms,fmax,s
      integer    i,k,n
      equivalence (work,force)
c     
c     Write Heading
c     
      write(21,'(a)') char(12)  ! Start on a new page
      write(21,'(//a,a/a,a)')
     *     '           Atom                    Coordinates (A)   ',
     *     '                       Force (mdyn)',
     *     '    Nr  Name     Type           x         y         z',
     *     '      Charge      x         y         z'
c     
c     Convert forces to mdyn and compute rms and max
c     
      rms=0.0
      fmax=0.0
      do i=1,nat
         do k=1,3
            force(k,i)=-6.947805*force(k,i)*1.0E-3
            rms=rms+force(k,i)**2
            fmax=max(fmax,abs(force(k,i)))
         end do
      end do
      rms=sqrt(rms/(3*nat))
      rms_g=rms
      fmax_g=fmax
c     
c     Write Data for molecular parameters.
c     
      do i=1,nat
         n=old(i)
         write(21,'(i6,2x,a8,1x,a8,1x,3f10.3,f10.5,3f10.4)')
     *        n,name(i),amnem(ntype(i)),(xyz(k,i),k=1,3),chrg(i),
     *        (force(k,i),k=1,3)
      end do
      write(21,'(/a,f10.5/a,f10.5)')
     *     '   Gradient r.m.s (mdyn) : ',rms,
     *     '      "     max.  (mdyn) : ',fmax
      if (ncon.gt.0) then
         write(21,'(//a/a,a)')
     *        '                    Distance Constraint Violations',
     *        '   Nr   from    to     dmin        d    dmax',
     *        '       Energy Force const.'
         do i=1,ncon
            write(21,'(i5,i7,i6,f9.2,f9.2,f8.2,f13.2,f13.2)')
     *           i,old(atcon(1,i)),old(atcon(2,i)),dlow(i),dcon(i),
     *           dhigh(i),epen(i),kcon(i)
         end do
      end if
      if (ncona.gt.0) then
         write(21,'(//a/a,a)')
     *        '                    Angle Constraint Violations',
     *        '   Nr   at-1  at-2  at-3     amin       a    amax',
     *        '       Energy Force const.'
         do i=1,ncona
            write(21,'(i5,i7,i6,i6,f9.2,f8.2,f8.2,f13.2,f13.2)') i,
     *           old(atcona(1,i)),old(atcona(2,i)),old(atcona(3,i)),
     *           dlowa(i),dcona(i),dhigha(i),epena(i),kcona(i)
         end do
      end if
      if (nconp.gt.0) then
         if (sprj.gt.0) then
            s=1/sprj
         else
            s=1.0
         end if
         write(21,'(//,a/a,a)')
     *        '                    Projection Constraint Violations',
     *        '  Nr   from    to    dtarg     s*d       Energy',
     *        '  Force const.'
         do i=1,nconp
            write(21,'(i5,i7,i6,f9.2,f8.2,f13.2,f13.2)')
     *           i,old(atconp(1,i)),old(atconp(2,i)),dtargp(i),
     *           s*dconp(i),epenp(i),kconp(i)
         end do
         write(21,'(a,f10.4)') 
     .        ' Scale for target distances: ',sprj
      end if
      if (ncond.gt.0) then
         write(21,'(//a/a,a)')
     *        '                    Dihedral  Constraint Violations',
     *        '   Nr     n1    n2    n3    n4     dmin        d     ',
     *        'dmax       Energy   Force const.'
         do i=1,ncond
            write(21,'(i6,4i6,f9.2,f9.2,f9.2,f13.2,f13.2)')
     *           i,(old(atcond(k,i)),k=1,4),dlowd(i),dcond(i),
     *           dhighd(i),epend(i),kcond(i)
         end do
      end if
      if (nconc.gt.0) then
         write(21,'(//a/a,a)')
     *        '                    Chirality  Constraint Violations',
     *        '  Nr     n1    n2    n3    n4      V       Vmin     ',
     *        '  Energy   Force const.'
         do i=1,nconc
            write(21,'(i5,4i6,f9.2,f9.2,f13.2,f13.2)')
     *           i,(old(atconc(k,i)),k=1,4),vcon(i),
     *           volmin(i),epenc(i),kconc(i)
         end do
      end if
      if (nconx.gt.0) then
         write(21,'(//a/a,a)')
     *        '                    Positional Constraint Violations',
     *        '    Nr   Atom  Distance   Energy  Force const.'
         do i=1,nconx
            write(21,'(i6,i7,f10.2,f9.2,f12.2)')
     *           i,old(atconx(i)),dconx(i),epenx(i),kconx(i)
         end do
      end if
c     
c     Done...
c     
      write(21,'(//)')
      return
      end
