      real*8 function onestep(nat,xyz)
c
      implicit none
#include "sizes.h"
#include "worksp.h"

      integer nat,npar,i,xyz2par,nfunc,K
      real*8 e0,en,em,s,sm,dmax,up,xyz(*),egf
      
c     Called for before minimizer, if max. gradient is large
c     Tries up top 5 steepest descent steps, with upper bound
c     on max. coordinate shift, to get a decent estimate of the
c     DFN parameter of VA14A.
      
      onestep=1
      K=0
      npar=xyz2par(xyz,work)
      s=1
      up=0.2    ! max delta-x allowed
      e0=egf(npar,work,work(3*nat+1))
      do while(onestep.gt.0.and.K.lt.5)
         do i=1,npar
            work(6*nat+i)=work(+i)-s*work(3*nat+i)
         end do
         call par2xyz(work(6*nat+1),work(9*nat+1))
         dmax=0
         do i=1,3*nat
            dmax=max(dmax,abs(xyz(i)-work(9*nat+i)))
         end do
         s=s*up/dmax
c
         nfunc=0
         em=abs(1.01*e0)
         do while(em.gt.e0.and.nfunc.lt.20)
            do i=1,npar
               work(6*nat+i)=work(i)-s*work(3*nat+i)
            end do
            en=egf(npar,work(6*nat+1),work(12*nat+1))
            if (en.lt.em) then
               sm=s
               em=en
            endif
            nfunc=nfunc+1
            s=0.5*s
         end do
         if (e0.gt.em) then
            onestep=e0-em
            do i=1,npar
               work(i)=work(i)-sm*work(3*nat+i)
               work(3*nat+i)=work(12*nat+i)
            end do
            call par2xyz(work,xyz)
            s=s*4
            e0=em
         else
            onestep=0
         end if
         K=K+1
      end do
      return
      end
