	subroutine par2xyz(p,x)
c
c  Compute cartesian coordinates x from optimization parameters p
c
c  This is currently simply a projection: if agg(i)=1, the atom is fixed,
c  coordinates of this atom do not appear in p.
c
	implicit none
#include "sizes.h"
#include "atom.h"
#include "energy.h"
#include "option.h"
	real*8	x(3,*),p(*)
c
	integer i,j,k
c
	k=0
	do i=1,ntot
	   if (agg(i).eq.1) then
	      do j=1,3
		 x(j,i)=xyz(j,i)
	      end do
	   else
	      do j=1,3
		 k=k+1
		 x(j,i)=p(k)
	      end do
	   end if
	end do
	return
	end
c------------------------------------------------------------------------

	subroutine dpar2dxyz(dEdp,dEdx)
c
c  Convert dE/dp to dE/dx
c
	implicit none
#include "sizes.h"
#include "energy.h"
#include "option.h"
	real*8	dEdx(3,*),dEdp(*)
c
	integer i,j,k
c
	k=0
	do i=1,ntot
	   if (agg(i).eq.1) then
	      do j=1,3
		 dEdx(j,i)=0.0
	      end do
	   else
	      do j=1,3
		 k=k+1
		 dEdx(j,i)=dEdp(k)
	      end do
	   end if
	end do
	return
	end
c------------------------------------------------------------------------

	integer function  xyz2par(x,p)
c
c  Compute optimization parameters p from cartesian coordinates x
c  Return number of optimization parameters
c
	implicit none
#include "sizes.h"
#include "energy.h"
#include "option.h"
	real*8	x(3,*),p(*)
c
	integer i,j,k
c
	k=0
	do i=1,ntot
	   if (agg(i).eq.0) then
	      do j=1,3
		 k=k+1
		 p(k)=x(j,i)
	      end do
	   end if
	end do
	xyz2par=k
	return
	end
c------------------------------------------------------------------------

	subroutine dxyz2dpar(dEdx,dEdp)
c
c  Convert dE/dx to dE/dp 
c
	implicit none
#include "sizes.h"
#include "energy.h"
#include "option.h"
	real*8	dEdx(3,*),dEdp(*)
c
	integer i,j,k
c
	k=0
	do i=1,ntot
	   if (agg(i).eq.0) then
	      do j=1,3
		 k=k+1
		 dEdp(k)=dEdx(j,i)
	      end do
	   end if
	end do
	return
	end
