      subroutine putmol(nat,coord)
c     
c     Put optimized coordinates back to SYBYL datastructure and
c     write new .MOL file
c     
      implicit none
#include "sizes.h"
#include "option.h"
#include "sybcom.h"
#include "renumber.h"
      integer*4   nat
      real*8      coord(3,matot)
      character*80 extfil*132,cmdlin*132,outfile*132
      integer*4 nin,nout,status,ciofopen,mol2wr,i,l
      logical replace
c     
c     Copy coords to SYBCOM
c     
      do i=1,nnew
         do l=1,3
            xyz(l,old(i))=coord(l,i)
         end do
      end do
c     
c     Write the new file
c     
      status=1
      if (ismol2) then
         nin=ciofopen(molfile,'r')
         if (nin.ge.0) then
            outfile=molfile
            cmdlin=extfil(molfile,'.min',.true.)
            call ztrimm(cmdlin,len(cmdlin))
            if (cmdlin.eq.molfile) outfile=extfil(molfile,'.mol',.true.)
            cmdlin=extfil(molfile,'.tmp',.true.)
            call ztrimm(cmdlin,len(cmdlin))
            nout=ciofopen(cmdlin,'w')
            if (nout.ge.0) then
               status=mol2wr(nin,nout)
               call ciofclose(nin)
               call ciofclose(nout)
               if (status.ne.0) then
                  call unlink(extfil(molfile,'.tmp',.true.))
               else
                  call unlink(outfile)
                  call rename(extfil(molfile,'.tmp',.true.),
     .                 outfile)
               end if
            else
               call ciofclose(nin)
            end if
         end if
      end if
c
      if (status.ne.0) then
         outfile=molfile
         cmdlin=extfil(molfile,'.min',.true.)
         call ztrimm(cmdlin,len(cmdlin))
         if (cmdlin.eq.molfile) outfile=extfil(molfile,'.mol',.true.)
         call unlink(outfile)
         open(unit=22,file=outfile,
     .        status='new')
         call molwr(22)
         close(unit=22)
      end if
c
c   done...
c
      return
      end
c========================================================================
      subroutine xputmol(nat,coord)
c     
c     Write current coordinates to stdout
c     
      implicit none
#include "sizes.h"
#include "option.h"
#include "sybcom.h"
#include "renumber.h"
      integer*4   nat
      real*8      coord(3,matot)
      integer*4 i,l,n
      character*256 line
c     
c     Copy coords to SYBCOM
c     
      write(6,'(a)') 'X> BEGIN'
      do i=1,nnew
         do l=1,3
            xyz(l,old(i))=coord(l,i)
         end do
      end do
c     
c     Write the new file
c     
      do i=1,nold
         line=' '
         write(line,'(A,3(1x,f20.5))') 'X> ',(xyz(l,i),l=1,3)
         n=0
         do l=1,256
            if (line(l:l).eq.' ') then
               if (n.eq.0) then
                  n=n+1
                  line(n:n)=line(l:l)
               else if (line(n:n).ne.' ') then
                  n=n+1
                  line(n:n)=line(l:l)
               end if
            else
               n=n+1
               line(n:n)=line(l:l)
            end if
         end do
         write(6,'(A)') line(1:n)
      end do
      write(6,'(a)') 'X> END'
c
c   done...
c
      return
      end
