      logical function readcon()
c     
c     Read distance constraints from .CON file...
c     
      implicit none
#include "sizes.h"
#include "apara.h"
#include "atom.h"
#include "energy.h"
#include "option.h"
#include "renumber.h"
c     
      integer i,i1,i2,i3,i4,state,olds,b,t,tmpagg(matot),nums(256)
      logical newcond
      real*8  rk,du,dl,p(6)
      character*256 line
c     
      ncon=0
      ncond=0
      ncona=0
      nconp=0
      nconc=0
      nconx=0
      ntot=nat
      nfix=0
      do i=1,matot
         tmpagg(i)=0
      end do
      do i=1,256
         nums(i)=0
      end do
      readcon=.TRUE.
      state=1
      olds=0
 1    continue
      read(1,'(a)',end=9000) line
      b=index(line,char(13))
      if (b.gt.0) line(b:b)=' '
      do i=1,132
         if (line(i:i).eq.char(9)) line(i:i)=' '
      end do
      olds=state
      state=0
      if (line(1:1).eq.'C'.or.line(1:1).eq.'c') go to 1
      if (line(1:1).eq.'D'.or.line(1:1).eq.'d') state=2
      if (line(1:1).eq.'T'.or.line(1:1).eq.'t') state=3
      if (line(1:1).eq.'E'.or.line(1:1).eq.'e') state=4
      if (line(1:1).eq.'V'.or.line(1:1).eq.'v') state=5
      if (line(1:1).eq.'P'.or.line(1:1).eq.'p') state=6
      if (line(1:1).eq.'A'.or.line(1:1).eq.'a') state=7
      if (line(1:1).eq.'F'.or.line(1:1).eq.'f') state=8
      if (line(1:1).eq.'X'.or.line(1:1).eq.'x') state=9
      if (state.eq.0) then
         b=1
         state=olds
      else
         b=index(line,' ')
         if (b.eq.0) b=1
      end if
      if (line(b:).eq.' ') go to 1
      go to (9100,10,100,9000,110,120,130,140,150) state
c     
c     Dist
c     
 10   continue
      read(line(b:),*,end=9100,err=9100) i1,i2,dl,du,rk
      if(ncon.eq.mconst) then
         write(6,'(a)') ' Too many distance constraints...'
         readcon=.FALSE.
         return
      end if
      ncon=ncon+1
      atcon(1,ncon)=i1
      atcon(2,ncon)=i2
      dlow(ncon)=dl
      dhigh(ncon)=du
      kcon(ncon)=rk
      if (rk.lt.0.0.or.dl.lt.0.0.or.du.lt.0.0.or.
     *     du.lt.dl) then
         write(6,'(a,2i6,2f8.2,f10.2)') 
     *        ' Bad constraint: D',i1,i2,dl,du,rk
         readcon=.FALSE.
         return
      end if
      go to 1
c     
c     Tors
c     
 100  continue
      read(line(b:),*,end=9100,err=9100) i1,i2,i3,i4,dl,du,rk
      if(ncond.eq.mconstd) then
         write(6,'(a)') ' Too many torsion constraints...'
         readcon=.FALSE.
         return
      end if
      ncond=ncond+1
      atcond(1,ncond)=i1
      atcond(2,ncond)=i2
      atcond(3,ncond)=i3
      atcond(4,ncond)=i4
      dlowd(ncond)=dl
      dhighd(ncond)=du
      kcond(ncond)=rk
      if (rk.lt.0.0.or.du.lt.dl) then
         write(6,'(a,4i6,2f8.2,f10.2)') 
     *        ' Bad constraint: T',i1,i2,i3,i4,dl,du,rk
         readcon=.FALSE.
         return
      end if
      if (dl.lt.-180.0.or.dl.gt.180.0) then
         write(6,'(a,4i6,2f8.2,f10.2)') 
     *        ' Bad constraint: T',i1,i2,i3,i4,dl,du,rk
         readcon=.FALSE.
         return
      endif
      go to 1
c     
c     Volume
c     
 110  continue
      read(line(b:),*,end=9100,err=9100) i1,i2,i3,i4,dl,rk
      if(ncond.eq.mconstc) then
         write(6,'(a)') ' Too many volume constraints...'
         readcon=.FALSE.
         return
      end if
      nconc=nconc+1
      atconc(1,nconc)=i1
      atconc(2,nconc)=i2
      atconc(3,nconc)=i3
      atconc(4,nconc)=i4
      volmin(nconc)=dl
      kconc(nconc)=rk
      if (rk.lt.0.0.or.dl.lt.0) then
         write(6,'(a,4i6,f8.2,f10.2)') 
     *        ' Bad constraint: V',i1,i2,i3,i4,dl,rk
         readcon=.FALSE.
         return
      end if
      go to 1
c     
c     Dist in xy-projection:
c     
 120  continue
      read(line(b:),*,end=9100,err=9100) i1,i2,dl,rk
      if(nconp.eq.mconstp) then
         write(6,'(a)') ' Too many projection constraints...'
         readcon=.FALSE.
         return
      end if
      nconp=nconp+1
      atconp(1,nconp)=i1
      atconp(2,nconp)=i2
      dtargp(nconp)=dl
      kconp(nconp)=rk
      if (rk.lt.0.0.or.dl.lt.0.0) then
         write(6,'(a,2i6,f8.2,f10.2)') 
     *        ' Bad constraint: P',i1,i2,dl,rk
         readcon=.FALSE.
         return
      end if
      go to 1
c     
c     Angle constraint:
c     
 130  continue
      read(line(b:),*,end=9100,err=9100) i1,i2,i3,dl,du,rk
      if(ncona.eq.mconsta) then
         write(6,'(a)') ' Too many angle constraints...'
         readcon=.FALSE.
         return
      end if
      ncona=ncona+1
      atcona(1,ncona)=i1
      atcona(2,ncona)=i2
      atcona(3,ncona)=i3
      dlowa(ncona)=dl
      dhigha(ncona)=du
      kcona(ncona)=rk
      if (rk.lt.0.0.or.du.lt.dl) then
         write(6,'(a,3i6,f8.2,f10.2)') 
     *        ' Bad constraint: A',i1,i2,i3,dl,rk
         readcon=.FALSE.
         return
      end if
      go to 1
c     
c     Definition of aggregates
c     
 140  continue
      read(line(b:),*,end=142,err=9100) nums
 142  do i=1,256
         if (nums(i).eq.0) go to 1
         if (nums(i).gt.0.and.nums(i).le.nold) tmpagg(nums(i))=1
         nums(i)=0
      end do
      go to 1
c
c     Harmonic positional restraint
c
 150  continue
      do i=1,6
         p(i)=0
      end do
      read(line(b:),*,end=152,err=9100) i1,p
 152  if (nconx.eq.matot) then
         write(6,'(a)') ' Too many positional constraints...'
         readcon=.FALSE.
         return
      end if
      if (i1.gt.0.and.i1.le.nold) then
         if (p(4).eq.0) then    ! restraint to current position
            do i=1,3
               p(i+3)=p(i)
               p(i)=xyz(i,new(i1))
            end do
         endif
      endif
      if (p(5).lt.0) p(5)=0
      if (p(6).le.1.e-4) p(6)=1.e30
      p(6)=p(5)+p(6)
      nconx=nconx+1
      atconx(nconx)=i1
      do i=1,3
         xconx(i,nconx)=p(i)
      end do
      kconx(nconx)=p(4)
      tconx(nconx)=p(5)
      uconx(nconx)=p(6)
      go to 1
c     
c     Renumber constraints...
c     
 9000 continue
      call newagg(nat,tmpagg,agg)
      do i=1,nat
         if (agg(i).eq.1) nfix=nfix+1
      end do
      readcon=readcon.and.newcond(ncon,atcon,ncond,atcond,nconc,
     *     atconc,nconp,atconp,ncona,atcona,nconx,atconx)
      return
c     
c     error
c     
 9100 continue
      write(6,'(1x,a,a)') ' Bad constraint: ',line(1:50)
      readcon=.FALSE.
      return
      end
c-----------------------------------------------------------------------
      logical function newcond(nd,ad,nt,at,nc,ac,np,ap,na,aa,nx,ax)
c     
c     convert constraints to new atomnumbering, report errors...
c     
      implicit none
#include "sizes.h"
#include "renumber.h"
      integer nd,ad(2,nd),nt,at(4,nt),nc,ac(4,nc),
     .     np,ap(2,np),na,aa(3,na),nx,ax(nx)
c     
      integer i,k
      newcond=.TRUE.
c     
      k=0
      do i=1,nd
         if (ad(1,i).gt.0.and.ad(1,i).le.nold.and.
     .        ad(2,i).gt.0.and.ad(2,i).le.nold) then
            if (new(ad(1,i)).gt.0.and.new(ad(2,i)).gt.0) then
               k=k+1
               ad(1,k)=new(ad(1,i))
               ad(2,k)=new(ad(2,i))
            end if
         else
            write(21,'(a,i6,i6)') ' Cnstr, bad atom number: Distance ',
     .           ad(1,i),ad(2,i)
            write(6,'(a,i6,i6)') ' Cnstr, bad atom number: Distance ',
     .           ad(1,i),ad(2,i)
            newcond=.FALSE.
         end if
      end do
      nd=k
c
      k=0
      do i=1,nx
         if (ax(i).gt.0.and.ax(i).le.nold) then
            if (new(ax(i)).gt.0) then
               k=k+1
               ax(k)=new(ax(i))
            end if
         else
            write(21,'(a,i6)') ' Cnstr, bad atom number: Position ',
     .           ax(i)
            write(6,'(a,i6)') ' Cnstr, bad atom number: Position ',
     .           ax(i)
            newcond=.FALSE.
         end if
      end do
      nx=k
c     
      k=0
      do i=1,np
         if (ap(1,i).gt.0.and.ap(1,i).le.nold.and.
     .        ap(2,i).gt.0.and.ap(2,i).le.nold) then
            if (new(ap(1,i)).gt.0.and.new(ap(2,i)).gt.0) then
               k=k+1
               ap(1,k)=new(ap(1,i))
               ap(2,k)=new(ap(2,i))
            endif
         else
            write(21,'(a,i6,i6)') 
     .           ' Cnstr, bad atom number: Projection ',
     .           ap(1,i),ap(2,i)
            write(6,'(a,i6,i6)') 
     .           ' Cnstr, bad atom number: Projection ',
     .           ap(1,i),ap(2,i)
            newcond=.FALSE.
         end if
      end do
      np=k
c     
      k=0
      do i=1,nt
         if (at(1,i).gt.0.and.at(1,i).le.nold.and.
     .        at(2,i).gt.0.and.at(2,i).le.nold.and.
     .        at(3,i).gt.0.and.at(3,i).le.nold.and.
     .        at(4,i).gt.0.and.at(4,i).le.nold) then
            if (new(at(1,i)).gt.0.and.new(at(2,i)).gt.0.and.
     .           new(at(3,i)).gt.0.and.new(at(4,i)).gt.0) then
               k=k+1
               at(1,k)=new(at(1,i))
               at(2,k)=new(at(2,i))
               at(3,k)=new(at(3,i))
               at(4,k)=new(at(4,i))
            end if
         else
            write(21,'(a,i6,i6,i6,i6)') 
     .           ' Cnstr, bad atom number: Torsion ',
     .           at(1,i),at(2,i),at(3,i),at(4,i)
            write(6,'(a,i6,i6,i6,i6)') 
     .           ' Cnstr, bad atom number: Torsion ',
     .           at(1,i),at(2,i),at(3,i),at(4,i)
            newcond=.FALSE.
         end if
      end do
      nt=k
c     
      k=0
      do i=1,nc
         if (ac(1,i).gt.0.and.ac(1,i).le.nold.and.
     .        ac(2,i).gt.0.and.ac(2,i).le.nold.and.
     .        ac(3,i).gt.0.and.ac(3,i).le.nold.and.
     .        ac(4,i).gt.0.and.ac(4,i).le.nold) then
            if (new(ac(1,i)).gt.0.and.new(ac(2,i)).gt.0.and.
     .           new(ac(3,i)).gt.0.and.new(ac(4,i)).gt.0) then
               k=k+1
               ac(1,i)=new(ac(1,i))
               ac(2,i)=new(ac(2,i))
               ac(3,i)=new(ac(3,i))
               ac(4,i)=new(ac(4,i))
            end if
         else
            write(21,'(a,i6,i6,i6,i6)') 
     .           ' Cnstr, bad atom number: Volume ',
     .           ac(1,i),ac(2,i),ac(3,i),ac(4,i)
            write(6,'(a,i6,i6,i6,i6)') 
     .           ' Cnstr, bad atom number: Volume ',
     .           ac(1,i),ac(2,i),ac(3,i),ac(4,i)
            newcond=.FALSE.
         end if
      end do
      nc=k
c     
      k=0
      do i=1,na
         if (aa(1,i).gt.0.and.aa(1,i).le.nold.and.
     .        aa(2,i).gt.0.and.aa(2,i).le.nold.and.
     .        aa(3,i).gt.0.and.aa(3,i).le.nold) then
            if (new(aa(1,i)).gt.0.and.
     .           new(aa(2,i)).gt.0.and.new(aa(3,i)).gt.0) then
               k=k+1
               aa(1,i)=new(aa(1,i))
               aa(2,i)=new(aa(2,i))
               aa(3,i)=new(aa(3,i))
            end if
         else
            write(21,'(a,i6,i6,i6)') ' Cnstr, bad atom number: Angle ',
     .           aa(1,i),aa(2,i),aa(3,i)
            write(6,'(a,i6,i6,i6)') ' Cnstr, bad atom number: Angle ',
     .           aa(1,i),aa(2,i),aa(3,i)
            newcond=.FALSE.
         end if
      end do
      na=k
c     
      return
      end
c------------------------------------------------------------------------

      subroutine newagg(nat,tmp,agg)
c     
      implicit none
#include "sizes.h"
#include "renumber.h"
c     
      integer tmp(*),agg(*),nat,i
c     
      do i=1,nold
         if (new(i).gt.0.and.new(i).le.nat) agg(new(i))=tmp(i)
      end do
      return
      end
