        logical function readff()
c                               
c   Read force field parameters from FF tables (driver)
c
        implicit none
c
#include "sizes.h"
#include "option.h"
#include "atom.h"
#include "apara.h"
#include "energy.h"
c
        logical readff_charmm,readff_taff
        integer i,j
        real*8 r6,r12
c
        if (fftype.eq.'CHARMM') then
           readff=readff_charmm()
           do i=1,nat
              LJ(i)=ntype(i)
           end do
           n_ljtype=n_atype
        else if (fftype.eq.'TAFF') then
           readff=readff_taff()
           do i=1,nat
              LJ(i)=ntype(i)
           end do
           n_ljtype=n_atype
        else if (fftype.eq.'AMBER') then
           readff=.TRUE.   ! topol_amber has done all the work...
        else
           readff=.FALSE.
        end if
        if (readff.and.vshift) then   ! compute vdW shifting coefficients
           r6=cutoff**(-6)
           r12=cutoff**(-12)
           do i=1,n_atype
              do j=1,i
                 vcij(i,j)=(2*vaij(i,j)*r6+vbij(i,j))*r12
                 vdij(i,j)=-(3*vaij(i,j)*r6+2*vbij(i,j))*r6
                 vcij(j,i)=vcij(i,j)
                 vdij(j,i)=vdij(i,j)
                 vcij14(i,j)=(2*vaij14(i,j)*r6+vbij14(i,j))*r12
                 vdij14(i,j)=-(3*vaij14(i,j)*r6+2*vbij14(i,j))*r6
                 vcij14(j,i)=vcij14(i,j)
                 vdij14(j,i)=vdij14(i,j)
              end do
           end do
        end if
        return
        end
c
c------------------------------------------------------------------------
c
      integer function typeq(t1,t2)
c
#include "sizes.h"
#include "apara.h"
#include "option.h"
c
      integer t1,t2
c
c   How equal are types t1 and t2 ? t1 may be wildcard (t1=0)
c
      if (fftype.eq.'TAFF') then
          typeq=-1000
        if (t1.eq.t2) then
            typeq=100
         else if (t2.gt.0.and.t2.le.n_atype) then
            if (t1.eq.etype(t2)) then
               typeq=90
            else if (t1.eq.0) then
               typeq=10
            end if
         else if (t1.eq.0) then
            typeq=10
         end if
      else if (fftype.eq.'CHARMM') then
         typeq=-1000
         if (t1.eq.t2) then
            typeq=100
         else if (t1.eq.0) then
            typeq=10
         end if
      endif
      return
      end
