      subroutine token(cmd,lcmd,pos,nsep,sep,start,end,term)
c     
c     Find next token in commandbuffer.
c     
c     cmd    : command buffer char*(*)   IN
c     lcmd   : length of command buffer  IN
c     pos    : pointer to next character in cmd IN/OUT
c     nsep   : number of separators  IN
c     sep    : separators char*(sep) IN
c     start  : first character of token  OUT
c     end    : last character of token   OUT
c     term   : separator (<CR> if end-of-buffer). OUT
c     
c     if end < start : token is NUL.
c     
      implicit none
      character cmd*(*),sep*(*),term*1,qc*1
      integer lcmd,pos,nsep,start,end
      logical tok_separator,tok_whitesp,q
c     
c     if nothing in buffer return, else skip whitespace and scan token
c     
      if (pos.gt.lcmd) then
         start=lcmd
         end=start-1
         term=char(13)
      else
         do while(tok_whitesp(cmd(pos:pos)))
            pos=pos+1
            if (pos.gt.lcmd) then
               term=char(13)
               start=lcmd
               end=start-1
               return
            end if
         end do
c     
c     take care of quoted tokens...
c     
         if (cmd(pos:pos).eq.'"'.or.cmd(pos:pos).eq.'''') then
            qc=cmd(pos:pos)
            q=.true.
            pos=pos+1
            if (pos.gt.lcmd) then
               start=lcmd
               end=start-1
               return
            end if
         else
            qc=char(255)
            q=.false.
         end if
         start=pos 
         do while((q .or. .not.tok_separator(nsep,sep,cmd(pos:pos)))  
     .        .and. cmd(pos:pos).ne.qc)
            pos=pos+1
            if (pos.gt.lcmd) then
               end=pos-1
               term=' '
               return
            end if
         end do
         end=pos-1
         term=cmd(pos:pos)
         pos=pos+1
      end if
c     
c     search separator (embedded by whitespace)
c     
      if (tok_whitesp(term)) then
         do while(pos.le.lcmd)
            if (.not.tok_whitesp(cmd(pos:pos))) then
               if (tok_separator(nsep,sep,cmd(pos:pos))) then
                  term=cmd(pos:pos)
                  pos=pos+1
                  return
               end if
               return
            end if
            pos=pos+1
         end do
      end if
      return
      end     
c     
      logical function tok_separator(nsep,sep,ch)
c     
c     Return .true. iff ch is a separator (blank or one of sep(i:i),i=1,nsep)
c     
      implicit none
      integer nsep,i
      character sep*(*) 
      character*1 ch
      logical is_sep,tok_whitesp
c     
      is_sep=tok_whitesp(ch)
      i=0
      do while(.not.is_sep.and.i.lt.nsep)
         i=i+1
         is_sep=ch.eq.sep(i:i)
      end do
      tok_separator=is_sep
      return
      end
c     
      logical function tok_whitesp(c)
c     
c     Return .true. if c is a 'whitespace' character...
c     
      character*1 c
c     
      tok_whitesp=c.eq.' '.or.(ichar(c).ge.9.and.ichar(c).le.13)
      return
      end
