      logical function wldmatch(str,wld)
c
c  Wild-card comparison between regular string str and 
c  wild-card string wld. Uses X-Plor style wildcards:
c
c     '\' is used as a quote character in "wild".
c     '*' matches any number of arbitrary characters.
c     '%' and '?' match a single arbitrary character.
c     '+' matches a single digit.
c     '#' matches a sequence of digits (incl. zero length)
c
c  Comparison is case-sensitive.
c
      character*(*) str,wld
      integer cwldmatch
      integer ls,lw,i
c
      ls=0
      do i=1,len(str)
         if (str(i:i).ne.' ') ls=i
      end do
c
      lw=0
      do i=1,len(wld)
         if (wld(i:i).ne.' ') lw=i
      end do
c
      wldmatch=cwldmatch(str,ls,wld,lw).eq.1
c
      return
      end
