/* Usage:  locfsname <host>:<path>

   Returns local name of <host>:<path>

*/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <mntent.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

int Setenv(char *name,char *value);

int main(int argc,char **argv)
{
  struct mntent *fsent;
  struct hostent *hent;
  FILE *fstab;
  char my_name[200],fn[200],*p,*f,*h;
  const char *his_name;

  if (argc!=2) {
    return(1);
  }

  /* we need to go into DNS first... */

  Setenv("HOSTRESORDER","bind nis local");

  gethostname(my_name,200);
  hent=gethostbyname(my_name);
  hent=gethostbyaddr(hent->h_addr,hent->h_length,hent->h_addrtype);
  strcpy(my_name,hent->h_name);

  h=argv[1];
  if (f=strchr(h,':')) *f++='\0';
  if (!f) {
    return (1);
  }

  hent=gethostbyname(h);

  if (!hent) {
    return(2);
  }
  hent=gethostbyaddr(hent->h_addr,hent->h_length,hent->h_addrtype); /* we need the official name */
  his_name=hent->h_name;

  if (strcmp(his_name,my_name)==0) {
    printf("%s\n",f);
    return(0);
  }

  if (!(fstab=setmntent("/etc/mtab","r"))) {
    return(3);
  }

  for (fsent=getmntent(fstab);fsent;fsent=getmntent(fstab)) {
    if (strcmp(fsent->mnt_type,"nfs")!=0) continue;
    strcpy(fn,fsent->mnt_fsname);
    if (p=strchr(fn,':')) *p++='\0';
    hent=gethostbyname(fn);
    if (!hent) continue;
    hent=gethostbyaddr(hent->h_addr,hent->h_length,hent->h_addrtype);     
    if (strcmp(his_name,hent->h_name)) continue;
    if (strlen(f)>=strlen(p)) {
      if (strncmp(p,f,strlen(p))==0) {
	printf("%s%s\n",fsent->mnt_dir,f+strlen(p));
	return(0);
      }
    }
  }

  return(4);

}
