/* Usage: netfsname <path>

   Returns NFS path name in the form <host>:<path>

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <mntent.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

int Setenv(char *name,char *value);

int main(int argc,char **argv)
{
  struct mntent *fsent;
  FILE *fstab;
  char my_name[200],*f,*h;
  const char *p;

  if (argc!=2) {
    return(1);
  }

  Setenv("HOSTRESORDER","bind nis local");

  gethostname(my_name,200);
  h=my_name;

  if (!(fstab=setmntent("/etc/mtab","r"))) {
    return(3);
  }

  f=argv[1];

  for (fsent=getmntent(fstab);fsent;fsent=getmntent(fstab)) {
    if (strcmp(fsent->mnt_type,"nfs")!=0) continue;
    p=fsent->mnt_dir;
    if (strlen(f)>=strlen(p)) {
      if (strncmp(p,f,strlen(p))==0) {
	if (!f[strlen(p)]||f[strlen(p)]=='/') {
	  printf("%s%s\n",fsent->mnt_fsname,f+strlen(p));
	  return(0);
	}
      }
    }
  }

  printf("%s:%s\n",h,f);
  return(4);
}
