#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>

#define RECSZ 256

int main(int argc,char **argv)
{
  int N,n,i;
  FILE *in,*out;
  char rec[RECSZ],outname[RECSZ];

  if (argc<3) {
    fprintf(stderr,"usage: splitm <bigfile> <prefix>\n");
    return(1);
  }

  in=fopen(argv[1],"r");
  if (!in) {
    fprintf(stderr,"Could not open %s for read\n",argv[1]);
    return(2);
  }

  N=0;
  while (fgets(rec,RECSZ,in)) {
    if (strncmp(rec+5,"MOL",3)!=0) {
      fprintf(stderr,"bad header\n");
      return(3);
    }
    n=atoi(rec);
    N++;
    if (N<10) sprintf(outname,"%s000%d.min",argv[2],N);
    else if (N<100) sprintf(outname,"%s00%d.min",argv[2],N); 
    else if (N<1000) sprintf(outname,"%s0%d.min",argv[2],N);
    else sprintf(outname,"%s%d.min",argv[2],N);
    out=fopen(outname,"w");
    if (!out) {
      fprintf(stderr,"could not open %s for write\n",outname);
      return (3);
    }
    fprintf(stderr,"%s\n",outname);
    fputs(rec,out);
    for (i=0;i<n;i++) {                          /* atoms */
      ;
      if (!fgets(rec,RECSZ,in)) {
	fprintf(stderr,"premature EOF\n");
	return(4);
      }
      fputs(rec,out);
    }
    if (!fgets(rec,RECSZ,in)) {
      fprintf(stderr,"premature EOF\n");
      return(5);
    }
    if (strncmp(rec+5,"MOL",3)!=0) {
      fprintf(stderr,"missing bond header\n");
      return(6);
    }
    n=atoi(rec);
    fputs(rec,out);                          
    for (i=0;i<n;i++) {                         /* bonds */
      if (!fgets(rec,RECSZ,in)) {
	fprintf(stderr,"premature EOF\n");
	return(7);
      }
      fputs(rec,out);
    }
    if (!fgets(rec,RECSZ,in)) {
      fprintf(stderr,"premature EOF\n");
      return(8);
    }
    if (strncmp(rec+5,"MOL",3)!=0) {
      fprintf(stderr,"missing feature header\n");
      return(9);
    }
    n=atoi(rec);
    fputs(rec,out);
    for (i=0;i<n;i++) {                         /* features */
      if (!fgets(rec,RECSZ,in)) {
	fprintf(stderr,"premature EOF\n");
	return(10);
      }
      fputs(rec,out);
    }
    fclose(out);
  }
  return(0);
}
