      program xpl2witcnt

c     Convert X-Plor electron density map file to Wit!P grid files.
c     Usage:  xpl2witcnt <xplor_map_file >wit_grid_file

      implicit none
      integer MAXSIZ
      parameter (MAXSIZ=200000)
c
      character*132 title
      integer i,k,ksect,a,b,c,ntitle,
     .     na,amin,amax,nb,bmin,bmax,nc,cmin,cmax
      real*4 xstart,ystart,zstart,cl(3),ca(3),v(MAXSIZ)

      open(unit=5,form='formatted')
      read(5,'(/i8)') ntitle
      if (ntitle.le.0) then
         read(5,'(a)') title
      else
         do i=1,ntitle
            read(5,'(a)') ntitle
         end do
      end if
      read(5,'(9i8)') na,amin,amax,nb,bmin,bmax,nc,cmin,cmax
      read(5,'(6f12.0)') (cl(i),i=1,3),(ca(i),i=1,3)
      read(5,'(a)') title
      if (title(1:3).ne.'ZYX') then
         write(0,'(a)') ' Bad mode: '//title(1:3)
         call exit(1)
      end if
c
      xstart=float(amin)/na
      ystart=float(bmin)/nb
      zstart=float(cmin)/nc
      call wrflt(xstart,1)
      call wrflt(ystart,1)
      call wrflt(zstart,1)
      call wrflt(1.0/na,1)
      call wrflt(1.0/nb,1)
      call wrflt(1.0/nc,1)
      na=(amax-amin+1)
      nb=(bmax-bmin+1)
      nc=(cmax-cmin+1)
      call wrint(na,1)
      call wrint(nb,1)
      call wrint(nc,1)
      if (na*nb.gt.MAXSIZ) then
         write(0,'(a)') ' Sorry max.number of points exceeded.'
         write(0,'(a,i8)') ' max. allowed is ',MAXSIZ
      end if
c
      do c=1,nc
         read(5,'(i8)') ksect
         read(5,'(6f12.0)') 
     .        ((v((b-1)*na+a),a=1,na),b=1,nb)
         call wrflt(v,na*nb)
      end do
c
      call wrflt(cl,3)
      call wrflt(ca,3)
      call exit(0)
c
      end
