#include <stdlib.h>
#include <stddef.h>
#if defined(darwin)
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif
#include "wnp.h"
#include "wnpwin.h"

static int hide_cursor = FALSE;        /* should we hide cursor in glbox ?    */
static int current_cursor =  1;        /* current index into cursor tab       */

typedef struct WnpCursor {
  int cursor;                          /* GLUT cursor id, (-1 if not defined) */
  int mono,cryst;                      /* cursor in mono/cryst mode           */
  int color;                           /* cursor, foreground=background       */   
  char *map;                           /* pointer to raw bitmap data          */
  int width,height;                    /* width and height in pixels          */
  int hotx,hoty;                       /* hotspot                             */
} WnpCursor;

static WnpCursor curtab[WNP_MAX_CURSOR] = {
  {GLUT_CURSOR_NONE,       WNP_CURSOR_NONE,   WNP_CURSOR_NONE,   0, NULL, 0,0, 0,0},
  {GLUT_CURSOR_CROSSHAIR,  WNP_CURSOR_DOTBOX, WNP_CURSOR_dotbox, 0, NULL, 0,0, 0,0},
  {GLUT_CURSOR_CROSSHAIR,  WNP_CURSOR_DOTBOX, WNP_CURSOR_dotbox, 0, NULL, 0,0, 0,0},
  {GLUT_CURSOR_LEFT_ARROW, WNP_CURSOR_ARROW,  WNP_CURSOR_arrow,  0, NULL, 0,0, 0,0},
  {GLUT_CURSOR_LEFT_ARROW, WNP_CURSOR_ARROW,  WNP_CURSOR_arrow,  0, NULL, 0,0, 0,0}
};

/* ======================================================================== */

void WnpInitCursor(void)
{
/* currently a NOP */
}

int WnpGlBoxShowCursor(void)
{
  int r,o;

  r=hide_cursor;
  hide_cursor=FALSE;
  if (r) {
    o=current_cursor;
    current_cursor=o+1;    /* to force OP in WnpSetGlBoxCursor */
    WnpSetGlBoxCursor(o);
  }
  return(r);
}

int WnpGlBoxHideCursor(void)
{
  int r,o;
  
  r=hide_cursor;
  if (!r) WnpDefineCursor(WNP_CURSOR_NONE);
  hide_cursor=TRUE;
  return(r);
}

void WnpSetGlBoxCursorColor(int cursor,int color)
{
  return;
}

int WnpSetGlBoxCursor(int new)
{
  int old_cursor,crystaleyes,w;

  crystaleyes=WnpCrystalEyesMode();
  old_cursor=current_cursor;
  if (new>=0 && new < WNP_MAX_CURSOR) {
    new=(crystaleyes ? curtab[new].cryst : curtab[new].mono);
    if (current_cursor!=new) {
      if (!hide_cursor) {
	w=glutGetWindow();
	WnpMakeGlBoxCurrent();
	WnpDefineCursor(new);
	glutSetWindow(w);
      }
      current_cursor=new;
    }
  }
  return(old_cursor);
}

void WnpDefineCursor(int id)
{
  if (id>=0 && id < WNP_MAX_CURSOR) glutSetCursor(curtab[id].cursor);
}

void WnpGlDrawCursor(int swapped)
{
  /* cursor drawn by system */
}

void WnpGlMoveCursor(int x,int y)
{
}

void WnpGlRestoreCursorPatch(void)
{
  /* never have a patch to restore */
}

void WnpGlSetCursorRedrawFlag(int state)
{
}
