#ifdef mingw
#include <winsock.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#if defined(darwin)
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif
#include "wnp.h"
#include "wnpwin.h"

#define FALSE 0


/* ======================================================================== */

#if defined(darwin)
int NSApplicationMain(int argc,const char *argv[]) 
#else
int main(int argc,char **argv)
#endif
{
  int i,k,background,pid,applic,w;
  char *service_name;
#ifdef mingw
  int err;
  WSADATA wsaData; 
#endif

  background=TRUE;           /* default is to run detached... */
  service_name="witnotp";    /* default service name          */
  
  /* process (and remove) some of the command line options */

  for (i=1;i<argc;) {
    if (strcmp("foreground",argv[i])==0) {
      background=FALSE;
      for (k=i;k<argc-1;k++) argv[k]=argv[k+1];
      argv[k]=(char *)NULL; argc--;
    }else if (strcmp("service",argv[i])==0) {
      service_name=strdup(argv[i+1]);
      for (k=i;k<argc-2;k++) argv[k]=argv[k+2];
      argv[k]=(char *)NULL; argc-=2;
    }else i++;
  }
  
  /* push it into the background... */
  
#ifndef mingw
  /* no fork available in mingw, always run in foreground */
  if (background) {
    if (pid=fork()>0) return(0);
    else if (pid<0) {
      fprintf(stderr," failed to fork client...\n");
      return (1);
    }
  }
#endif

#ifdef mingw
  /* get ready for sockets... */
  err = WSAStartup( 0x0101, &wsaData ); 
  if ( err != 0 ) { 
    fprintf(stderr,"couldn't find a useable winsock.dll.\n");
    return(1); 
  } 
#endif

  /* wait for request from client and go... */

  applic=WnpStartComm(service_name);
  if (!applic) {
    fprintf(stderr,"WITNOTP: Could not open message transport to client...\n");
    return(0);
  }

  /* ready to go GLUT */

  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA );
  glutInitWindowPosition(30,30);
  glutInitWindowSize(glutGet(GLUT_SCREEN_WIDTH)-60,glutGet(GLUT_SCREEN_HEIGHT)-100);
  w=glutCreateWindow("Wit!P Graphics Server");
  WnpRegisterGlBox(w);

  /* register callbacks */
  glutReshapeFunc(WnpReshapeCB);
  glutDisplayFunc(WnpDisplayCB);
  glutKeyboardFunc(WnpKeyboardCB);
  glutSpecialFunc(WnpSpecialCB);
  glutMouseFunc(WnpMouseCB);
  glutEntryFunc(WnpEntryCB);

  /* enter application loop */
  glutMainLoop();

  return(0); /* this will never happen... */
}

#if defined(darwin)
//#import <Cocoa/Cocoa.h>
int main(int argc, const char *argv[])
{
  return NSApplicationMain(argc, argv);
}
#endif
