#ifdef mingw
#include <winsock.h>
#endif
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "wnp.h"
#include "wnpwin.h"
#define TRUE  1
#define FALSE 0

#define APPL_CLASS  TEXT("WitNotP")

/* ======================================================================== */
/* WIN32 API Entry Point */

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
		   PSTR szCmdLine,int iCmdShow)
{
  char **argv;
  int applic,pid,background=TRUE;
  char buf[1024],*service_name,*p;
#ifdef mingw
  int err;
  WSADATA wsaData; 
#endif
  WNDCLASS wc;
  HWND hWnd;
  MSG msg;

  /* parse command line... */

  if (p=strstr(szCmdLine,"service")) {
    sscanf(p+strlen("service "),"%s",buf);
    service_name=buf;
  }else service_name="witnotp";
  
  if (strstr(szCmdLine,"foreground")) background=FALSE;

  /* push it into the background... */
  
#ifndef mingw
  /* no fork available in mingw, always run in foreground */
  if (background) {
    if (pid=fork()>0) return(0);
    else if (pid<0) {
      fprintf(stderr," failed to fork client...\n");
      return (1);
    }
  }
#endif

#ifdef mingw
  /* get ready for sockets... */
  err = WSAStartup( 0x0101, &wsaData ); 
  if ( err != 0 ) { 
    fprintf(stderr,"couldn't find a useable winsock.dll.\n");
    return(1); 
  } 
#endif

  /* wait for request from client and go... */

  applic=WnpStartComm(service_name);
  if (!applic) {
    fprintf(stderr,"WITNOTP: Could not open message transport to client...\n");
    return(0);
  }

  /* ready to go WIN32 */

  wc.style       = CS_OWNDC | CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc = WndProc;
  wc.cbClsExtra  = 0;
  wc.cbWndExtra  = 0;
  wc.hInstance   = hInstance;
  wc.hIcon       = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor     = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = GetStockObject(WHITE_BRUSH);
  wc.lpszMenuName = NULL;
  wc.lpszClassName = APPL_CLASS;
   
  RegisterClass( &wc );

  hWnd = CreateWindow( APPL_CLASS,
		       TEXT("Wit!P Graphics Server"),
		       WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,
		       CW_USEDEFAULT, CW_USEDEFAULT,
		       CW_USEDEFAULT, CW_USEDEFAULT,
		       NULL,
		       NULL,
		       hInstance,
		       NULL );

  if ( hWnd != NULL ) {
    ShowWindow( hWnd, iCmdShow );
    UpdateWindow( hWnd );
    do {
      while (!PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)) WnpWorkProc();
      while ( PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
	if (msg.message!=WM_QUIT) {
	  TranslateMessage(&msg);
	  DispatchMessage(&msg);
	}else break;
      }
    } while (msg.message!=WM_QUIT);
    WnpCloseGraphics();
    return(msg.wParam);
  }else{
    fprintf(stderr,"CreateWindow: failed\n");
  }
}
