#ifdef mingw
#include <winsock.h>
#else
#if defined (darwin)
#include <fcntl.h>
#include <sys/socket.h>
#include <sys/types.h>
#else
#include <sys/socket.h>
#endif
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include "utlsock.h"
#include "transpor.h"
#include "wnp.h"

/* 2.01 --> 2.1  : June 4 2003 */
/* 2.10 --> 2.11 : December 29 2004 */
/* 2.11 --> 2.2  : September 2006, support for save/restore */
/* 2.2  --> 2.21 : March 2007: CDOT  */

#define SRVVERS "2.21"

#if defined (sgi)
#define SRVOS "IRIX"
#endif

#if defined (linux)
#define SRVOS "Linux"
#endif

#if defined (cygwin)
#define SRVOS "Cygwin"
#endif

#if defined (mingw)
#define SRVOS "MinGW"
#endif

#if defined (darwin)
#define SRVOS "darwin"
#endif

static int client,service;

#ifndef mingw
void broken_pipe(int dummy);
#endif

int WnpStartComm(char *service_name)
{
  int applic=0;
  char hostname[1024],response[2048];

  if (service=open_service(service_name)) {
    if (client=accept_client(service)) {
      close_service(service);
      gethostname(hostname,120);
#ifndef mingw
      signal(SIGPIPE,broken_pipe);
#endif
      applic=WnpOpenTransport(client);
      sprintf(response,"+WITNOTP: %s %s started on %s\r\n",SRVVERS,SRVOS,hostname);
      send_data(applic,strlen(response),response);
    }else{
      fprintf(stderr,"WITNOTP: request from client failed...\n");
      close_service(service);
    }
  }else fprintf(stderr,"WITNOTP: could not open graphics service %s...\n",service_name);
  return(applic);
}

#ifndef mingw
void broken_pipe(int dummy)
{
  dummy=dummy;
  fprintf(stderr,"WITNOTP: broken pipe\n");
  shutdown(service,2);
  close_service(service);
  exit(0);    
}
#endif
