#ifndef WNPPROTDEF
#define WNPPROTDEF

#include <stdio.h>

/* --------------------------------------------------------------------------------- */

int         WnpStartComm(char *service_name);
void        WnpWorkProc(void);

void        WnpSwapGlBuffers(void);
void        WnpReportGlError(char *msg);

void        MouseMapFunction(int function,int state);
void        MouseReset(void);
int         MouseButtonPress(int button,int state,int x,int y);
int         MouseButtonRelease(unsigned int button,int state,int x,int y);
void        MouseMoved(int state,int x,int y);
void        WnpSetMouseMap(int *map);
void        WnpSetMouseLeft(int right);
void        WnpSetAltObjKey(int key);
int         WnpSetPickMode(int new);
void        WnpSetMouseTrap(int xo,int yo,int width,int height);
void        WnpTrapMouse(int *x,int *y);
void        WnpRemoveMouseTrap(void);

int         WnpSetenv(char *definition);

void        WnpExit(void);
void        WnpMakeGlBoxCurrent(void);
void        WnpGetGlBoxGeom(int geom[4]);

void        WnpSendToParser(char *word);
char       *WnpSetCommandPrompt(char *prompt);
void        WnpSetCommandError(char *msg);

void        WnpDrawSphere(float *x,float r);
void        WnpDrawGlCylinder(float *x,float rx,float *y,float ry);
void        WnpSetSphereMethod(int method);
void        WnpSetSphereMode(int mode,int param);
void        WnpSetCylinderMode(int mode,int param);
void        WnpPrepareForSolid(void);
void        WnpRestoreAfterSolid(void);

void        WnpCrystalEyes(int mode);
int         WnpCrystalEyesMode(void);
void        WnpInitGlBox(int width,int height);
void        WnpGetGlBoxWinpos(int geom[4]);
void        WnpGlBoxWinpos(int geom[4]);
void        WnpGlBoxFullScreen(int geom[4]);
void        WnpGlBoxToggleFullScreen(void);
int         WnpGlBoxRedraw(void);
void        WnpGlBoxViewport(int orgx,int orgy,int width,int height);
int         WnpGlBoxRedrawFlag(void);
int         WnpResetCBFlag(void);
void        WnpSetGlBoxRedrawFlag(int);
void        WnpInitCursor(void);
void        WnpDefineCursor(int id);
void        WnpGlMoveCursor(int x,int y);
void        WnpGlDrawCursor(int swapped);
void        WnpGlRestoreCursorPatch(void);
void        WnpGlSetCursorRedrawFlag(int state);
int         WnpSetGlBoxCursor(int new_cursor);
void        WnpSetGlBoxCursorColor(int cursor,int color);
int         WnpGetGlBoxMode(void);
int         WnpSetGlBoxMode(int mode);
Viewport   *WnpScreen2FractVwpXY(int x,int y,float *xf,float *yf);
void        WnpFractVwpXY2Window(Viewport *v,float xf,float yf,int *x,int *y);
int         WnpGlBoxHideCursor(void);
int         WnpGlBoxShowCursor(void);
void        WnpChange3DSize(int dx,int dy);
void        WnpMenuCommState(int on);
void        WnpToggleMenuComm(void);
void        WnpThreeDState(int on);
void        WnpToggleThreeD(void);
void        WnpRingBell(void);
void        WnpCloseGraphics(void);

float       WnpPixelPerA(void);
int         WnpDisplayWidth(void);
int         WnpDisplayHeight(void);
int         WnpYStereo(void);
void        WnpStereoPar(int op,int dir);
void        WnpCEmode(int mode);
void        WnpStereoPersp(float xmin,float xmax,float ymin,float ymax,float znear,
			   float zfar,float zzps,float dist,float eye,float sep);
void        WnpStereoOrtho(float xmin,float xmax,float ymin,float ymax,float znear,
			   float zfar,float dist,float eye,float sep);
void        WnpDrawThreeDBox(void);
int         WnpPlotThreeDBox(char *cmd);
void        WnpThreeDPick(Viewport *focus,float xf,float yf,int wnpPickMode);
void        WnpThreeDPickMatrix(int x,int y,int mode);
int         WnpPickAtoms(DspObj *root,WnpAtom **atoms,int maxpicks);
void        WnpAtomPicker(DspObj *root);
int         WnpPickObjects(DspObj *root,DspObj **objects,int maxpicks);
void        WnpObjectPicker(DspObj *root);
void        WnpReportUSAPick(int n,WnpAtom **atoms);
void        WnpReportAtomPick(WnpAtom *atom);
void        WnpReportObjectPick(DspObj *object);
int         WnpPickPoint(int xw,int yw,float *line);
void        WnpReportPickLine(float *line);
int         WnpSelectViewport(int view,int stereomode);
int         WnpSelectTextport(int view,int stereomode);
int         WnpFindThreeDView(float xf,int stereomode);
void        WnpSetThreeDView(int view);
int         WnpGetVwpDimensions(char *name,float *width,float *height);
void        WnpDrawThreeDScene(void);
int         WnpThreeDRedrawFlag(void);
void        WnpSetThreeDRedrawFlag(int);
WnpPrj      WnpGetThreeDPrj(void);
void        WnpSetThreeDPrj(WnpPrj prj);
void        WnpThreeDScale(int upd);
void        WnpThreeDScaleRel(float scale);
void        WnpThreeDSlabWidth(int upd);
void        WnpThreeDSlabPosition(int upd);
void        WnpThreeDStereoSeparation(int upd);
void        WnpThreeDViewingDistance(int upd);
void        WnpThreeDTranslatePx(GlblObj *o,int dx,int dy,int dz);
void        WnpThreeDTranslate(GlblObj *o,float *txyz);
void        WnpThreeDRotate(GlblObj *o,float *axis,float angle);
void        WnpThreeDXYrot(GlblObj *o,int dx,int dy);
void        WnpThreeDZrot(GlblObj *o,int x,int y,int dx,int dy);
void        WnpSetPivot(GlblObj *o,float *piv);
void        WnpSetPivotAtom(GlblObj *o,WnpAtom *a);
void        WnpDrawObject(DspObj *o);
void        WnpDrawGlobal(GlblObj *o);
void        WnpDrawMdl(MdlObj *o);
void        WnpDrawMdlBonds(MdlObj *o);
void        WnpDrawMdlAtoms(MdlObj *o);
void        WnpDrawMdlDots(MdlObj *o);
void	    WnpDotColorMap(int n,int *pmap,float *plim);
void        WnpDotColor(float val);
void        WnpTransform(WnpMatrix m,float *x,float *y);
void        WnpGetRTP(WnpMatrix m,DspObj *o);
void        WnpSetRTP(WnpMatrix m,DspObj *o);
int         WnpSetMVTFlag(int s);
void        WnpUpdMVT(void);
void        WnpUpdGlblMVT(GlblObj *r);
void        WnpGetMVT(WnpMatrix mat,DspObj *o);
void        WnpResetMVT(DspObj *o);
void        WnpFreezeMVT(DspObj *o,WnpMatrix mvt);
void        WnpCleanMVT(WnpMatrix mat);
void        WnpViewShift(WnpMatrix mat);
void        WnpZeroViewShift(void);
void        WnpDrawMonitorList(WnpMonPair *lst);
void        WnpDrawInterBonds(WnpBond *bnd);
void        WnpDrawNOEList(MdlObj *mdl);
void        WnpSetAtomLableSize(float size);
void        WnpDrawCSO(CSObj *obj);
void        WnpDrawTRG(TRGObj *obj);

WnpMonPair *WnpMonitorPairs(void);
WnpBond    *WnpInterBonds(void);
void        WnpAddMonitorPair(WnpAtom *a,WnpAtom *b);
void        WnpClearMonitorPairs(void);
void        WnpMonitorLabel(int status);
void        WnpMonitorColor(int color);
void        WnpMonitorWidth(int width);
void        WnpMonitorStatus(int status);
int         WnpDefaultMonColor(void);
int         WnpDefaultMonLabel(void);
int         WnpDefaultMonWidth(void);
int         WnpDefaultMonDsp(void);

int         WnpColorDef(int idx,float R,float G,float B);
int         WnpNoColor(void);
int         WnpColor(int col);
void        WnpMaterialColor(int face,int mode,int color,float alpha,float inte);
void        WnpColorInit(void);
void        WnpFogRange(float znear,float zfar);
void        WnpSetFogColor(float *rgb);
void        WnpSetBackgroundColor(float *rgb);
void        WnpClear(int color);
void        WnpAdjustLightPosition(int dx,int dy,int dz);
void        WnpMoveLight(float *dx);
void        WnpAdjustLightDirection(int x,int y,int dx,int dy);
void        WnpRotateLight(float a);
void        WnpToggleLightSourceLocal(void);
void        WnpAdjustLightIntensity(int scl);
void        WnpAdjustAmbientLightIntensity(int scl);
int         WnpSetViewMode(int mode);
int         WnpGetViewMode(void);
int         WnpGetStereoMode(void);
int         WnpSetStereoMode(int mode);
void        WnpSetMonitor(int mode);

Viewport   *VwpCreate(char *name,float xl,float yl,float xh,float yh,int mode);
Viewport   *VwpGet(char *name);
int         ViewportIsOpen(char *name);
void        ViewportOpen(char *name);
void        ViewportClose(char *name);
int         ViewportSetMode(char *name,int mode);
int         ViewportSetModeFlags(char *name,int flags,int mode);
void        ViewportSet(char *name,int ster_vwp);
int         ViewportLocate(char *name,int *xo,int *yo,int *width,int *height);

int         WnpPixelsPerLine(void);
void        WnpLoadFonts(void);
int         WnpActiveFontNr(void);
int         WnpSetFont(int font);
int         WnpSelFont(int class,int height);
int         WnpTextWidth(char *text,int nch);
void        WnpTextDraw(char *text);
void        WnpTextPos3f(float x,float y,float z);

void        WnpSendToCom(char *msg,...);
void        WnpMessageBoxInit(void);
void        WnpDrawMessageBox(int buffer);
void        WnpDrawMessageBoxBB(void);
void        WnpDrawPendingLines(void);
void        WnpDrawMessageLine(int i);
void        WnpDrawKeyLine(void);
void        WnpMsgPgUp(void);
void        WnpMsgPgDown(void);
void        WnpMsgScroll(int i);
void        WnpSetPrompt(char *promt);
void        WnpSetLocalPrompt(char *promt);
void        WnpSetLocalString(char *line);
int         WnpGetLocalString(WnpLocalStringCB dispatch,void *extraData);
WnpLocalStringCB WnpLocalStringDispatcher(void);

int         WnpButton(unsigned int xbutton);
long        WnpGetEventMask(void);
void        WnpSetEventMask(long set_bits);
void        WnpResetEventMask(long reset_bits);
void        WnpMouseMotionMask(int state);

void        WnpKeyboardInit(void);
void        WnpKeyboardEcho(int state);
void        WnpAddKey(unsigned int key,unsigned int state);
int         WnpSetKeyboardMode(int mode);
int         WnpKeyboardMode(void);
void        WnpSendKeyboardToDisplay(int cpos,char *msg);
void        WnpArrowKey(int key,int state);
void        WnpFunctionKey(int key,int state);

void        WnpMenuBoxInit(void);
void        WnpDrawMenuBox(int mode);
void        WnpDrawMenuBoxBB(void);
void        WnpDrawMenu(WnpMenu *m);
void        WnpDrawMenuButton(WnpMenu *m,int i);
void        WnpRefreshMenu(WnpMenu *m);
WnpMenu    *WnpCreateMenu(char *vwp,int mbtn,int nbtn,int nres);
void        WnpResizeMenu(WnpMenu *m,int newsize);
void        WnpClearMenu(WnpMenu *m);
void        WnpHighlightMenuButton(Viewport *focus,float y);
void        WnpPressMenuButton(Viewport *focus,float y);
void        WnpClearMenuButton(WnpMenu *m,int i);
void        WnpLoadMenuButtons(WnpMenu *m,int next,char *text);
int         WnpActivateButton(WnpMenu *m,int i,int on_or_off);
int         WnpMenuColor(int col);
WnpMenu    *WnpActiveMenu(void);
WnpMenu    *WnpMainMenu(void);
WnpMenu    *WnpSetActiveMenu(WnpMenu *new);
void        WnpSetMenuText(WnpMenu *m,int i,char *text);
void        WnpSetMenuAction(WnpMenu *m,int i,WnpMenuAction action);
void        WnpScrollMenuUp(void *menu,int dummy);
void        WnpScrollMenuDown(void *menu,int dummy);
void        WnpMessageDump(char *file);
void        WnpScreenDump(char *file);

int         WnpOpenTransport(int client);
int         WnpCommQueue(int *back);
int         WnpCommDebug(void);
void        WnpSendTextToClient(char *hdr,int n,char *text);

void        WnpNewObjectFlags(DspObj *o,int flags,int state);
void        WnpToggleObjectFlags(DspObj *o,int flags);
void        WnpSetObjectLW(DspObj *o,int lw);
void        WnpSetObjectMDST(DspObj *o,int mdstype);
void        WnpSetObjectColor(DspObj *o,int color);
void        WnpSetBackfaceColor(DspObj *o,int color);
GlblObj    *WnpAssocGlbl(DspObj *o);
GlblObj    *WnpDisplayRoot(void);
GlblObj    *WnpAltDspObj(void);
GlblObj    *WnpSetAltObj(GlblObj *o);
void        WnpSetDisplayStyle(DspObj *o,int style);
void        WnpSetTransparency(DspObj *o,int level);
DspObj     *WnpAtomPickRoot(void);
DspObj     *WnpSetAtomPickRoot(DspObj *o);
DspObj     *WnpObjectPickRoot(void);
DspObj     *WnpSetObjectPickRoot(DspObj *o);
void       *WnpAddDspObj(cptr_t parent,cptr_t son,int type);
void        WnpTransformObject(DspObj *obj,WnpMatrix mmv);
DspObj     *WnpDeleteDspObj(DspObj *obj);
void        WnpUnlinkDspObj(DspObj *obj);
DspObj     *WnpNextObj(DspObj *root,DspObj *now,int obj_type);
DspObj     *WnpFirstObj(DspObj *r,int types);
GlblObj    *WnpMakeGlblObj(void);
GlblObj    *WnpDeleteGlblObj(GlblObj *obj);
MdlObj     *WnpMakeMdlObj(void);
CSObj      *WnpMakeCSObj(void);
CSObj      *WnpDeleteCSObj(CSObj *obj);
TRGObj     *WnpMakeTRGObj(void);
TRGObj     *WnpDeleteTRGObj(TRGObj *obj);
void        WnpTransformCSO(CSObj *obj,WnpMatrix mmv);
void        WnpTransformTRG(TRGObj *obj,WnpMatrix mmv);
void        WnpTransformDots(WnpDots *dots,WnpMatrix mmv);
void        WnpTransformMdl(MdlObj *obj,WnpMatrix mmv);
MdlObj     *WnpDeleteMdlObj(MdlObj *obj);
void        WnpRebuildMdl(MdlObj *obj);
void        WnpRebuildInterLists(void);
WnpAtom    *WnpMakeAtom(void);
WnpAtom    *WnpNextAtom(DspObj *r,WnpAtom *a);
WnpAtom    *WnpFirstAtom(DspObj *r);
void        WnpSetAtomMark(WnpAtom *a,int mark);
void        WnpClearAllAtomMarks(void);
void        WnpRemoveAtom(WnpAtom *a);
void        WnpReplaceAtom(WnpAtom *old,WnpAtom *new);
WnpAtom    *WnpDeleteAtom(WnpAtom *a);
void        WnpRemoveAtomLabel(WnpAtom *a);
void        WnpSetAtomLabel(WnpAtom *a,char *text);
void        WnpSetDefaultAtomLabelColor(int color);
void        WnpSetAtomLabelColor(WnpAtom *a,int color);
void        WnpSetAtomLabelSize(float size);
void        WnpNewAtomXYZ(WnpAtom *a,float *x);
void        WnpNewAtomColor(WnpAtom *a,int color);
void        WnpNewAtomFlags(WnpAtom *a,int flags,int status);
void        WnpNewAtomRadius(WnpAtom *a,float r);
void        WnpScaleAtomRadius(WnpAtom *a,float s);
WnpBond    *WnpMakeBond(void);
void        WnpAddAtomToMdl(WnpAtom *a,MdlObj* mdl);
void        WnpAddBondToMdl(WnpBond *b,MdlObj* mdl);
void        WnpAddBond(WnpBond *b);
void        WnpAddInterBond(WnpBond *b);
void        WnpCopyDots(WnpAtom *trg,WnpAtom *src);
void        WnpReplaceDots(WnpAtom *a,int n,float *xyz);
void        WnpDeleteDots(WnpAtom *a);
void        WnpDisplayDots(WnpAtom *a,int dsp);
WnpDots    *WnpFindDots(WnpAtom *a);
void        WnpColorDots(WnpAtom *a,int color);
void        WnpDotsStyle(WnpAtom *a,int style);
void        WnpNewBondFlags(WnpBond *b,int flags,int status);
void        WnpSetBondRadius(WnpBond *b,float r);
void        WnpRemoveBond(WnpBond *b);
WnpBond    *WnpDeleteBond(WnpBond *b);
void        WnpRemoveBondLabel(WnpBond *b);
void        WnpSetBondLabelColor(WnpBond *b,int color);
void        WnpSetBondLabel(WnpBond *b,char *text);
void        WnpSetBondLW(WnpBond *b,int lw);
void        WnpSetDefaultBondLW(int lw);
WnpLst     *WnpDeleteLst(WnpLst *l);
WnpLst     *WnpDeleteLstEntry(WnpLst *l);
WnpDots    *WnpMakeDots(void);
DspObj     *MyObjPtr(cptr_t his);
void        WnpSetRebuildFlag(DspObj *obj);
void        WnpSetModifiedFlag(DspObj *obj);
void        WnpLockEvtQ(int inc);
int         WnpEvtQLocked(void);
void        WnpTogglePhotoMode(int ticks);
void        WnpToggleTxtBuffMode(void);
void        WnpToggleDoubleBufferMode(void);  
void        WnpSetRocking(float *pars);
void        WnpToggleRocking(void);
void        WnpSetBenchmarkCounter(void);
void        WnpNewRotAxis(int n,WnpAtom **atoms);
float       WnpFreezeRotAxis(void);
void        WnpIncRotAxis(float d);
void        WnpResetRotAxis(void);
int         WnpAxisRotation(void);
void        WnpAddMDS(CSObj *cso,WnpMDS *mds);
WnpMDS     *WnpMakeMDS(void);
void        WnpAddTOBJ(CSObj *cso,WnpTOBJ *tob);
WnpTOBJ    *WnpMakeTOBJ(void);
void        WnpAddTRG(TRGObj *obj,WnpTRG *trg);
WnpTRG     *WnpMakeTRG(void);
void        WnpAddNOE(WnpNOE *noe);
WnpNOE     *WnpMakeNOE(void);
void        WnpRemoveNOEs(DspObj *dsp);
void        WnpSetNOEAttributes(DspObj *dsp,int label,int style,int width);

int        *WnpMakePTStipple(int level);
void        WnpTextInit(void);
void        WnpTextPos3fv(float *x);
void        WnpTextSize(float sx,float sy);
void        WnpTextIniCur(int icur);
void        WnpTextFinCur(int fcur);
void        WnpTextQuality(short qual);
void        WnpDrawText(float *x,WnpMatrix mvt,char *text);

void        WnpPlotThreeD(void);
void        WnpRenderMode(int mode);
void        WnpSetColor(int color);
void        WnpVertex(float *x);
void        WnpGlBegin(int mode);
void        WnpGlEnd(void);
void        WnpSetLWMap(float *fbuf);
void        WnpVLineWidth(int width);
void        WnpLineWidth(float width);
void        WnpGlLineWidth(float width);
float       WnpRealLineWidth(int width);
void        WnpVPointSize(int size);
void        WnpPointSize(float size);
void        WnpGlPointSize(float size);
void       *WnpInitPlot(char *file,int xs,int ys);
void        WnpPlotProjection(WnpMatrix  pm);
void        WnpPlotMVT(WnpMatrix  mvt);
void        WnpPlotCurrentMVT(void);
void        WnpPlotClipPlanes(float znear,float zfar);
void        WnpPlotViewport(float xl,float xh,float yl,float yh);
void        WnpEndPlot(void);
int         WnpPlotMode(void);
void        WnpDrawCylinder(float *x,float rx,float *y,float ry);
void        WnpLineStipple(int s);

FILE       *WnpPipeOpen(char *cmd,char *type);
int         WnpPipeClose(FILE *fp);

#endif
