      subroutine bomatr(delta)
c     
c     Compute Bondordermatrix p from eigenvectors in evec. On output delta
c     will be set to the maximum deviation between new and old bondorders.
c     
      implicit none
      include 'sizes.h'
      include 'atom.h'
      include 'energy.h'
      include 'fock.h'

      integer  k,l,i,j,norb
      real opl,delta
c     
c     Number of occupied orbitals is nelpi/2, two electrons per orbital.
c     
      norb=nelpi/2
      if (norb.eq.0) return
c     
c     p is stored in symmetric storage mode
c     
      delta=0.0
      l=0
      do 100 i=1,natpi
         do 90 j=1,i
            l=l+1
            opl=p(l)
            p(l)=0.0
            do 80 k=1,norb
               p(l)=p(l)+evec(i,k)*evec(j,k)*2
 80         continue
            delta=amax1(abs(opl-p(l)),delta)
 90      continue
 100  continue
c     
c     done...
c     
      return
      end
