      subroutine chkpar(*)
c     
c     Check Parametertables for Symmetry. 
c     Take alternate return in case of symmetry violations.
c     
      implicit none
      include 'sizes.h'
      include 'apara.h'
      include 'bpara.h'
      logical bad
      integer i,j
c     
      bad=.false.
c     
      do i=1,matype-1
         do j=i+1,matype
            if (al(i,j).ne.al(j,i)) then
               write(21,'(a,a,1x,a,2g15.5)')
     *              ' Bad symmetry : Al ',type(i),type(j),
     *              al(i,j),al(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (bl(i,j).ne.bl(j,i)) then
               write(21,'(a,a,1x,a,2g15.5)')
     *              ' Bad symmetry : Bl ',type(i),type(j),bl(i,j),
     *              bl(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (de(i,j).ne.de(j,i)) then
               write(21,'(a,a,1x,a,2g15.5)')
     *              ' Bad symmetry : De ',type(i),type(j),de(i,j),
     *              de(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (ame(i,j).ne.ame(j,i)) then
               write(21,'(a,a,1x,a,2g15.5)')
     *              ' Bad symmetry : Ame ',type(i),type(j),ame(i,j),
     *              ame(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (bk(i,j).ne.bk(j,i)) then
               write(21,'(a,a,1x,a,2g15.5)')
     *              ' Bad symmetry : Bk ',type(i),type(j),bk(i,j),
     *              bk(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (pk2(i,j).ne.pk2(j,i)) then
               write(21,'(a,a,1x,a,2g15.5)')
     *              ' Bad symmetry : Pk2 ',type(i),type(j),pk2(i,j),
     *              pk2(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (pk4(i,j).ne.pk4(j,i)) then
               write(21,'(a,a,1x,a,2g15.5)')
     *              ' Bad symmetry : Pk4 ',type(i),type(j),pk4(i,j),
     *              pk4(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (pk6(i,j).ne.pk6(j,i)) then
               write(21,'(a,a,1x,a,2g15.5)')
     *              ' Bad symmetry : Pk6 ',type(i),type(j),pk6(i,j),
     *              pk6(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (kttype(i,j).ne.kttype(j,i)) then
               write(21,'(a,a,1x,a,2i15)')
     *              ' Bad symmetry : Kttype ',type(i),type(j),
     *              kttype(i,j),kttype(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (ppiz(i,j).ne.ppiz(j,i)) then
               write(21,'(a,a,1x,a,2g15.5)')
     *              ' Bad symmetry : Ppiz ',type(i),type(j),
     *              ppiz(i,j),ppiz(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (ppit(i,j).ne.ppit(j,i)) then
               write(21,'(a,a,1x,a,2g15.5)')
     *              ' Bad symmetry : Ppit ',type(i),type(j),
     *              ppit(i,j),ppit(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (ptt(i,j).ne.ptt(j,i)) then
               write(21,'(a,a,1x,a,2g15.5)')
     *              ' Bad symmetry : Ptt ',type(i),type(j),
     *              ptt(i,j),ptt(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (avdw(i,j).ne.avdw(j,i)) then
               write(21,'(a,a,1x,a,2g15.5)')
     *              ' Bad symmetry : Avdw ',type(i),type(j),
     *              avdw(i,j),avdw(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (bvdw(i,j).ne.bvdw(j,i)) then
               write(21,'(a,a,1x,a,2g15.5)')
     *              ' Bad symmetry : Bvdw ',type(i),type(j),
     *              bvdw(i,j),bvdw(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (cvdw(i,j).ne.cvdw(j,i)) then
               write(21,'(a,a,1x,a,2g15.5)')
     *              ' Bad symmetry : Cvdw ',type(i),type(j),
     *              cvdw(i,j),cvdw(j,i)
               bad=.true.
            end if
         end do
      end do
      do i=1,matype-1
         do j=i+1,matype
            if (dvdw(i,j).ne.dvdw(j,i)) then
               write(21,'(a,a,1x,a,2i15)')
     *              ' Bad symmetry : Dvdw ',type(i),type(j),
     *              dvdw(i,j),dvdw(j,i)
               bad=.true.
            end if
         end do
      end do
c     
      if (bad) return 1
      return
      end
