#ifndef CONJGRADDEF
#define CONJGRADDEF

/* Define the desired precision of real numbers:                           */

#ifndef REAL
#define REAL float
#endif

int conjgrad(
   REAL (*func)(int *n,REAL *x,REAL *g,void *dat),/* the objective function  */
   int   n,                              /* number of variables (in)        */
   REAL *x,                              /* n variables (in/out)            */
   REAL *f,                              /* min f (out)                     */
   REAL *g,                              /* gradient at optimum x (out)     */
   REAL dfn,                             /* the infamous dfn (in, see below)*/
   REAL acc,                             /* desired accuracy (in)           */
   int   maxfn,                          /* max. func evaluations (in)      */
   void *dat);                           /* pointer to data needed in func  */

#endif
