      subroutine dist(n,x)
c     
c     Compute interatomic distances for the molecule whose coordinates
c     are stored in x. N is the number of atoms.
c     
      implicit none
      include 'sizes.h'
      include 'energy.h'
      real    x(3,*)
      integer n

      integer i,ij,j
c     
c     Compute matrix of interatomic distances (symmetric storage mode)
c     
      do 100 i=2,n
         ij=(i*(i-1))/2
         r(ij)=0.0
         do 90 j=1,i-1
            ij=ij+1
            r(ij)=sqrt((x(1,i)-x(1,j))**2+(x(2,i)-x(2,j))**2+
     *           (x(3,i)-x(3,j))**2)
 90      continue
 100  continue
      r((n*(n+1))/2)=0.0
c     
      return
      end
