      subroutine edtpar(file,*)
c     
c     Update SCF and FF parameters with values from user file.
c     Alternate return if something goes wrong.
c     
      implicit none
      integer nr_known
      parameter (nr_known=5)
      include 'sizes.h'
      include 'apara.h'
      include 'bpara.h'
c     
      integer*2 pos
      logical found,bad
      integer i,nr1,nr2,nr
      real    rvalue
      character*40 file
      character record*80,fld*80,pnam*6,at1*4,at2*4,value*20
      character*6 known_p(nr_known)
c     
      data known_p /
     *     'PPIZ  ','DIELC','PPIT','PTT','FCANG3' /
c     
c     Open the user file
c     
      bad=.false.
      open(unit=22,file=file,status='old',err=8100)
      write(21,'(/a/)') 'Parameter changes taken from '//file
c     
c     Read next line
c     
 10   continue
      read(22,'(a)',end=8000) record
      pos=1
c     
c     Which parameter ?
c     
      call strupcase(pnam,fld(record,pos))
      nr=0
      found=.false.
      do while (nr.lt.nr_known.and..not.found)
         nr=nr+1
         found=pnam.eq.known_p(nr)
      end do
      if (.not.found) then
         write(21,'(a)') ' no such parameter : '//pnam
         bad=.true.
         go to 10
      end if
c     
c     Read arguments
c     
      call strupcase(value,fld(record,pos))
      call strupcase(at1,fld(record,pos))
      call strupcase(at2,fld(record,pos))
c     
c     Translate atomtypes to numbers
c     
      nr1=0
      nr2=0
      do i=1,matype
         if (type(i).eq.at1) nr1=i
         if (type(i).eq.at2) nr2=i
      end do
c     
c     Store the new value to the appropriate matrix
c     
      go to (100,200,300,400,500) nr
      go to 10
c     
c     PPIZ (single bond torsion)
c     
 100  continue
      if (nr1.eq.0.or.nr2.eq.0) then
         write(21,'(a/a)') ' unknown atomtype in the record below:',
     *        record
         bad=.true.
      else
         read(value,'(bn,f20.0)') rvalue
         write(21,'(a,g13.6,a,g13.6,a)') pnam//' changed from ',
     *        ppiz(nr1,nr2),' to ',rvalue,' for '//at1//' --- '//at2
         ppiz(nr1,nr2)=rvalue
         ppiz(nr2,nr1)=rvalue
      end if
      go to 10
c     
c     Dielectric constant
c     
 200  continue
      read(value,'(bn,f20.0)') rvalue
      rvalue=amax1(0.0,rvalue)
      write(21,'(a,g13.6,a,g13.6)') pnam//' changed from ',
     *     dielc,' to ',rvalue
      dielc=rvalue
      go to 10           
c     
c     Pi-bond torsion (deformation) PPIT
c     
 300  continue
      if (nr1.eq.0.or.nr2.eq.0) then
         write(21,'(a/a)') ' unknown atomtype in the record below:',
     *        record
         bad=.true.
      else
         read(value,'(bn,f20.0)') rvalue
         write(21,'(a,g13.6,a,g13.6,a)') pnam//' changed from ',
     *        ppit(nr1,nr2),' to ',rvalue,' for '//at1//' --- '//at2
         ppit(nr1,nr2)=rvalue
         ppit(nr2,nr1)=rvalue
      end if
      go to 10
c     
c     Pi-bond torsion (strain) PTT
c     
 400  continue
      if (nr1.eq.0.or.nr2.eq.0) then
         write(21,'(a/a)') ' unknown atomtype in the record below:',
     *        record
         bad=.true.
      else
         read(value,'(bn,f20.0)') rvalue
         write(21,'(a,g13.6,a,g13.6,a)') pnam//' changed from ',
     *        ptt(nr1,nr2),' to ',rvalue,' for '//at1//' --- '//at2
         ptt(nr1,nr2)=rvalue
         ptt(nr2,nr1)=rvalue
      end if
      go to 10
c     
c     FCANG3: angle bending, cubic term.
c     
 500  continue
      if (nr1.eq.0) then
         write(21,'(a)') ' Atomtype not founf (FCANG3) : '//at1
         bad=.true.
      else
         read(value,'(bn,f20.0)') rvalue
         fcang3(nr1)=rvalue
      end if
      go to 10
c     
c     Done...
c     
 8000 continue
      if (bad) then
         write(6,'(a)') ' Parameter update fails. '//
     *        'See molecule.DAT file for reason.'
         return 1
      else
         return
      end if
c     
 8100 continue
      write(21,'(a)') ' Can''t open parameter file '//file
      bad=.true.
      go to 8000
c     
      end
