      subroutine egang(x,e,gr)
c     
c     Compute energy due to angle bending and update gradient 'gr'.
c     
      implicit none
      include 'sizes.h'
      include 'energy.h'
      real    x(3,*),gr(3,*)
      real    x21(3),x23(3)

      integer i,j,i1,i2,i3,m,ik
      real e,rd,r21,r23,s,d,f,f21,f23
c     
c     The following procedure returns the interatomic distance between atom i
c     and atom j (retrieved from symm. matrix r)
c     
      rd(i,j)=abs(r((max0(i,j)*(max0(i,j)-1))/2+min0(i,j)))
c     
c     Initialize energy
c     
      e=0.0
c     
c     Compute bondangle
c     
      do 100 i=1,nang
         i1=ang(1,i)
         i2=ang(2,i)
         i3=ang(3,i)
         r21=rd(i2,i1)
         r23=rd(i2,i3)
         s=0.0
         do 10 m=1,3
            x21(m)=x(m,i1)-x(m,i2)
            x23(m)=x(m,i3)-x(m,i2)
            s=s+x21(m)*x23(m)
 10      continue
         s=amax1(-1.0,amin1(1.0,s/(r21*r23)))
         angl(i)=acos(s)
c     
c     Energy
c     
         d=angl0(i)-angl(i)
         eiangl(i)=0.5*kang(i)*d**2+0.25*kang3(i)*d**4
         e=e+eiangl(i)
c     
c     Gradient
c     
         if (1-s**2.gt.1.e-6) then
            f=(kang(i)*d+kang3(i)*d**3)/sqrt(1-s**2)
            do 90 m=1,3
               f21=f*(x23(m)/(r21*r23)-s*x21(m)/r21**2)
               f23=f*(x21(m)/(r21*r23)-s*x23(m)/r23**2)
               gr(m,i1)=gr(m,i1)+f21
               gr(m,i3)=gr(m,i3)+f23
               gr(m,i2)=gr(m,i2)-f21-f23
 90         continue
         end if
c     
c     Flag (i1,i3) to exclude this pair from nonbonded interactions
c     
         ik=(max0(i1,i3)*(max0(i1,i3)-1))/2+min0(i1,i3)
         r(ik)=-abs(r(ik))
 100  continue
c     
c     done...
c     
      return
      end
