      subroutine egbond(x,e,gr)
c     
c     Compute bondstretching energy 'e' for the molecule whose coordinates
c     are stored in x (n atoms). At the same time the gradient resulting from
c     the bondstretching potentials will be added to 'gr'.
c     
      implicit none
      include 'sizes.h'
      include 'energy.h'
      real    x(3,*),gr(3,*),e,f,d,rd
      integer i,j,ij,i1,i2,l

c     
c     The following procedure returns the interatomic distance between atom i
c     and atom j (retrieved from symm. matrix r)
c     
      rd(i,j)=r((max0(i,j)*(max0(i,j)-1))/2+min0(i,j))
c     
c     Initialize energy
c     
      e=0.0
c     
c     Take bondlengths from distance table 'r'
c     
      do 100 i=1,nbnd
         i1=bnd(1,i)
         i2=bnd(2,i)
         bndl(i)=rd(i1,i2)
c     
c     Energy
c     
         d=bndl(i)-bndl0(i)
         eibond(i)=d*d*kbnd(i)*0.5
         e=e+eibond(i)
c     
c     Gradient
c     
         f=kbnd(i)*d/bndl(i)
         do 90 l=1,3
            gr(l,i1)=gr(l,i1)+(x(l,i1)-x(l,i2))*f
            gr(l,i2)=gr(l,i2)-(x(l,i1)-x(l,i2))*f
 90      continue
c     
c     Flag (i1,i2) to exclude this pair from nonbonded interactions
c     
         ij=(max0(i1,i2)*(max0(i1,i2)-1))/2+min0(i1,i2)
         r(ij)=-abs(r(ij))
 100  continue
c     
c     done...
c     
      return
      end
