      subroutine egcondi(x,e,gr)
c     
c     Compute distance constraint energy 'e' for the molecule whose coordinates
c     are stored in x (n atoms). At the same time the gradient resulting from
c     the constraint potentials will be added to 'gr'.
c     
      implicit none
      include 'sizes.h'
      include 'energy.h'
      real    x(3,*),gr(3,*)

      integer i1,i2,l,i,j
      real d,e,f,rd

c     
c     The following procedure returns the interatomic distance between atom i
c     and atom j (retrieved from symm. matrix r)
c     
      rd(i,j)=r((max0(i,j)*(max0(i,j)-1))/2+min0(i,j))
c     
c     Take distances from distance table 'r'
c     
      do 100 i=1,ncon
         i1=atcon(1,i)
         i2=atcon(2,i)
         dcon(i)=abs(rd(i1,i2))
c     
c     Energy
c     
         d=0.0
         epen(i)=0.0
         if (dcon(i).lt.dlow(i)) d=dcon(i)-dlow(i)
         if (dcon(i).gt.dhigh(i)) d=dcon(i)-dhigh(i)
         if (abs(d).gt.1.e-6) then
            epen(i)=d*d*kcon(i)*0.5
            e=e+epen(i)
c     
c     Gradient
c     
            f=kcon(i)*d/dcon(i)
            do 90 l=1,3
               gr(l,i1)=gr(l,i1)+(x(l,i1)-x(l,i2))*f
               gr(l,i2)=gr(l,i2)-(x(l,i1)-x(l,i2))*f
 90         continue
         end if
 100  continue
c     
c     done...
c     
      return
      end
