      subroutine egcou(x,e,gr)
c     
c     Compute electrostatic (Coulomb) energy for the molecule whose coordinates
c     are stored in x (n atoms). At the same time gradient resulting from these
c     interactions are added to 'gr'. Only interactions of the types 1 -- 4 and
c     higher are included.
c     
      implicit none
      include 'sizes.h'
      include 'energy.h'
      include 'bpara.h'
      include 'atom.h'
      real    x(3,*),gr(3,*)
      real fdiel,rij,c,f,e
      integer i,ij,j

c     
c     Initialize the energy
c     
      e=0.0
      if (dielc.lt.0.0001) return
      fdiel=0.23079E-2/dielc
c     
      do i=2,nat
         ij=(i*(i-1))/2
         do j=1,i-1
            ij=ij+1
            rij=r(ij)
            if (rij.gt.0.0) then
               c=chrg(i)*chrg(j)*fdiel/rij
               e=e+c
               f=-c/(rij*rij)
               gr(1,i)=gr(1,i)+f*(x(1,i)-x(1,j))
               gr(1,j)=gr(1,j)-f*(x(1,i)-x(1,j))
               gr(2,i)=gr(2,i)+f*(x(2,i)-x(2,j))
               gr(2,j)=gr(2,j)-f*(x(2,i)-x(2,j))
               gr(3,i)=gr(3,i)+f*(x(3,i)-x(3,j))
               gr(3,j)=gr(3,j)-f*(x(3,i)-x(3,j))
            end if
         end do
      end do
c     
c     done...
c     
      return
      end
