      real function egeneral(n,q,gr)
c     
c     Compute energy and gradient as functions of generalized coordinates
c     q. Unit of energy is dynA/mol.
c     
      implicit none
      include 'sizes.h'
      integer my,mw
      parameter (my=3*matot+1)
      parameter (mw=6*matot+1)  ! room for two coordinate sets
c     
      include 'atom.h'
      include 'fragment.h'
      include 'tree.h'
      include 'worksp.h'
c     
      integer n,nf,j,i
      real    egf,e,q(n),gr(n),x(3,matot),y(3,matot),gy(3,matot)
c     
      equivalence (x,work),(y,work(my)),(gy,work(mw))
c     
c     Compute new geometry and cartesian energy and gradient.
c     
      nf=3*nsingle+6*nfrag
      if (nrotb.gt.0) then
         call flexigeom(q(nf+1),xyz,x)
      else
         do j=1,nat
            do i=1,3
               x(i,j)=xyz(i,j)
            end do
         end do
      end if
      call frageom(q,x,y)
      e=egf(3*nat,y,gy)
c     
c     Convert cartesian gradient to generalized gradient:
c     
      if (nrotb.gt.0) call egflexi(nrotb,y,gy,gr(nf+1))
      if (nf.gt.0)    call egfrag(nf,q,x,gy,gr)
c     
c     done...
c     
      egeneral=e
      return
      end
