      subroutine egflexi(n,x,gx,gr)
c     
c     Compute gradient as a function of n flexible bond torsions t
c     from cartesian coordinates x and cart. gradient gx.
c     
      implicit none
      include 'sizes.h'
c     
      include 'atom.h'
      include 'energy.h'
      include 'tree.h'
c     
      integer n,tr,a,b,i,j
      real    gr(n),x(3,matot),gx(3,matot),ajb(3),rab,rd
c     
c     The following procedure returns the interatomic distance between atom i
c     and atom j (retrieved from symm. matrix r)
c     
      rd(i,j)=abs(r((max0(i,j)*(max0(i,j)-1))/2+min0(i,j)))
c     
c     Compute gradient in coordinates t from cartesian gradient.
c     
      if (n.eq.0) return
      do i=1,n
         gr(i)=0.0
      end do
c     
c     For each atom, update the components of gr (only for bonds that affect
c     the position of the current atom).
c     
      do j=1,nat
         tr=trnr(j)
         do while (tr.ne.0)
            a=axis(1,tr)
            b=axis(2,tr)
            rab=rd(a,b)
c     
c     Compute normal to plane formed by flexible bond and current atom.
c     Length of normal is the distance of the atom from bond.
c     
            ajb(1)=( (x(2,j)-x(2,a))*(x(3,j)-x(3,b))
     *           -(x(3,j)-x(3,a))*(x(2,j)-x(2,b)))/rab
            ajb(2)=( (x(3,j)-x(3,a))*(x(1,j)-x(1,b))
     *           -(x(1,j)-x(1,a))*(x(3,j)-x(3,b)))/rab
            ajb(3)=( (x(1,j)-x(1,a))*(x(2,j)-x(2,b))
     *           -(x(2,j)-x(2,a))*(x(1,j)-x(1,b)))/rab
c     
c     Update to gradient is the scalar product of normal and force on
c     current atom.
c     
            do i=1,3
               gr(tr)=gr(tr)+ajb(i)*gx(i,j)
            end do
c     
c     Back up in tree of flexible bonds.
c     
            tr=ptra(tr)
         end do
      end do
c     
c     done...
c     
      return
      end
