      subroutine egfrag(n,q,x,gx,gr)
c     
c     Compute gradient as a function of generalized fragment coordinates q
c     from cartesian coordinates x (prior to fragment transform) and cartesian
c     gradient gx.
c     
      implicit none
      include 'sizes.h'
      include 'atom.h'
      include 'fragment.h'
c     
      integer n,k,ksingle,j,i,l,ka,kt,ll,kk
      real    q(n),gr(n),ajb(3)
      real    x(3,matot),gx(3,matot),z(3)
c     
c     Compute new cartesian coordinates, energy, and cartesian gradient.
c     
      do k=1,n
         gr(k)=0.0
      end do
c     
c     Compute gradient for single atoms
c     
      ksingle=6*nfrag
      do k=1,fragpt(0)
         j=fragnr(k)
         do i=1,3
            ksingle=ksingle+1
            gr(ksingle)=gx(i,j)
         end do
      end do
c     
c     Compute gradient for rigid fragments
c     
      do l=1,nfrag
         ka=6*(l-1)+4
         call frotder(q(ka),drf) ! Derivatives of rotation matrix
         do k=fragpt(l-1)+1,fragpt(l)
c     
c     Update translational part of gradient. Compute atomic coordinates
c     relative to current centroid position.
c     
            j=fragnr(k)
            kt=6*(l-1)
            do i=1,3
               kt=kt+1
               gr(kt)=gr(kt)+gx(i,j)
               z(i)=x(i,j)-x(i,cfrag(l))
            end do
c     
c     Update rotational part of gradient.
c     
            ka=kt
            do i=1,3
               do ll=1,3
                  ajb(ll)=0.0
                  do kk=1,3
                     ajb(ll)=ajb(ll)+drf(ll,kk,i)*z(kk)
                  end do
               end do
               ka=ka+1
               do ll=1,3
                  gr(ka)=gr(ka)+ajb(ll)*gx(ll,j)
               end do
            end do            
         end do
      end do
c     
      return
      end
