      real function egf(n,x,gr)
c     
c     Compute total MM-energy and forces for molecule whose n coordinates are
c     stored in x (n/3 atoms).
c     
      implicit none
      include 'sizes.h'
      include 'energy.h'
      include 'option.h'
      real    x(3,*),gr(3,*)
      integer n,i,j
c     
c     Initialize energy and gradient (forces)
c     
      egf=0.0
      do 10 j=1,n/3
         do 5 i=1,3
            gr(i,j)=0.0
 5       continue
 10   continue
c     
c     Compute all interatomic distances
c     
      call dist(n/3,x)
c     
c     Sum energies and forces
c     
      call egbond(x,ebnd,gr)
      egf=egf+ebnd
      call egcou(x,ecou,gr)
      egf=egf+ecou
      call egang(x,eang,gr)
      egf=egf+eang
      call egtors(x,etord,etors,gr)
      egf=egf+etors+etord
      call egbend(x,epla,gr)
      egf=egf+epla
      call egvdw(x,evdw,gr)
      egf=egf+evdw
      call egcons(x,econ,gr)
      egf=egf+econ
c     
c     Energy printout if requested
c     
      ncalls=ncalls+1
      if (nenout.ne.0) then
         if (mod(ncalls,nenout).eq.1.or.nenout.eq.1) then
            write(6,'(i5,7(f10.2))') ncalls,
     *           egf*602493.3,
     *           ebnd*602493.3,
     *           eang*602493.3,
     *           (etord+etors)*602493.3,
     *           epla*602493.3,
     *           evdw*602493.3,
     *           ecou*602493.3
            if (interact) call xputmol(n/3,x)
            call flush(6)
         end if
      end if
c     
c     done...
c     
      return
      end
