c     
c     Distancematrix (symmetric storage mode)
c     
      real    r(msamat)         ! interatomic distances
c     
      common /dstmat/ r
c     
c     Bondlist
c     
      integer nbnd              ! number of bonds
      integer bnd(2,mbtot)      ! 2 atoms that form bond
      real    bndl0(mbtot)      ! equilibrium bondlength
      real    bndl(mbtot)       ! effective bondlength
      real    kbnd(mbtot)       ! force constant
      real    p(mspmat)         ! bondordermatrix
      real    eibond(mbtot)     ! Bond stretch energy
c     
      common /bond/ nbnd,bnd,bndl0,bndl,kbnd,p,eibond
c     
c     List of bondangles
c     
      integer nang              ! number of bondangles
      integer ang(3,mantot)     ! 3 atoms that form angle
      real    angl0(mantot)     ! equilibrium angle
      real    angl(mantot)      ! effective angle
      real    kang(mantot)      ! force constant
      real    kang3(mantot)     ! force constant (cubic)
      real    eiangl(mantot)    ! Angle bending energy
c     
      common /angle/ nang,ang,angl0,angl,kang,kang3,eiangl
c     
c     List of torsionangles
c     
      integer ntor              ! number of torsionangles
      integer tor(4,mtotot)     ! 4 atoms that form angle
      real    tora(mtotot)      ! torsion angle
      integer tortyp(mtotot)    ! type (1=pi,2=sigma)
      real    kzt(mtotot)       ! forceconstant (deform)
      real    ktt(mtotot)       ! forceconstant (pi,strain)
      real    kvor(mtotot)      ! forceconstant (pi,strain)
      real    eitord(mtotot)    ! Torsion (deform.) energy
      real    eitors(mtotot)    ! Torsion (strain) energy
c     
      common /tors/ ntor,tor,tora,tortyp,kzt,ktt,kvor,eitord,eitors
c     
c     List of out of plane bends (pi atoms)
c     
      integer npla              ! number of planes
      integer pla(4,mplane)     ! 4 atoms of plane
      real    plad(mplane)      ! plane deformation
      real    kpla(mplane)      ! forceconstant
      real    eibend(mplane)    ! OP-Bending energy
c     
      common /plane/ npla,pla,plad,kpla,eibend
c     
c     List of distance constraints
c     
      integer ncon              ! number of distance constraints
      integer atcon(2,mconst)   ! atomnumbers of const. pair
      real    dlow(mconst)      ! lower bound on distance
      real    dhigh(mconst)     ! upper bound
      real    kcon(mconst)      ! force constant
      real    dcon(mconst)      ! distance 
      real    epen(mconst)      ! energy
c     
      common /constr/ ncon,atcon,dlow,dhigh,kcon,dcon,epen
c     
c     List of dihedral constraints
c     
      integer ncond             ! number of dihedral constraints
      integer atcond(4,mconstd) ! atomnumbers of const.
      real    dlowd(mconstd)    ! lower bound on distance
      real    dhighd(mconstd)   ! upper bound
      real    kcond(mconstd)    ! force constant
      real    dcond(mconstd)    ! dihedral angle 
      real    epend(mconstd)    ! energy
c     
      common /constrd/ ncond,atcond,dlowd,dhighd,kcond,dcond,epend
c     
c     Partial energies due to bonds, angles, torsions...
c     
      real    ebnd,eang,etors,etord,epla,evdw,esig,epib,hofm,ecou,
     .     econ,rmsG
c     
      common /energy/ ebnd,eang,etors,etord,epla,evdw,esig,epib,
     *     hofm,ecou,econ,rmsG
