      subroutine eout
c     
c     Write Energy summary to outputfile and TTY
c     
      implicit none
      include 'sizes.h'
      include 'apara.h'
      include 'bpara.h'
      include 'atom.h'
      include 'energy.h'
      include 'fock.h'
      include 'option.h'
      include 'worksp.h'

      integer i,k,l,kt,lt,li,j,lj,lij
      real rex,zi,zj,hofa,etot,egf
c     
c     Compute energy of sigmabonds
c     
      esig=0.0
      do 190 i=1,nbnd
         k=bnd(1,i)
         l=bnd(2,i)
         kt=ntype(k)
         lt=ntype(l)
         rex=ame(kt,lt)*(al(kt,lt)-bndl(i))
         esig=esig+de(kt,lt)*((exp(rex)-1)**2-1)
 190  continue
      esig=esig*96.53083        ! eV --> kJ/mole
c     
c     Compute pi-bond energy
c     
      epib=0.0
      do 290 i=1,natpi
         zi=npiel(ntype(atnr(i)))
         li=(i*(i+1))/2
         epib=epib+p(li)*beta(li)+0.25*p(li)*p(li)*gamma(li)-
     *        beta(li)*zi-gamma(li)*(zi-1.0)
         do 280 j=i+1,natpi
            lj=(j*(j+1))/2
            lij=lj-j+i
            zj=npiel(ntype(atnr(j)))
            epib=epib+2*p(lij)*beta(lij)+
     *           (p(li)-zi)*(p(lj)-zj)*gamma(lij)-
     *           0.5*p(lij)*p(lij)*gamma(lij)
 280     continue
 290  continue
      epib=epib*96.53083        ! eV --> kJ/mole
c     
c     Sum heats of formation of free atoms
c     
      hofa=0.0
      do 390 i=1,nat
         hofa=hofa+dhfa(ntype(i))
 390  continue
      hofa=hofa*4.186           ! kcal/mole --> kJ/mole
c     
c     Compute forcefield energy
c     
      etot=egf(3*nat,xyz,work)  ! gradient is now in workspace
      etot=602493.3*etot
      ebnd=602493.3*ebnd
      eang=602493.3*eang
      epla=602493.3*epla
      evdw=602493.3*evdw
      etors=602493.3*etors
      etord=602493.3*etord
      ecou=602493.3*ecou
      econ=602493.3*econ
c     
c     Heat of formation
c     
      hofm=(etot-ebnd-etors-ecou-econ)+epib+esig+hofa
c     
c     Produce summary
c     
      write(21,'(/)')
      write(21,'(/a,i4,a/a)')
     *     ' Energy (kJ/mole) after ',ncalls,' functioncalls:',
     *     ' ------------------------------------------'
      if (do_scf)
     *     write(21,'(3(a,f10.2/),a,i10/)')
     *     '  SCF:    Sigmabonds        : ',esig,
     *     '          pi-Bonds          : ',epib,
     *     '          Heat of Formation : ',hofm,
     *     '          Iterations        : ',nscf
      if (ncon+ncond.eq.0) then
         write(21,'(8(a,f10.2/))')
     *        '  MM:     Bond              : ',ebnd,
     *        '          Angle             : ',eang,
     *        '          Torsion (strain)  : ',etors,
     *        '          Torsion (defor.)  : ',etord,
     *        '          Plane             : ',epla,
     *        '          van der Waals     : ',evdw,
     *        '          Coulomb           : ',ecou,
     *        '                TOTAL (MM)  : ',etot
      else
         write(21,'(9(a,f10.2/))')
     *        '  MM:     Bond              : ',ebnd,
     *        '          Angle             : ',eang,
     *        '          Torsion (strain)  : ',etors,
     *        '          Torsion (defor.)  : ',etord,
     *        '          Plane             : ',epla,
     *        '          van der Waals     : ',evdw,
     *        '          Coulomb           : ',ecou,
     *        '          Constraints       : ',econ,
     *        '                TOTAL (MM)  : ',etot
      end if
c     
c     done...
c     
      return
      end
