      subroutine esetup
c     
c     Set up parameters for calculation of MM-energy
c     
      implicit none
      include 'sizes.h'
      include 'apara.h'
      include 'bpara.h'
      include 'atom.h'
      include 'energy.h'

      integer i,j,k,l,nr,nt
      real bord,bo
c     
c     The following procedure returns the bondorder for a pair of pi-atoms:
c     
      bo(i,j)=p((max0(pinr(i),pinr(j))*(max0(pinr(i),pinr(j))-1))/2+
     *     min0(pinr(i),pinr(j)))
c     
c     Equilibrium bondlengths and forceconstants
c     
      do 100 i=1,nbnd
         k=bnd(1,i)
         l=bnd(2,i)
         if (pinr(k).ne.0.and.pinr(l).ne.0) then
            bndl0(i)=al(ntype(k),ntype(l))
     *           -bl(ntype(k),ntype(l))*bo(k,l)
         else
            bndl0(i)=al(ntype(k),ntype(l))
         end if
         kbnd(i)=0.001*(pk2(ntype(k),ntype(l))/bndl0(i)**2+
     *        pk4(ntype(k),ntype(l))/bndl0(i)**4+
     *        pk6(ntype(k),ntype(l))/bndl0(i)**6)
 100  continue
c     
c     Equilibrium bondangles and forceconstants
c     
      do 200 i=1,nang
         k=ntype(ang(2,i))
         if (pinr(ang(2,i)).ne.0) then
            j=ang(2,i)
            angl0(i)=amin1(gang(k),
     *           gang(k)-anc1(k)*(bo(j,j)-anc2(k)))
         else
            angl0(i)=gang(k)
         end if
         kang(i)=fcang(k)
         kang3(i)=fcang3(k)
 200  continue
c     
c     Forceconstants for torsional energy
c     
      do 300 i=1,ntor
         tortyp(i)=kttype(ntype(tor(2,i)),ntype(tor(3,i)))
         if (tortyp(i).eq.1.or.tortyp(i).eq.4) then
            kzt(i)=ppit(ntype(tor(1,i)),ntype(tor(4,i)))
            ktt(i)=ptt(ntype(tor(2,i)),ntype(tor(3,i)))
            bord=bo(tor(2,i),tor(3,i))
            kvor(i)=bord*(1.0+0.15*bord)
         else
            kzt(i)=ppiz(ntype(tor(2,i)),ntype(tor(3,i)))
            ktt(i)=ptt(ntype(tor(2,i)),ntype(tor(3,i)))
         end if
 300  continue
c     
c     Forceconstants for pi-center plane deformations
c     
      do 400 i=1,npla
         nr=pla(1,i)
         nt=ntype(nr)
         kpla(i)=fcpla(nt)+bopla(nt)*(npiel(nt)-bo(nr,nr))
 400  continue
c     
c     done...
c     
      return
      end
