      subroutine ffdmp
c     
c     Dump FF and Energies to .DAT File
c     
      implicit none
      include 'sizes.h'
      include 'energy.h'
      include 'atom.h'
c     
      integer i,j,k
      real    cv,ca

      cv=602493.3
      ca=180.0/3.141592653
c     
c     Bondstretching:
c     
      write(21,*) char(12)
      write(21,*) '       F O R C E   F I E L D    E N E R G Y '
      write(21,*) '       ************************************'
      write(21,'(//)')        
      write(21,*) 'Bondstretching:'
      write(21,*) '   1   2  kJ/mole     dist.   Requil.      kbnd'
      do i=1,nbnd
         j=bnd(1,i)
         k=bnd(2,i)
         write(21,'(1x,2i4,1x,f10.5,3(1x,g10.4))') 
     .        j,k,cv*eibond(i),bndl(i),bndl0(i),kbnd(i)
      end do
c     
c     Anglebending
c     
      write(21,'(//)')        
      write(21,*) 'Anglebending:'
      write(21,*) 
     .     '   1   2   3  kJ/mole     angle    equil.      kang'
      do i=1,nang
         write(21,'(1x,3i4,1x,f10.5,4(1x,g10.4))')
     .        (ang(j,i),j=1,3),cv*eiangl(i),
     .        angl(i)*ca,angl0(i)*ca,kang(i)
      end do
c     
c     Torsion
c     
      write(21,'(//)')
      write(21,*) 'Torsion Angles'
      write(21,*) '   1   2   3   4  kJ/mole     angle  type'//
     .     '  k-deform       ktt      kvor'
      do i=1,ntor
         write(21,'(1x,4i4,1x,f10.5,1x,f10.1,i6,3(1x,g10.4))')
     .        (tor(j,i),j=1,4),cv*(eitord(i)+eitors(i)),tora(i)*ca,
     .        tortyp(i),kzt(i),ktt(i),kvor(i)
      end do
c     
c     Put of Plane Bending comes here...
c     
      return 
      end
