      subroutine frageom(q,x,y)
c     
c     Compute cartesian coordinates y from original cartesion coordinates
c     x and generalized coordinates q.
c     
      implicit none
      include 'sizes.h'
      include 'atom.h'
      include 'fragment.h'
c     
      real    q(*),x(3,*),y(3,*),z(3),centr(3)
      integer i,j,k,l,ksingle,kt,ll
c     
c     If there are no fragments copy coordinates.
c     
      if (3*nsingle+6*nfrag.eq.0) then
         do j=1,nat
            do i=1,3
               y(i,j)=x(i,j)
            end do
         end do
         return
      end if
c     
c     Copy single atom coordinates
c     
      ksingle=6*nfrag
      do k=1,fragpt(0)
         j=fragnr(k)
         do i=1,3
            ksingle=ksingle+1
            y(i,j)=q(ksingle)
         end do
      end do
c     
c     Transform coordinates of rigid fragments
c     
      do l=1,nfrag
         call fragrot(q((l-1)*6+4),rfrag)
         do i=1,3
            centr(i)=x(i,cfrag(l))
         end do
         do k=fragpt(l-1)+1,fragpt(l)
            j=fragnr(k)
            kt=(l-1)*6
            do i=1,3
               z(i)=x(i,j)-centr(i)
            end do
            do i=1,3
               kt=kt+1
               y(i,j)=q(kt)
               do ll=1,3
                  y(i,j)=y(i,j)+rfrag(i,ll)*z(ll)
               end do
            end do
         end do
      end do
c     
c     done...
c     
      return
      end
