      subroutine fragrot(tau,r)
c     
c     Compute 3x3 fragment rotation matrix r from three Euler angles
c     tau(1)...tau(3). Angles are in rad.
c     
      implicit none
      real    tau(3),r(3,3),c(3),s(3)
      integer i
c     
c     Compute sines and cosines
c     
      do i=1,3
         c(i)=cos(tau(i))
         s(i)=sin(tau(i))
      end do
c     
c     Now build rotation matrix:
c     
      r(1,1)=c(1)*c(3)-s(1)*c(2)*s(3)
      r(1,2)=-c(1)*s(3)-s(1)*c(2)*c(3)
      r(1,3)=s(1)*s(2)
      r(2,1)=s(1)*c(3)+c(1)*c(2)*s(3)
      r(2,2)=-s(1)*s(3)+c(1)*c(2)*c(3)
      r(2,3)=-c(1)*s(2)
      r(3,1)=s(2)*s(3)
      r(3,2)=s(2)*c(3)
      r(3,3)=c(2)
      return
      end
