      subroutine frotder(tau,dr)
c     
c     Compute derivatives dr of rotation matrix given by three Euler angles
c     tau(1)...tau(3). Angles are in radians.
c     
      implicit none
      real    tau(3),dr(3,3,3),c(3),s(3)
      integer i
c     
c     Compute sines and cosines
c     
      do i=1,3
         c(i)=cos(tau(i))
         s(i)=sin(tau(i))
      end do
c     
c     Compute derivatives
c     
      dr(1,1,1)=-s(1)*c(3)-c(1)*c(2)*s(3)
      dr(1,2,1)=s(1)*s(3)-c(1)*c(2)*c(3)
      dr(1,3,1)=c(1)*s(2)
      dr(2,1,1)=c(1)*c(3)-s(1)*c(2)*s(3)
      dr(2,2,1)=-c(1)*s(3)-s(1)*c(2)*c(3)
      dr(2,3,1)=s(1)*s(2)
      dr(3,1,1)=0.0
      dr(3,2,1)=0.0
      dr(3,3,1)=0.0
c     
      dr(1,1,2)=s(1)*s(2)*s(3)
      dr(1,2,2)=s(1)*s(2)*c(3)
      dr(1,3,2)=s(1)*c(2)
      dr(2,1,2)=-c(1)*s(2)*s(3)
      dr(2,2,2)=-c(1)*s(2)*c(3)
      dr(2,3,2)=-c(1)*c(2)
      dr(3,1,2)=c(2)*s(3)
      dr(3,2,2)=c(2)*c(3)
      dr(3,3,2)=-s(2)
c     
      dr(1,1,3)=-c(1)*s(3)-s(1)*c(2)*c(3)
      dr(1,2,3)=-c(1)*c(3)+s(1)*c(2)*s(3)
      dr(1,3,3)=0.0
      dr(2,1,3)=-s(1)*s(3)+c(1)*c(2)*c(3)
      dr(2,2,3)=-s(1)*c(3)-c(1)*c(2)*s(3)
      dr(2,3,3)=0.0
      dr(3,1,3)=s(2)*c(3)
      dr(3,2,3)=-s(2)*s(3)
      dr(3,3,3)=0.0
c     
c     done...
c     
      return
      end
