      subroutine getmol(nat,name,coord,ntype,chr,chrgok,nbnds,bnd,*)
c     
c     Copy molecular description from SYBYL-common to internal data structure
c     
      implicit none
      include 'sizes.h'
      include 'sybcom.h'
      include 'option.h'
      integer      nat,ntype(matot),nbnds,bnd(2,mbtot),
     *     nbr_of_bonds(matot)
      real         coord(3,matot),chr(matot)
      character    name(matot)*8
      logical      chrgok
c     
      integer      ptp(mxnat),piff_type(31)
      integer      pi_system(matype)
      integer      hb_donor(matype)
      integer      minbnd(matype),maxbnd(matype)
      integer      i,k,i1,i2,nr,j,n_illegal
c     
      data piff_type /
     *     2,1,1,0,6,5,0,9,7,11,
     *     5,0,3,0,13,0,0,10,4,-1,
     *     0,0,0,0,0,-1,0,4,0,0,
     *     6 /
c     
      data pi_system /
     *     1,0,0,1,1,0,1,1,0,1,0,1,0,0 /
c     
      data hb_donor /
     *     0,0,0,1,1,1,0,1,1,0,0,0,0,0 /
c     
      data minbnd / 
     *     3,4,1,3,2,3,1,2,2,2,2,0,0,1 /
c     
      data maxbnd /
     *     3,4,1,4,3,4,1,2,2,2,2,1,1,1 /
c     
c     Assign PIFF atomtypes
c     
      n_illegal=0
      do i=1,nat1
         ptp(i)=0
         if (natp(i).le.31.and.natp(i).ge.1) then
            nbr_of_bonds(i)=0
            ptp(i)=piff_type(natp(i))
         end if   
         if (ptp(i).eq.0) n_illegal=n_illegal+1
      end do
      if (n_illegal.gt.0) then
         do i=1,nat1
            if (ptp(i).eq.0) then
               write(6,'(a,i3,1x,a)') ' Illegal atomtype ',natp(i),
     *              natlab(i)
            end if
         end do
         return 1
      end if
c     
c     Make PIFF types unambiguous
c     
      do k=1,nbond
         i1=nbnd(1,k)
         i2=nbnd(2,k)
         if (ptp(i1).eq.3) then
            if (hb_donor(ptp(i2)).eq.1) ptp(i1)=14
         else if (ptp(i1).eq.9) then
            if (pi_system(ptp(i2)).eq.1) ptp(i1)=8
         else if (ptp(i1).eq.13) then
            if (pi_system(ptp(i2)).eq.1) ptp(i1)=12
         end if
         if (ptp(i2).eq.3) then
            if (hb_donor(ptp(i1)).eq.1) ptp(i2)=14
         else if (ptp(i2).eq.9) then
            if (pi_system(ptp(i1)).eq.1) ptp(i2)=8
         else if (ptp(i2).eq.13) then
            if (pi_system(ptp(i1)).eq.1) ptp(i2)=12
         end if
      end do
c     
c     Renumber atoms
c     
      nat=0
      do i=1,nat1
         if (ptp(i).gt.0) then
            nat=nat+1
            natp(i)=natp(i)+1000*nat
         end if
      end do
      if (nat.gt.matot) then
         write(6,'(a)') ' Too many atoms for PIFF'
         return 1
      end if
      do i=1,nat1
         nr=natp(i)/1000
         if (nr.gt.0) then
            do k=1,3
               coord(k,nr)=xyz(k,i)
            end do
            name(nr)=natlab(i)
            ntype(nr)=ptp(i)
            if (chfl) chr(nr)=chrg(i)
         end if
      end do
c     
c     Renumber and copy bonds
c     
      nbnds=0 
      do j=1,nbond
         if (ptp(nbnd(1,j)).gt.0.and.ptp(nbnd(2,j)).gt.0
     *        .and.nbndtp(j).ne.8) then
            i1=natp(min0(nbnd(1,j),nbnd(2,j)))/1000
            i2=natp(max0(nbnd(1,j),nbnd(2,j)))/1000
            if (i1.ne.0.and.i2.ne.0) then
               nbnds=nbnds+1
               if (nbnds.le.mbtot) then
                  bnd(1,nbnds)=i1
                  bnd(2,nbnds)=i2
               end if
            end if
         end if
      end do
      if (nbnds.gt.mbtot) then
         write(6,'(a)') ' Too many bonds for PIFF'
         return 1
      end if
c     
c     Does the molecule have valid charges ?
c     
      chrgok=chfl
c     
c     A few checks on atomtypes...
c     
      if (check_bonds) then
         do i=1,nbnds
            nbr_of_bonds(bnd(1,i))=nbr_of_bonds(bnd(1,i))+1
            nbr_of_bonds(bnd(2,i))=nbr_of_bonds(bnd(2,i))+1
         end do
         n_illegal=0
         do i=1,nat
            if (ntype(i).eq.7.and.nbr_of_bonds(i).eq.2) ntype(i)=8
            if (nbr_of_bonds(i).lt.minbnd(ntype(i))) then
               n_illegal=n_illegal+1
               do k=1,nat1
                  if (natp(k)/1000.eq.i) then
                     write(6,'(a,i4)') ' Too few bonds to atom ',k
                     write(21,'(a,i4)') ' Too few bonds to atom ',k
                  end if
               end do
            end if
            if (nbr_of_bonds(i).gt.maxbnd(ntype(i))) then
               n_illegal=n_illegal+1
               do k=1,nat1
                  if (natp(k)/1000.eq.i) then
                     write(6,'(a,i3)') ' Too many bonds to atom ',k
                     write(21,'(a,i3)') ' Too many bonds to atom ',k
                  end if
               end do
            end if
         end do
         if (n_illegal.gt.0) return 1
      end if
c     
c     done...
c     
      return
      end
