      subroutine hueckl(*)
c     
c     Do an initial Hueckel to get first approx. to bond order matrix...
c     5-Sep-1986 : self consistent HMO, independent of starting geometry.
c     
      implicit none
      include 'sizes.h'
      include 'atom.h'
      include 'energy.h'
      include 'apara.h'
      include 'bpara.h'
      include 'fock.h'
      include 'worksp.h'
      include 'option.h'
      real    blb,alb,delta
      integer nloops
      integer max_loops,i1,i2,ier,i,j
c     
      nscf=0
      if (nelpi.eq.0) return
      if (natpi.gt.mwork) then
         write(6,'(a)') ' Workspace for Hueckel is too small.'
         return 1
      end if
c     
c     Build Hueckelmatrix (symmetric storage mode) FM
c     
      do i=1,mspmat
         p(i)=0.5 
      end do
      nloops=0
      max_loops=10
      if (do_scf) nloops=1
c     
c     The following uses formula 44 of QC-3 p. 154
c     
 10   continue
      do i=1,natpi
         do j=1,natpi
            evec(i,j)=0.0
         end do
      end do
      do i=1,nbnd
         i1=pinr(max0(bnd(1,i),bnd(2,i)))
         i2=pinr(min0(bnd(1,i),bnd(2,i)))
         if (i1.ne.0.and.i2.ne.0) then
            j=(i1*(i1-1))/2+i2
            blb=bl(ntype(i1),ntype(i2))
            if (do_scf) then
               alb=al(ntype(i1),ntype(i2))
               evec(i1,i2)=exp(ybeta*(alb-bndl(i)-0.667*blb))
               evec(i2,i1)=evec(i1,i2)
            else
               evec(i1,i2)=exp(ybeta*blb*p(j)-0.667)
               evec(i2,i1)=evec(i1,i2)
            end if
         end if
      end do
c     
c     Diagonal terms
c     
      do i=1,natpi
         evec(i,i)=hucka(ntype(atnr(i)))
      end do
c     
c     Use EISPACK routines to solve Eigenproblem
c     
      call EPtred2(mpiat,natpi,evec,eval,work,evec)
      call EPimtql2(mpiat,natpi,eval,work,evec,ier)
      if (ier.ne.0) then
         write(21,'(a)') 'Bad return from IMTQL2 in HUECKL.'
         write( *,'(a)') 'Bad return from IMTQL2 in HUECKL.'
         return 1
      end if
      call bomatr(delta)
      nloops=nloops+1
      if (delta.gt.0.05.and.nloops.lt.max_loops) go to 10
c     
c     done...
c     
      return
      end
