      subroutine inifrag(q)
c     
c     Initialize generalized fragment coordinates from cartesian coordinates.
c     
      implicit none
      include 'sizes.h'
      include 'atom.h'
      include 'fragment.h'
      include 'tree.h'
c     
      real    q(*),centr(3),dmin,d
      integer i,j,k,l,nq
c     
c     Compute centroids of rigid fragments and assign pivot to atom nearest
c     to centroid
c     
      do k=1,nfrag
         do i=1,3
            centr(i)=0.0
         end do
         do l=fragpt(k-1)+1,fragpt(k) 
            j=fragnr(l)
            do i=1,3
               centr(i)=centr(i)+xyz(i,j)
            end do
         end do
         do i=1,3
            centr(i)=centr(i)/fragsize(k)
         end do
         cfrag(k)=fragnr(fragpt(k-1)+1)
         dmin=(centr(1)-xyz(1,cfrag(k)))**2
     *        +(centr(2)-xyz(2,cfrag(k)))**2
     *        +(centr(3)-xyz(3,cfrag(k)))**2
         do l=fragpt(k-1)+2,fragpt(k)
            j=fragnr(l)
            d=(centr(1)-xyz(1,j))**2+(centr(2)-xyz(2,j))**2
     *           +(centr(3)-xyz(3,j))**2
            if (d.lt.dmin) then
               cfrag(k)=j
               dmin=d
            end if
         end do
      end do
c     
c     Compute generalized fragment coordinates
c     
      nq=6*nfrag
      do i=1,nq
         q(i)=0.0
      end do
      do k=1,nfrag
         l=(k-1)*6
         do i=1,3
            q(l+i)=xyz(i,cfrag(k))
         end do
      end do
c     
c     Initialize single atom coordinates
c     
      do k=1,nsingle
         do i=1,3
            nq=nq+1
            q(nq)=xyz(i,fragnr(k))
         end do
      end do
c     
c     Initialize flexible bond coordinates
c     
      do k=1,nrotb
         q(nq+k)=0.0
      end do
c     
c     done...
c     
      return
      end
