      subroutine mmcalc
c     
c     Molecular mechanics part of PIFF
c     
      implicit none
      include 'sizes.h'
      integer nfrq,nw,mxq
      parameter (nfrq=9*matot+1)
      parameter (nw=12*matot+1)
      parameter (mxq=3*matot)
c     
      include 'atom.h'
      include 'energy.h'
      include 'worksp.h'
      include 'option.h'
      include 'tree.h'
      include 'fragment.h'
c     
      real    q(mxq),ef
      integer nq,status,conjgrad
c     
      equivalence (q,work(nfrq))
c     
      external egeneral,egf
c     
c     Select Energy function
c     
      if (method.eq.1) then     ! cartesian coordinates
         status=conjgrad(egf,3*nat,xyz,ef,work,deexp,agr,negr)
         mmcon=status.ge.0
      else if (method.eq.2) then ! generalized coordinates
         call inifrag(q)
         nq=nrotb+3*nsingle+6*nfrag
         status=conjgrad(egeneral,nq,q,ef,work(nw),deexp,agr,negr)
         call geom(q,xyz,xyz)
         mmcon=status.ge.0
      else                      ! unknown method
         write(21,'(a)') ' Minimization method not implemented.'
         mmcon=.false.
      end if
c     
c     done...
c     
      return
      end
