      subroutine moldmp
c     
c     Dump molecular data to printfile
c     
      implicit none
      include 'sizes.h'
      include 'atom.h'
      include 'energy.h'
      include 'apara.h'
      include 'bpara.h'
      include 'worksp.h'
c     
      real     force(3,matot),fmax,rms,pich,pibo
      equivalence (work,force)

      integer i,k,l
c     
c     Write Heading
c     
      write(21,'(a)') char(12)  ! Start on a new page
      write(21,'(//a/a)')
     *     '         Atom                   Coordinates (A)   '//
     *     '                                   Force (mdyn)',
     *     '  Nr  Name      Type         x         y         z'//
     *     '      Charge     Pi-ch        x         y         z'
c     
c     Convert forces from dyn to mdyn
c     
      do i=1,nat
         do k=1,3
         end do
      end do
      rms=0.0
      fmax=0.0
      do i=1,nat
         do k=1,3
            force(k,i)=-1000.0*force(k,i)
            rms=rms+force(k,i)**2.0
            fmax=amax1(fmax,abs(force(k,i)))
         end do
      end do
      rms=sqrt(rms/(3*nat))
      rmsG=rms
c     
c     Write Data for molecular parameters.
c     
      do i=1,nat
         if (pinr(i).ne.0) then
            pich=npiel(ntype(i))-p((pinr(i)*(pinr(i)+1))/2)
            write(21,'(i4,2x,a8,2x,a4,2x,3f10.3,2f10.5,2x,3f10.4)')
     *           i,name(i),ctype(i),(xyz(k,i),k=1,3),chrg(i),pich,
     *           (force(k,i),k=1,3)
         else
            write(21,'(i4,2x,a8,2x,a4,2x,3f10.3,f10.5,12x,3f10.4)')
     *           i,name(i),ctype(i),(xyz(k,i),k=1,3),chrg(i),
     *           (force(k,i),k=1,3)
         end if
      end do
c     
c     If pi-system is present, write list of bonds with their pi-bondorders
c     
      if (nelpi.gt.0) then
         write(21,'(//a/a)') 
     *        '              List of  pi-Bonds',
     *        '  Nr  Name        Nr  Name       pi-Bondorder'
         do i=1,nbnd
            k=bnd(1,i)
            l=bnd(2,i)
            if (pinr(k).ne.0.and.pinr(l).ne.0) then
               pibo=(al(ntype(k),ntype(l))-bndl0(i))/
     *              bl(ntype(k),ntype(l))
               write(21,'(i4,2x,a8,2x,i4,2x,a8,f12.4)')
     *              k,name(k),l,name(l),pibo
            end if
         end do
      end if
c     
c     gradient summary...
c     
      write(21,'(/a,f10.5/a,f10.5)')
     *     '   Gradient r.m.s (mdyn) : ',rms,
     *     '      "     max.  (mdyn) : ',fmax
c     
c     Constraints
c     
      if (ncon.gt.0) then
         write(21,'(//,a/a)')
     *     '                        Distance Constraints',
     *     '  Nr   from    to     dmin        d    dmax       Energy'//
     *     ' Force const.'
         do i=1,ncon
            write(21,'(i4,i7,i6,f9.2,f9.2,f8.2,f13.2,f13.2)')
     *           i,atcon(1,i),atcon(2,i),dlow(i),dcon(i),dhigh(i),
     *           epen(i)*602493.3,kcon(i)
         end do
      end if
      if (ncond.gt.0) then
         write(21,'(//,a/a)')
     *        '                         Dihedral  Constraints',
     *        '  Nr  n1  n2  n3  n4     dmin        d     dmax       '
     *        //'Energy Force const.'
         do i=1,ncond
            write(21,'(i4,4i4,f9.2,f9.2,f9.2,f13.2,f13.2)')
     *           i,(atcond(k,i),k=1,4),dlowd(i),dcond(i),dhighd(i),
     *           epend(i)*602493.3,kcond(i)
         end do
      end if
c     
c     Done...
c     
      write(21,'(//)')
      return
      end
