      subroutine molrd(nin,status)
c     ****************************
c     
c     the subroutine reads the sybyl.mol-file into the common
c     block 'sybcom'.
c     
c     status = 0: no errors.
c     = 1: file has not mol-file format.
c     = 2: error in mol-file.
c     = 3: too many atoms.
c     
      implicit none
      include 'sybcom.h'
c     
      integer ichrg(5)
c     
      character line*80,idmol*4
      integer i,k,nft,nftch,nchrg,nftyp,j,nin,status
      real val2,val1,chflag
c     
      status = 0
      chflag=0
c     
c     read atom records:
c     
      read(nin,1000,err=100) nat1,idmol,molnam,filnam,iroot
 1000 format(i4,a,10x,a,1x,a,1x,i4)
      if(idmol.ne.' MOL') then
         status = 1
         return 
      end if
      if(nat1.gt.mxnat) then
         status=3
         return 
      end if
      do i = 1,nat1
         read(nin,1010,err=100) natp(i),(xyz(k,i),k=1,3),natlab(i)
 1010    format(4x,1i4,3f9.4,a)
      end do
c     
c     read bond records:
c     
      read(nin,1000,err=100) nbond
      do i = 1,nbond
         read(nin,1020,err=100) nbnd(1,i),nbnd(2,i),nbndtp(i)
 1020    format(4x,2i4,9x,i4)
      end do
c     
c     read feature records:
c     
      chfl = .false.
      do i = 1,mxnat
         chrg(i) = 0.0
      end do
      read(nin,'(i4)',end=90,err=100) nft
      if(nft.eq.0) return
c     
      nfta = 0
      nftch = 0
      nchrg = 0
      do i =1,nft
         read(nin,'(a)') line
         read(line,'(i4)',err=100) nftyp
         if(nftyp.eq.4) then
            nftch = nftch + 1
            read(line,1025,err=100) (ichrg(j),j=1,5),val1,val2
 1025       format(4x,5i6,2f8.4)
            do 20 j = 1,5
               nchrg = nchrg + 1
               chrg(nchrg) = float(ichrg(j))/10000.
 20         continue
            if(nftch.eq.1) chflag = val2
            if(nftch.eq.2) chgmet = val1
         else
            nfta = nfta + 1
            ftlin(nfta) = line
         end if
      end do
      chfl = (chflag.lt.0.1).and.nftch.gt.0
c     
      if(.not.chfl) then
         nft = nfta
         chgmet = 0.0
         do i = 1,nat1
            chrg(i) = 0.0
         end do
      end if
 90   return
c     
 100  status = 2
      return 
c     
      end
