      Block Data PDATA
c     
c     Parametrization (MO and MM)
c     
      implicit none
      include 'sizes.h'
      include 'apara.h'
      include 'bpara.h'

      integer i
c     
c     Type designators
c     
      data type /
     *     'CSP2',  'CSP3',  'H   ',  'NPOL',  'NPIN',
     *     'NAIN',  'OCAR',  'OETP',  'OETS',  'STEP',
     *     'STES',  'CLP ',  'CLS ',  'HBND'               /
c     
c     Atomic number for each atomtype
c     
      data atnb /
     *     6,       6,       1,       7,       7,
     *     7,       8,       8,       8,      16,
     *     16,      17,      17,       1               /
c     
c     Number of pi-electrons for each atomtype
c     
      data npiel /
     *     1,       0,       0,       2,       1,
     *     0,       1,       2,       0,       2,
     *     0,       2,       0,       0               /
c     
c     Corrections for Hueckel alpha's  (from QC-3 p. 158)
c     
      data hucka /
     *     0.0,     0.0,     0.0,     1.5,     0.5,
     *     0.0,     1.0,     2.0,     0.0,     0.0,
     *     0.0,     2.0,     0.0,     0.0               /
c     
c     Effective nuclear charges for Slater-Zener orbitals (PIMM)
c     
      data zsz /
     *     3.18,    0.00,    0.00,    4.92,    3.55,
     *     0.00,    4.18,    5.43,    0.00,    4.55,
     *     0.00,    4.50,    0.00,    0.00               /
c     
c     Parameters for twocenter repulsion integrals gamma (QC-3 Tab. 4.4.1 p. 182)
c     
      data tcri /
     *     11.13,    0.00,    0.00,   16.63,   12.34,
     *     0.00,   15.23,   18.60,    0.00,   11.90,
     *     0.00,   10.81,    0.00,    0.00               /
c     
c     Ionisation potentials uip (QC-3 Tab. 4.4.1 p. 182)
c     
      data uip /
     *     -11.16,    0.00,    0.00,  -28.59,  -14.12,
     *     0.00,  -17.70,  -33.90,    0.00,  -22.88,
     *     0.00,  -25.32,    0.00,    0.00               /
c     
c     y of formula 44 QC-3 p. 154 (relation between bondorder and beta)
c     
      data ybeta / 4.0 /
c     
c     Equilibrium bondangles (PIMM)
c     
      data gang /
     *     2.09440, 1.91986,     0.0, 2.09440, 2.09440,
     *     1.91986,     0.0, 1.95477, 1.95477, 1.83260,
     *     1.83260,     0.0,     0.0,     0.0 /
c     
c     Forceconstant for bondangle bending (PIMM)
c     
      data fcang /
     *     0.572E-3,0.572E-3,     0.0,0.486E-3,0.798E-3,
     *     0.486E-3,0.752E-3,0.798E-3,0.798E-3,0.800E-3,
     *     0.800E-3,     0.0,     0.0,     0.0 /
c     
c     Forceconstant for angle bending (cubic part) PIMM
c     
      data fcang3 /
     *     -0.662E-9,-1.246E-9,    0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
c     
c     Angle correction for pi-atoms (currently N-Pyrrol only)
c     
      data anc1 /
     *     0.0,     0.0,     0.0,  1.7453,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
c     
      data anc2 /
     *     0.0,     0.0,     0.0,     1.9,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
c     
c     Forceconstants for out of plane deformations of pi-atoms (PIMM)
c     
      data fcpla /
     *     0.137E-3,     0.0,     0.0,   0.000,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
c     
c     Bondorder correction for fcpla (PIMM): fc=fcpla+bopla*(npiel-p)
c     
      data bopla /
     *     0.00,     0.0,     0.0,.3333E-3,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
c     
c     Heats of formation for free atoms (PIMM) kcal/mole
c     
      data dhfa /
     *     170.89,  170.89,   52.10,  113.00,  113.00,
     *     113.00,   59.60,   59.60,   59.60,   65.65,
     *     65.65,   28.95,   28.95,   52.10               /
c     
c     Bondlengthparameters al and bl : r(equil.)=al-bl*bondorder.
c     (Original PIMM parameters).
c     
      data (al(i,1),i=1,matype) /
     *     1.512,   1.528,   1.080,   1.428,   1.448,
     *     1.428,   1.385,   1.395,   1.395,   1.802,
     *     1.802,   1.720,   1.720,   1.080 /
      data (al(i,2),i=1,matype) /
     *     1.528,   1.544,   1.080,   1.472,   1.472,
     *     1.472,   1.426,   1.426,   1.426,   1.820,
     *     1.820,   1.767,   1.767,   1.080 /
      data (al(i,3),i=1,matype) /
     *     1.080,   1.080,     0.0,   1.010,   1.010,
     *     1.010,   0.960,   0.960,   0.960,   1.330,
     *     1.330,     0.0,     0.0,     0.0 /
      data (al(i,4),i=1,matype) /
     *     1.428,   1.472,   1.010,   1.417,   1.417,
     *     1.417,   1.380,   1.405,   1.405,     0.0,
     *     0.0,     0.0,     0.0,   1.010 /
      data (al(i,5),i=1,matype) /
     *     1.448,   1.472,   1.010,   1.417,   1.417,
     *     1.417,   1.370,   1.395,   1.395,     0.0,
     *     0.0,     0.0,     0.0,   1.010 /
      data (al(i,6),i=1,matype) /
     *     1.428,   1.472,   1.010,   1.417,   1.417,
     *     1.417,   1.380,   1.405,   1.405,     0.0,
     *     0.0,     0.0,     0.0,   1.010 /
      data (al(i,7),i=1,matype) /
     *     1.385,   1.426,   0.960,   1.380,   1.370,
     *     1.380,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,   0.960 /
      data (al(i,8),i=1,matype) /
     *     1.395,   1.426,   0.960,   1.405,   1.395,
     *     1.405,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,   0.960 /
      data (al(i,9),i=1,matype) /
     *     1.395,   1.426,   0.960,   1.405,   1.395,
     *     1.405,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,   0.960 /
      data (al(i,10),i=1,matype) /
     *     1.802,   1.820,   1.330,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,   1.330 /
      data (al(i,11),i=1,matype) /
     *     1.802,   1.820,   1.330,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     2.038,     0.0,     0.0,   1.330 /
      data (al(i,12),i=1,matype) /
     *     1.720,   1.767,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (al(i,13),i=1,matype) /
     *     1.720,   1.767,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (al(i,14),i=1,matype) /
     *     1.080,   1.080,     0.0,   1.010,   1.010,
     *     1.010,   0.960,   0.960,   0.960,   1.330,
     *     1.330,     0.0,     0.0,     0.0 /
c     
      data (bl(i,1),i=1,matype) /
     *     0.174,     0.0,     0.0,   0.178,   0.178,
     *     0.0,   0.185,   0.185,     0.0,   0.229,
     *     0.0,   0.230,     0.0,     0.0 /
      data (bl(i,2),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bl(i,3),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bl(i,4),i=1,matype) /
     *     0.178,     0.0,     0.0,   0.177,   0.177,
     *     0.0,   0.190,   0.190,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bl(i,5),i=1,matype) /
     *     0.178,     0.0,     0.0,   0.177,   0.177,
     *     0.0,   0.190,   0.190,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bl(i,6),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bl(i,7),i=1,matype) /
     *     0.185,     0.0,     0.0,   0.190,   0.190,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bl(i,8),i=1,matype) /
     *     0.185,     0.0,     0.0,   0.190,   0.190,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bl(i,9),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bl(i,10),i=1,matype) /
     *     0.229,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bl(i,11),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bl(i,12),i=1,matype) /
     *     0.230,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bl(i,13),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bl(i,14),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
c     
c     Bondenergyparameters (sigma) PIMM, eV
c     
      data (de(i,1),i=1,matype) /
     *     3.9409,  3.8827,  4.4375,  3.3463,  3.3463,
     *     3.3463,  3.9987,  3.9987,  3.9987,  3.2783,
     *     3.2783,  3.5770,  3.5770,  4.4375 /
      data (de(i,2),i=1,matype) /
     *     3.8827,  3.6022,  4.2759,  3.0950,  3.0950,
     *     3.0950,  3.5780,  3.5780,  3.5780,  2.9964,
     *     2.9964,  3.4474,  3.4474,  4.2759 /
      data (de(i,3),i=1,matype) /
     *     4.4375,  4.2759,     0.0,  3.9130,  3.9130,
     *     3.9130,  4.5950,  4.5950,  4.5950,  3.6150,
     *     3.6150,     0.0,     0.0,     0.0 /
      data (de(i,4),i=1,matype) /
     *     3.3463,  3.0950,  3.9130,  2.6020,  2.6020,
     *     2.6020,  2.4720,  2.4720,  2.4720,     0.0,
     *     0.0,     0.0,     0.0,  3.9130 /
      data (de(i,5),i=1,matype) /
     *     3.3463,  3.0950,  3.9130,  2.6020,  2.6020,
     *     2.6020,  2.4720,  2.4720,  2.4720,     0.0,
     *     0.0,     0.0,     0.0,  3.9130 /
      data (de(i,6),i=1,matype) /
     *     3.3463,  3.0950,  3.9130,  2.6020,  2.6020,
     *     2.6020,  2.4720,  2.4720,  2.4720,     0.0,
     *     0.0,     0.0,     0.0,  3.9130 /
      data (de(i,7),i=1,matype) /
     *     3.9987,  3.5780,  4.5950,  2.4720,  2.4720,
     *     2.4720,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,  4.5950 /
      data (de(i,8),i=1,matype) /
     *     3.9987,  3.5780,  4.5950,  2.4720,  2.4720,
     *     2.4720,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,  4.5950 /
      data (de(i,9),i=1,matype) /
     *     3.9987,  3.5780,  4.5950,  2.4720,  2.4720,
     *     2.4720,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,  4.5950 /
      data (de(i,10),i=1,matype) /
     *     3.2783,  2.9964,  3.6150,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,  3.6150 /
      data (de(i,11),i=1,matype) /
     *     3.2783,  2.9964,  3.6150,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     3.0637,     0.0,     0.0,  3.6150 /
      data (de(i,12),i=1,matype) /
     *     3.5770,  3.4474,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (de(i,13),i=1,matype) /
     *     3.5770,  3.4474,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (de(i,14),i=1,matype) /
     *     4.4375,  4.2759,     0.0,  3.9130,  3.9130,
     *     3.9130,  4.5950,  4.5950,  4.5950,  3.6150,
     *     3.6150,     0.0,     0.0,     0.0 /
c     
c     Morse constant for sigmabond energy (PIMM) 
c     
      data (ame(i,1),i=1,matype) /
     *     2.0022,  1.8641,  1.3320,  1.9209,  1.9209,
     *     1.9209,  1.7870,  1.7870,  1.7870,  1.9663,
     *     1.9663,  1.8000,  1.8000,  1.3320 /
      data (ame(i,2),i=1,matype) /
     *     1.8641,  1.8407,  1.3800,  1.2959,  1.2959,
     *     1.2959,  1.0838,  1.0838,  1.0838,  1.9663,
     *     1.9663,  1.8000,  1.8000,  1.3800 /
      data (ame(i,3),i=1,matype) /
     *     1.3320,  1.3800,     0.0,  1.4690,  1.4690,
     *     1.4690,  1.2400,  1.2400,  1.2400,  1.5000,
     *     1.5000,     0.0,     0.0,     0.0 /
      data (ame(i,4),i=1,matype) /
     *     1.9209,  1.2959,  1.4690,  2.5290,  2.5290,
     *     2.5290,  2.0275,  2.0275,  2.0275,     0.0,
     *     0.0,     0.0,     0.0,  1.4690 /
      data (ame(i,5),i=1,matype) /
     *     1.9209,  1.2959,  1.4690,  2.5290,  2.5290,
     *     2.5290,  2.0275,  2.0275,  2.0275,     0.0,
     *     0.0,     0.0,     0.0,  1.4690 /
      data (ame(i,6),i=1,matype) /
     *     1.9209,  1.2959,  1.4690,  2.5290,  2.5290,
     *     2.5290,  2.0275,  2.0275,  2.0275,     0.0,
     *     0.0,     0.0,     0.0,  1.4690 /
      data (ame(i,7),i=1,matype) /
     *     1.7870,  1.0838,  1.2400,  2.0275,  2.0275,
     *     2.0275,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,  1.2400 /
      data (ame(i,8),i=1,matype) /
     *     1.7870,  1.0838,  1.2400,  2.0275,  2.0275,
     *     2.0275,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,  1.2400 /
      data (ame(i,9),i=1,matype) /
     *     1.7870,  1.0838,  1.2400,  2.0275,  2.0275,
     *     2.0275,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,  1.2400 /
      data (ame(i,10),i=1,matype) /
     *     1.9663,  1.9663,  1.5000,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,  1.5000 /
      data (ame(i,11),i=1,matype) /
     *     1.9663,  1.9663,  1.5000,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     1.5328,     0.0,     0.0,  1.5000 /
      data (ame(i,12),i=1,matype) /
     *     1.8000,  1.8000,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ame(i,13),i=1,matype) /
     *     1.8000,  1.8000,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ame(i,14),i=1,matype) /
     *     1.3320,  1.3800,     0.0,  1.4690,  1.4690,
     *     1.4690,  1.2400,  1.2400,  1.2400,  1.5000,
     *     1.5000,     0.0,     0.0,     0.0 /
c     
c     K-parameter for resonance integrals beta (Dewar,PIMM)
c     
      data (bk(i,1),i=1,matype) /
     *     6.927,     0.0,     0.0,  10.577,   6.635,
     *     0.0,   9.092,  12.100,     0.0,  15.727,
     *     0.0,  15.000,     0.0,     0.0 /
      data (bk(i,2),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bk(i,3),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bk(i,4),i=1,matype) /
     *     10.577,     0.0,     0.0,  17.876,  10.845,
     *     0.0,  16.250,  23.698,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bk(i,5),i=1,matype) /
     *     6.635,     0.0,     0.0,  10.845,   6.579,
     *     0.0,   8.720,  14.371,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bk(i,6),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bk(i,7),i=1,matype) /
     *     9.092,     0.0,     0.0,  16.250,   8.720,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bk(i,8),i=1,matype) /
     *     12.100,     0.0,     0.0,  23.698,  14.371,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bk(i,9),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bk(i,10),i=1,matype) /
     *     15.727,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bk(i,11),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bk(i,12),i=1,matype) /
     *     15.000,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bk(i,13),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (bk(i,14),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
c     
c     Bondlength force constant parameter (second order) PIMM
c     
      data (pk2(i,1),i=1,matype) /
     *     -31.514, -31.514,  5.8320, -22.292, -22.292,
     *     -22.292, -20.067, -20.067, -20.067, -66.726,
     *     -66.726,  10.770,  10.770,  5.8320 /
      data (pk2(i,2),i=1,matype) /
     *     -31.514, -31.514,  5.8320, -22.292, -22.292,
     *     -22.292, -20.067, -20.067, -20.067, -66.726,
     *     -66.726,  10.770,  10.770,  5.8320 /
      data (pk2(i,3),i=1,matype) /
     *     5.8320,  5.8320,     0.0,  5.1005,  5.1005,
     *     5.1005,  4.6080,  4.6080,  4.6080,  8.8445,
     *     8.8445,     0.0,     0.0,     0.0 /
      data (pk2(i,4),i=1,matype) /
     *     -22.292, -22.292,  5.1005, -56.632, -56.632,
     *     -56.632,  18.267,  18.267,  18.267,     0.0,
     *     0.0,     0.0,     0.0,  5.1005 /
      data (pk2(i,5),i=1,matype) /
     *     -22.292, -22.292,  5.1005, -56.632, -56.632,
     *     -56.632,  18.267,  18.267,  18.267,     0.0,
     *     0.0,     0.0,     0.0,  5.1005 /
      data (pk2(i,6),i=1,matype) /
     *     -22.292, -22.292,  5.1005, -56.632, -56.632,
     *     -56.632,  18.267,  18.267,  18.267,     0.0,
     *     0.0,     0.0,     0.0,  5.1005 /
      data (pk2(i,7),i=1,matype) /
     *     -20.067, -20.067,  4.6080,  18.267,  18.267,
     *     18.267,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,  4.6080 /
      data (pk2(i,8),i=1,matype) /
     *     -20.067, -20.067,  4.6080,  18.267,  18.267,
     *     18.267,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,  4.6080 /
      data (pk2(i,9),i=1,matype) /
     *     -20.067, -20.067,  4.6080,  18.267,  18.267,
     *     18.267,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,  4.6080 /
      data (pk2(i,10),i=1,matype) /
     *     -66.726, -66.726,  8.8445,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,  8.8445 /
      data (pk2(i,11),i=1,matype) /
     *     -66.726, -66.726,  8.8445,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     9.5806,     0.0,     0.0,  8.8445 /
      data (pk2(i,12),i=1,matype) /
     *     10.770,  10.770,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk2(i,13),i=1,matype) /
     *     10.770,  10.770,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk2(i,14),i=1,matype) /
     *     5.8320,  5.8320,     0.0,  5.1005,  5.1005,
     *     5.1005,  4.6080,  4.6080,  4.6080,  8.8445,
     *     8.8445,     0.0,     0.0,     0.0 /
c     
c     Bondlength force constant parameter (fourth order) PIMM
c     
      data (pk4(i,1),i=1,matype) /
     *     130.072, 130.072,     0.0,  67.003,  67.003,
     *     67.003,  52.681,  52.681,  52.681, 261.520,
     *     261.520,   0.000,   0.000,     0.0 /
      data (pk4(i,2),i=1,matype) /
     *     130.072, 130.072,     0.0,  67.003,  67.003,
     *     67.003,  52.681,  52.681,  52.681, 261.520,
     *     261.520,   0.000,   0.000,     0.0 /
      data (pk4(i,3),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk4(i,4),i=1,matype) /
     *     67.003,  67.003,     0.0, 179.565, 179.565,
     *     179.565, -61.330, -61.330, -61.330,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk4(i,5),i=1,matype) /
     *     67.003,  67.003,     0.0, 179.565, 179.565,
     *     179.565, -61.330, -61.330, -61.330,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk4(i,6),i=1,matype) /
     *     67.003,  67.003,     0.0, 179.565, 179.565,
     *     179.565, -61.330, -61.330, -61.330,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk4(i,7),i=1,matype) /
     *     52.681,  52.681,     0.0, -61.330, -61.330,
     *     -61.330,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk4(i,8),i=1,matype) /
     *     52.681,  52.681,     0.0, -61.330, -61.330,
     *     -61.330,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk4(i,9),i=1,matype) /
     *     52.681,  52.681,     0.0, -61.330, -61.330,
     *     -61.330,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk4(i,10),i=1,matype) /
     *     261.520, 261.520,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk4(i,11),i=1,matype) /
     *     261.520, 261.520,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk4(i,12),i=1,matype) /
     *     0.000,   0.000,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk4(i,13),i=1,matype) /
     *     0.000,   0.000,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk4(i,14),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
c     
c     Bondlength force constant parameter (sixth order) PIMM
c     
      data (pk6(i,1),i=1,matype) /
     *     -70.269, -70.269,     0.0,  -6.018,  -6.018,
     *     -6.018,   3.629,   3.629,   3.629,   0.000,
     *     0.000,   0.000,     0.0,     0.0 /
      data (pk6(i,2),i=1,matype) /
     *     -70.269, -70.269,     0.0,  -6.018,  -6.018,
     *     -6.018,   3.629,   3.629,   3.629,   0.000,
     *     0.000,   0.000,     0.0,     0.0 /
      data (pk6(i,3),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk6(i,4),i=1,matype) /
     *     -6.018,  -6.018,     0.0, -94.043, -94.043,
     *     -94.043,  75.710,  75.710,  75.710,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk6(i,5),i=1,matype) /
     *     -6.018,  -6.018,     0.0, -94.043, -94.043,
     *     -94.043,  75.710,  75.710,  75.710,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk6(i,6),i=1,matype) /
     *     -6.018,  -6.018,     0.0, -94.043, -94.043,
     *     -94.043,  75.710,  75.710,  75.710,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk6(i,7),i=1,matype) /
     *     3.629,   3.629,     0.0,  75.710,  75.710,
     *     75.710,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk6(i,8),i=1,matype) /
     *     3.629,   3.629,     0.0,  75.710,  75.710,
     *     75.710,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk6(i,9),i=1,matype) /
     *     3.629,   3.629,     0.0,  75.710,  75.710,
     *     75.710,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk6(i,10),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk6(i,11),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk6(i,12),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk6(i,13),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (pk6(i,14),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
c     
c     Type of torsion potential (1=pi-system, 2=sp3-sp3, 3=sp3-sp2,
c     4=Csp2-Oetp [no Ed, but 1-4 vdW])
c     
      data (kttype(i,1),i=1,matype) /
     *     1,       3,       0,       1,       1,
     *     3,       1,       4,       3,       4,
     *     3,       1,       3,       0 /
      data (kttype(i,2),i=1,matype) /
     *     3,       2,       0,       3,       3,
     *     2,       3,       3,       2,       3,
     *     2,       3,       2,       0 /
      data (kttype(i,3),i=1,matype) /
     *     0,       0,       0,       0,       0,
     *     0,       0,       0,       0,       0,
     *     0,       0,       0,       0 /
      data (kttype(i,4),i=1,matype) /
     *     1,       3,       0,       1,       1,
     *     3,       1,       1,       3,       1,
     *     3,       1,       3,       0 /
      data (kttype(i,5),i=1,matype) /
     *     1,       3,       0,       1,       1,
     *     3,       1,       1,       3,       1,
     *     3,       1,       3,       0 /
      data (kttype(i,6),i=1,matype) /
     *     3,       2,       0,       3,       3,
     *     2,       3,       3,       2,       3,
     *     2,       3,       2,       0 /
      data (kttype(i,7),i=1,matype) /
     *     1,       3,       0,       1,       1,
     *     3,       1,       1,       3,       1,
     *     3,       1,       3,       0 /
      data (kttype(i,8),i=1,matype) /
     *     4,       3,       0,       1,       1,
     *     3,       1,       1,       3,       1,
     *     3,       1,       3,       0 /
      data (kttype(i,9),i=1,matype) /
     *     3,       2,       0,       3,       3,
     *     2,       3,       3,       2,       3,
     *     2,       3,       2,       0 /
      data (kttype(i,10),i=1,matype) /
     *     4,       3,       0,       1,       1,
     *     3,       1,       1,       3,       1,
     *     3,       1,       3,       0 /
      data (kttype(i,11),i=1,matype) /
     *     3,       2,       0,       3,       3,
     *     2,       3,       3,       2,       3,
     *     5,       3,       2,       0 /
      data (kttype(i,12),i=1,matype) /
     *     1,       3,       0,       1,       1,
     *     3,       1,       1,       3,       1,
     *     3,       1,       3,       0 /
      data (kttype(i,13),i=1,matype) /
     *     3,       2,       0,       3,       3,
     *     2,       3,       3,       2,       3,
     *     2,       3,       2,       0 /
      data (kttype(i,14),i=1,matype) /
     *     0,       0,       0,       0,       0,
     *     0,       0,       0,       0,       0,
     *     0,       0,       0,       0 /
c     
c     Forceconstant parameters for single bond torsion (PIMM)
c     
      data (ppiz(i,1),i=1,matype) /
     *     0.0, 6.56E-7,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ppiz(i,2),i=1,matype) /
     *     6.56E-7, 1.93E-6,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ppiz(i,3),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ppiz(i,4),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ppiz(i,5),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ppiz(i,6),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ppiz(i,7),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ppiz(i,8),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ppiz(i,9),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ppiz(i,10),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ppiz(i,11),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     4.863E-5,     0.0,     0.0,     0.0 /
      data (ppiz(i,12),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ppiz(i,13),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ppiz(i,14),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
c     
c     Forceconstant parameters for pi bond torsion (deformation) (PIMM)
c     
      data (ppit(i,1),i=1,matype) /
     *     1.67E-5, 1.67E-5, 1.10E-5, 1.00E-5, 1.00E-5,
     *     1.00E-5, 0.90E-5, 0.90E-5, 0.90E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 1.10E-5 /
      data (ppit(i,2),i=1,matype) /
     *     1.67E-5, 1.67E-5, 1.10E-5, 1.00E-5, 1.00E-5,
     *     1.00E-5, 0.90E-5, 0.90E-5, 0.90E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 1.10E-5 /
      data (ppit(i,3),i=1,matype) /
     *     1.10E-5, 1.10E-5, 0.58E-5, 1.00E-5, 1.00E-5,
     *     1.00E-5, 0.90E-5, 0.90E-5, 0.90E-5, 1.00E-5,
     *     1.00E-5, 1.00E-5, 1.00E-5, 0.58E-5 /
      data (ppit(i,4),i=1,matype) /
     *     1.00E-5, 1.00E-5, 1.00E-5, 0.80E-5, 0.80E-5,
     *     0.80E-5, 0.80E-5, 0.80E-5, 0.80E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 1.00E-5 /
      data (ppit(i,5),i=1,matype) /
     *     1.00E-5, 1.00E-5, 1.00E-5, 0.80E-5, 0.80E-5,
     *     0.80E-5, 0.80E-5, 0.80E-5, 0.80E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 1.00E-5 /
      data (ppit(i,6),i=1,matype) /
     *     1.00E-5, 1.00E-5, 1.00E-5, 0.80E-5, 0.80E-5,
     *     0.80E-5, 0.80E-5, 0.80E-5, 0.80E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 1.00E-5 /
      data (ppit(i,7),i=1,matype) /
     *     0.90E-5, 0.90E-5, 0.90E-5, 0.80E-5, 0.80E-5,
     *     0.80E-5, 0.80E-5, 0.80E-5, 0.80E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 0.90E-5 /
      data (ppit(i,8),i=1,matype) /
     *     0.90E-5, 0.90E-5, 0.90E-5, 0.80E-5, 0.80E-5,
     *     0.80E-5, 0.80E-5, 0.80E-5, 0.80E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 0.90E-5 /
      data (ppit(i,9),i=1,matype) /
     *     0.90E-5, 0.90E-5, 0.90E-5, 0.80E-5, 0.80E-5,
     *     0.80E-5, 0.80E-5, 0.80E-5, 0.80E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 0.90E-5 /
      data (ppit(i,10),i=1,matype) /
     *     1.20E-5, 1.20E-5, 1.00E-5, 1.20E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 1.20E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 1.0E-5 /
      data (ppit(i,11),i=1,matype) /
     *     1.20E-5, 1.20E-5, 1.00E-5, 1.20E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 1.20E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 1.00E-5 /
      data (ppit(i,12),i=1,matype) /
     *     1.20E-5, 1.20E-5, 1.00E-5, 1.20E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 1.20E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 1.00E-5 /
      data (ppit(i,13),i=1,matype) /
     *     1.20E-5, 1.20E-5, 1.00E-5, 1.20E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 1.20E-5, 1.20E-5,
     *     1.20E-5, 1.20E-5, 1.20E-5, 1.00E-5 /
      data (ppit(i,14),i=1,matype) /
     *     1.10E-5, 1.10E-5, 0.58E-5, 1.00E-5, 1.00E-5,
     *     1.00E-5, 0.90E-5, 0.90E-5, 0.90E-5, 1.00E-5,
     *     1.00E-5, 1.00E-5, 1.00E-5, 0.58E-5 /
c     
c     Forceconstant parameters for pi-bond torsion (strain) (PIMM)
c     
      data (ptt(i,1),i=1,matype) /
     *     0.14,     0.0,     0.0,    0.04,    0.04,
     *     0.0,    0.00,    0.02,     0.0,    0.00,
     *     0.0,    0.00,     0.0,     0.0 /
      data (ptt(i,2),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ptt(i,3),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ptt(i,4),i=1,matype) /
     *     0.04,     0.0,     0.0,    0.00,    0.00,
     *     0.0,    0.00,    0.00,     0.0,    0.00,
     *     0.0,    0.00,     0.0,     0.0 /
      data (ptt(i,5),i=1,matype) /
     *     0.04,     0.0,     0.0,    0.00,    0.00,
     *     0.0,    0.00,    0.00,     0.0,    0.00,
     *     0.0,    0.00,     0.0,     0.0 /
      data (ptt(i,6),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ptt(i,7),i=1,matype) /
     *     0.00,     0.0,     0.0,    0.00,    0.00,
     *     0.0,    0.00,    0.00,     0.0,    0.00,
     *     0.0,    0.00,     0.0,     0.0 /
      data (ptt(i,8),i=1,matype) /
     *     0.02,     0.0,     0.0,    0.00,    0.00,
     *     0.0,    0.00,    0.00,     0.0,    0.00,
     *     0.0,    0.00,     0.0,     0.0 /
      data (ptt(i,9),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ptt(i,10),i=1,matype) /
     *     0.00,     0.0,     0.0,    0.00,    0.00,
     *     0.0,    0.00,    0.00,     0.0,    0.00,
     *     0.0,    0.00,     0.0,     0.0 /
      data (ptt(i,11),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     8.337E-6,     0.0,     0.0,     0.0 /
      data (ptt(i,12),i=1,matype) /
     *     0.00,     0.0,     0.0,    0.00,    0.00,
     *     0.0,    0.00,    0.00,     0.0,    0.00,
     *     0.0,    0.00,     0.0,     0.0 /
      data (ptt(i,13),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
      data (ptt(i,14),i=1,matype) /
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0,     0.0,
     *     0.0,     0.0,     0.0,     0.0 /
c     
c     Giglio's parameter a for van der Waals interactions.
c     E.Giglio, Nature Vol.222,April 26 1960,p.340
c     
      data (avdw(i,1),i=1,matype) /
     *     3012E2,  3012E2,   448E2,  3400E2,  3400E2,
     *     3400E2,  2787E2,  2787E2,  2787E2,  2554E2,
     *     2554E2,  2554E2,  2554E2,   448E2 /
      data (avdw(i,2),i=1,matype) /
     *     3012E2,  3012E2,   448E2,  3400E2,  3400E2,
     *     3400E2,  2787E2,  2787E2,  2787E2,  2554E2,
     *     2554E2,  2554E2,  2554E2,   448E2 /
      data (avdw(i,3),i=1,matype) /
     *     448E2,   448E2,    66E2,   521E2,   521E2,
     *     521E2,   420E2,   420E2,   420E2,   405E2,
     *     405E2,   405E2,   405E2,    66E2 /
      data (avdw(i,4),i=1,matype) /
     *     3400E2,  3400E2,   521E2,  3870E2,  3870E2,
     *     3870E2,  3162E2,  3162E2,  3162E2,  2886E2,
     *     2886E2,  2886E2,  2886E2,   521E2 /
      data (avdw(i,5),i=1,matype) /
     *     3400E2,  3400E2,   521E2,  3870E2,  3870E2,
     *     3870E2,  3162E2,  3162E2,  3162E2,  2886E2,
     *     2886E2,  2886E2,  2886E2,  1577E1 /
      data (avdw(i,6),i=1,matype) /
     *     3400E2,  3400E2,   521E2,  3870E2,  3870E2,
     *     3870E2,  3162E2,  3162E2,  3162E2,  2886E2,
     *     2886E2,  2886E2,  2886E2,  1577E1 /
      data (avdw(i,7),i=1,matype) /
     *     2787E2,  2787E2,   420E2,  3162E2,  3162E2,
     *     3162E2,  2590E2,  2590E2,  2590E2,  2392E2,
     *     2392E2,  2392E2,  2392E2,   724E1 /
      data (avdw(i,8),i=1,matype) /
     *     2787E2,  2787E2,   420E2,  3162E2,  3162E2,
     *     3162E2,  2590E2,  2590E2,  2590E2,  2392E2,
     *     2392E2,  2392E2,  2392E2,   724E1 /
      data (avdw(i,9),i=1,matype) /
     *     2787E2,  2787E2,   420E2,  3162E2,  3162E2,
     *     3162E2,  2590E2,  2590E2,  2590E2,  2392E2,
     *     2392E2,  2392E2,  2392E2,   724E1 /
      data (avdw(i,10),i=1,matype) /
     *     2554E2,  2554E2,   405E2,  2886E2,  2886E2,
     *     2886E2,  2392E2,  2392E2,  2392E2,  2208E2,
     *     2208E2,  2208E2,  2208E2,   405E2 /
      data (avdw(i,11),i=1,matype) /
     *     2554E2,  2554E2,   405E2,  2886E2,  2886E2,
     *     2886E2,  2392E2,  2392E2,  2392E2,  2208E2,
     *     2208E2,  2208E2,  2208E2,   405E2 /
      data (avdw(i,12),i=1,matype) /
     *     2554E2,  2554E2,   405E2,  2886E2,  2886E2,
     *     2886E2,  2392E2,  2392E2,  2392E2,  2208E2,
     *     2208E2,  2208E2,  2208E2,   405E2 /
      data (avdw(i,13),i=1,matype) /
     *     2554E2,  2554E2,   405E2,  2886E2,  2886E2,
     *     2886E2,  2392E2,  2392E2,  2392E2,  2208E2,
     *     2208E2,  2208E2,  2208E2,   405E2 /
      data (avdw(i,14),i=1,matype) /
     *     448E2,   448E2,    66E2,   521E2,  1577E1,
     *     1577E1,   724E1,   724E1,   724E1,   405E2,
     *     405E2,   405E2,   405E2,    66E2 /
c     
c     Giglio's parameter b for van der Waals interactions.
c     E.Giglio, Nature Vol.222,April 26 1960,p.340
c     
      data (bvdw(i,1),i=1,matype) /
     *     0.000,   0.000,   2.040,   0.000,   0.000,
     *     0.000,   0.000,   0.000,   0.000,   1.811,
     *     1.811,   1.811,   1.811,   2.040 /
      data (bvdw(i,2),i=1,matype) /
     *     0.000,   0.000,   2.040,   0.000,   0.000,
     *     0.000,   0.000,   0.000,   0.000,   1.811,
     *     1.811,   1.811,   1.811,   2.040 /
      data (bvdw(i,3),i=1,matype) /
     *     2.040,   2.040,   4.080,   2.040,   2.040,
     *     2.040,   2.040,   2.040,   2.040,   3.851,
     *     3.851,   3.851,   3.851,   4.080 /
      data (bvdw(i,4),i=1,matype) /
     *     0.000,   0.000,   2.040,   0.000,   0.000,
     *     0.000,   0.000,   0.000,   0.000,   1.811,
     *     1.811,   1.811,   1.811,   2.040 /
      data (bvdw(i,5),i=1,matype) /
     *     0.000,   0.000,   2.040,   0.000,   0.000,
     *     0.000,   0.000,   0.000,   0.000,   1.811,
     *     1.811,   1.811,   1.811,   0.000 /
      data (bvdw(i,6),i=1,matype) /
     *     0.000,   0.000,   2.040,   0.000,   0.000,
     *     0.000,   0.000,   0.000,   0.000,   1.811,
     *     1.811,   1.811,   1.811,   0.000 /
      data (bvdw(i,7),i=1,matype) /
     *     0.000,   0.000,   2.040,   0.000,   0.000,
     *     0.000,   0.000,   0.000,   0.000,   1.811,
     *     1.811,   1.811,   1.811,   0.000 /
      data (bvdw(i,8),i=1,matype) /
     *     0.000,   0.000,   2.040,   0.000,   0.000,
     *     0.000,   0.000,   0.000,   0.000,   1.811,
     *     1.811,   1.811,   1.811,   0.000 /
      data (bvdw(i,9),i=1,matype) /
     *     0.000,   0.000,   2.040,   0.000,   0.000,
     *     0.000,   0.000,   0.000,   0.000,   1.811,
     *     1.811,   1.811,   1.811,   0.000 /
      data (bvdw(i,10),i=1,matype) /
     *     1.811,   1.811,   3.851,   1.811,   1.811,
     *     1.811,   1.811,   1.811,   1.811,   3.621,
     *     3.621,   3.621,   3.621,   3.851 /
      data (bvdw(i,11),i=1,matype) /
     *     1.811,   1.811,   3.851,   1.811,   1.811,
     *     1.811,   1.811,   1.811,   1.811,   3.621,
     *     3.621,   3.621,   3.621,   3.851 /
      data (bvdw(i,12),i=1,matype) /
     *     1.811,   1.811,   3.851,   1.811,   1.811,
     *     1.811,   1.811,   1.811,   1.811,   3.621,
     *     3.621,   3.621,   3.621,   3.851 /
      data (bvdw(i,13),i=1,matype) /
     *     1.811,   1.811,   3.851,   1.811,   1.811,
     *     1.811,   1.811,   1.811,   1.811,   3.621,
     *     3.621,   3.621,   3.621,   3.851 /
      data (bvdw(i,14),i=1,matype) /
     *     2.040,   2.040,   4.080,   2.040,   0.000,
     *     0.000,   0.000,   0.000,   0.000,   3.851,
     *     3.851,   3.851,   3.851,   4.080 /
c     
c     Giglio's parameter c for van der Waals interactions.
c     E.Giglio, Nature Vol.222,April 26 1960,p.340
c     
      data (cvdw(i,1),i=1,matype) /
     *     327.2,   327.2,   125.0,   340.0,   340.0,
     *     340.0,   342.3,   342.3,   342.3,   684.0,
     *     684.0,   684.0,   684.0,   125.0 /
      data (cvdw(i,2),i=1,matype) /
     *     327.2,   327.2,   125.0,   340.0,   340.0,
     *     340.0,   342.3,   342.3,   342.3,   684.0,
     *     684.0,   684.0,   684.0,   125.0 /
      data (cvdw(i,3),i=1,matype) /
     *     125.0,   125.0,    49.2,   132.0,   132.0,
     *     132.0,   132.7,   132.7,   132.7,   265.2,
     *     265.2,   265.2,   265.2,    49.2 /
      data (cvdw(i,4),i=1,matype) /
     *     340.0,   340.0,   132.0,   354.0,   354.0,
     *     354.0,   356.0,   356.0,   356.0,   711.5,
     *     711.5,   711.5,   711.5,   132.0 /
      data (cvdw(i,5),i=1,matype) /
     *     340.0,   340.0,   132.0,   354.0,   354.0,
     *     354.0,   356.0,   356.0,   356.0,   711.5,
     *     711.5,   711.5,   711.5,   268.2 /
      data (cvdw(i,6),i=1,matype) /
     *     340.0,   340.0,   132.0,   354.0,   354.0,
     *     354.0,   356.0,   356.0,   356.0,   711.5,
     *     711.5,   711.5,   711.5,   268.2 /
      data (cvdw(i,7),i=1,matype) /
     *     342.3,   342.3,   132.7,   356.0,   356.0,
     *     356.0,   358.5,   358.5,   358.5,   715.5,
     *     715.5,   715.5,   715.5,   192.1 /
      data (cvdw(i,8),i=1,matype) /
     *     342.3,   342.3,   132.7,   356.0,   356.0,
     *     356.0,   358.5,   358.5,   358.5,   715.5,
     *     715.5,   715.5,   715.5,   192.1 /
      data (cvdw(i,9),i=1,matype) /
     *     342.3,   342.3,   132.7,   356.0,   356.0,
     *     356.0,   358.5,   358.5,   358.5,   715.5,
     *     715.5,   715.5,   715.5,   192.1 /
      data (cvdw(i,10),i=1,matype) /
     *     684.0,   684.0,   265.2,   711.5,   711.5,
     *     711.5,   715.5,   715.5,   715.5,  1430.0,
     *     1430.0,  1430.0,  1430.0,   265.2 /
      data (cvdw(i,11),i=1,matype) /
     *     684.0,   684.0,   265.2,   711.5,   711.5,
     *     711.5,   715.5,   715.5,   715.5,  1430.0,
     *     1430.0,  1430.0,  1430.0,   265.2 /
      data (cvdw(i,12),i=1,matype) /
     *     684.0,   684.0,   265.2,   711.5,   711.5,
     *     711.5,   715.5,   715.5,   715.5,  1430.0,
     *     1430.0,  1430.0,  1430.0,   265.2 /
      data (cvdw(i,13),i=1,matype) /
     *     684.0,   684.0,   265.2,   711.5,   711.5,
     *     711.5,   715.5,   715.5,   715.5,  1430.0,
     *     1430.0,  1430.0,  1430.0,   265.2 /
      data (cvdw(i,14),i=1,matype) /
     *     125.0,   125.0,    49.2,   132.0,   268.2,
     *     268.2,   192.1,   192.1,   192.1,   265.2,
     *     265.2,   265.2,   265.2,    49.2 /
c     
c     Giglio's parameter d for van der Waals interactions.
c     E.Giglio, Nature Vol.222,April 26 1960,p.340
c     
      data (dvdw(i,1),i=1,matype) /
     *     12,      12,       6,      12,      12,
     *     12,      12,      12,      12,       6,
     *     6,       6,       6,       6 /
      data (dvdw(i,2),i=1,matype) /
     *     12,      12,       6,      12,      12,
     *     12,      12,      12,      12,       6,
     *     6,       6,       6,       6 /
      data (dvdw(i,3),i=1,matype) /
     *     6,       6,       0,       6,       6,
     *     6,       6,       6,       6,       0,
     *     0,       0,       0,       0 /
      data (dvdw(i,4),i=1,matype) /
     *     12,      12,       6,      12,      12,
     *     12,      12,      12,      12,       6,
     *     6,       6,       6,       6 /
      data (dvdw(i,5),i=1,matype) /
     *     12,      12,       6,      12,      12,
     *     12,      12,      12,      12,       6,
     *     6,       6,       6,      14 /
      data (dvdw(i,6),i=1,matype) /
     *     12,      12,       6,      12,      12,
     *     12,      12,      12,      12,       6,
     *     6,       6,       6,      14 /
      data (dvdw(i,7),i=1,matype) /
     *     12,      12,       6,      12,      12,
     *     12,      12,      12,      12,       6,
     *     6,       6,       6,      14 /
      data (dvdw(i,8),i=1,matype) /
     *     12,      12,       6,      12,      12,
     *     12,      12,      12,      12,       6,
     *     6,       6,       6,      14 /
      data (dvdw(i,9),i=1,matype) /
     *     12,      12,       6,      12,      12,
     *     12,      12,      12,      12,       6,
     *     6,       6,       6,      14 /
      data (dvdw(i,10),i=1,matype) /
     *     6,       6,       0,       6,       6,
     *     6,       6,       6,       6,       0,
     *     0,       0,       0,       0 /
      data (dvdw(i,11),i=1,matype) /
     *     6,       6,       0,       6,       6,
     *     6,       6,       6,       6,       0,
     *     0,       0,       0,       0 /
      data (dvdw(i,12),i=1,matype) /
     *     6,       6,       0,       6,       6,
     *     6,       6,       6,       6,       0,
     *     0,       0,       0,       0 /
      data (dvdw(i,13),i=1,matype) /
     *     6,       6,       0,       6,       6,
     *     6,       6,       6,       6,       0,
     *     0,       0,       0,       0 /
      data (dvdw(i,14),i=1,matype) /
     *     6,       6,       0,       6,      14,
     *     14,      14,      14,      14,       0,
     *     0,       0,       0,       0 /
c     
c     Dielectric constant to be used for Coulomb interactions. 1 for vacuum,
c     70 (approx.) for water. This parameter is also used to indicate that no
c     Coulomb energy terms are to be included in the total MM-energy.
c     
      data dielc / 1.0 /        ! defaults to value for vacuum
c     
c     all parameters defined...
c     
      end
