      subroutine pople(*)
c     
c     Pariser-Parr-Pople LCAO-MO-SCF
c     
      implicit none
      include 'sizes.h'
      include 'apara.h'
      include 'bpara.h'
      include 'energy.h'
      include 'atom.h'
      include 'fock.h'
      include 'worksp.h'
      include 'option.h'
c     
      integer i,j,ia,la,ka,kb,k,ib,lb,l,ier
      real delta
c     
      nscf=1
c     
c     Compute diagonal of new Fock Matrix (FM, stored in evec)
c     
 5    continue
      do 100 i=1,natpi
         ia=atnr(i)
         la=(i*(i+1))/2
         evec(i,i)=beta(la)+0.5*p(la)*gamma(la)
         do 10 j=1,natpi
            if (j.ne.i) then
               ka=max0(i,j)
               kb=min0(i,j)
               k=(ka*(ka-1))/2+kb
               ib=atnr(j)
               lb=(j*(j+1))/2
               evec(i,i)=evec(i,i)+(p(lb)-npiel(ntype(ib)))*gamma(k)
            end if
 10      continue
 100  continue
c     
c     Compute offdiagonal terms of FM
c     
      do 200 i=2,natpi
         l=(i*(i-1))/2
         do 190 j=1,i-1
            evec(i,j)=beta(l+j)-0.5*p(l+j)*gamma(l+j)
            evec(j,i)=evec(i,j)
 190     continue
 200  continue
c     
c     Compute eigenvalues and eigenvectors of FM (sorted ascending)
c     
      call EPtred2(mpiat,natpi,evec,eval,work,evec)
      call EPimtql2(mpiat,natpi,eval,work,evec,ier)
      if (ier.ne.0) then
         write(21,'(a)') 'Bad return from IMTQL2 in POPLE.'
         write( *,'(a)') 'Bad return from IMTQL2 in POPLE.'
         return 1
      end if
      call EPevsort(mpiat,natpi,eval,evec,1)
c     
c     Compute new bondordermatrix and test for sefconsistency
c     
      call bomatr(delta)
      if (delta.lt.ascf) then
         scfcon=.true.
         return
      end if
      if (nscf.eq.mxscf) then
         scfcon=.false.
         return
      end if
      nscf=nscf+1
      go to 5
c     
c     done...
c     
      end
