      subroutine readcon(*)
c     
c     Read distance constraints from .CON file...
c     
      implicit none
      include 'sizes.h'
      include 'apara.h'
      include 'atom.h'
      include 'energy.h'
      include 'option.h'
      character*132 line
c     
      integer i1,i2,i3,i4
      real dl,du,rk

      ncon=0
      ncond=0
      read(1,'(a)',end=200) line
      call strupcase(line,line)
 1    if (line(1:1).eq.'D') go to 10
      if (line(1:1).eq.'T') go to 100
      if (line(1:1).eq.'E') go to 200
      write(6,'(1x,a,a)') ' Bad constraint: ',line(1:50)
      return 1
c     
c     Dist
c     
 10   do while (ncon.le.mconst)
         read(1,'(a)',end=200) line
         read(line,*,err=1) i1,i2,dl,du,rk
         if(ncon.eq.mconst) then
            write(6,'(a)') ' Too many constraints...'
            return 1
         end if
         ncon=ncon+1
         atcon(1,ncon)=i1
         atcon(2,ncon)=i2
         dlow(ncon)=dl
         dhigh(ncon)=du
         kcon(ncon)=rk
         if (rk.lt.0.0.or.i1.lt.1.or.i2.lt.1.or.i1.gt.nat
     *        .or.i2.gt.nat.or.dl.lt.0.0.or.du.lt.0.0.or.
     *        du.lt.dl) then
            write(6,'(a,2i4,2f8.2,f10.2)') 
     *           ' Bad constraint: ',i1,i2,dl,du,rk
            return 1
         end if
      end do
      return
c     
c     Tors
c     
 100  do while (ncond.le.mconstd)
         read(1,'(a)',end=200) line
         read(line,*,err=1) i1,i2,i3,i4,dl,du,rk
         if(ncond.eq.mconstd) then
            write(6,'(a)') ' Too many constraints...'
            return 1
         end if
         ncond=ncond+1
         atcond(1,ncond)=i1
         atcond(2,ncond)=i2
         atcond(3,ncond)=i3
         atcond(4,ncond)=i4
         dlowd(ncond)=dl
         dhighd(ncond)=du
         kcond(ncond)=rk
         if (rk.lt.0.0.or.i1.lt.1.or.i2.lt.1.or.i1.gt.nat
     *        .or.i2.gt.nat.or.i3.lt.1.or.i3.gt.nat.or.i4.lt.1.or.
     *        i4.gt.nat.or.du.lt.dl) then
            write(6,'(a,4i4,2f8.2,f10.2)') 
     *           ' Bad constraint: ',i1,i2,dl,du,rk
            return 1
         end if
         if (dl.lt.-180.0.or.dl.gt.180.0) then
            write(6,'(a,4i4,2f8.2,f10.2)') 
     *           ' Bad constraint: ',i1,i2,dl,du,rk
            return 1
         end if
      end do
 200  continue
      return
      end
