      subroutine scfdmp
c     
c     Dump Results of SCF to .DAT File ...
c     
      implicit none
      include 'sizes.h'
      include 'energy.h'
      include 'fock.h'
      include 'atom.h'
c     
      real res,dns
      integer nparts,i,j,k,start,end
      dns(i,j)=p((max0(i,j)*(max0(i,j)-1))/2+min0(i,j))
      res(i,j)=beta((max0(i,j)*(max0(i,j)-1))/2+min0(i,j))
c     
      if (natpi.eq.0) return
c     
c     Write out the eigenvalues (in eV) and eigenvectors
c     
      write(21,'(a//)') char(12)
      write(21,*) 'Eigenvalues (eV) and Eigenvectors:'
      write(21,*) '---------------------------------'
      nparts=(natpi+9)/10
      end=0
      do k=1,nparts
         start=end+1
         end  =min(end+10,natpi)
         write(21,'(//)')
         write(21,'(a,10(i6,4x))') '            ',(i,i=start,end)
         write(21,'(a,10f10.4)')   
     .        ' Energy (eV)',(eval(i),i=start,end)
         do j=1,natpi
            write(21,'(i12,10f10.4)') atnr(j),(evec(j,i),i=start,end)
         end do
      end do
c     
c     Write out density matrix
c     
      write(21,'(a//)') char(12)
      write(21,*) 'Density Matrix'
      write(21,*) '--------------'
      nparts=(natpi+9)/10
      end=0
      do k=1,nparts
         start=end+1
         end  =min(end+10,natpi)
         write(21,'(//)')
         write(21,'(a,10(i6,4x))') '            ',(i,i=start,end)
         do j=1,natpi
            write(21,'(i12,10f10.4)') atnr(j),(dns(j,i),i=start,end)
         end do
      end do
c     
c     Write resonance matrix
c     
      write(21,'(a//)') char(12)
      write(21,*) 'Resonance Matrix'
      write(21,*) '----------------'
      nparts=(natpi+9)/10
      end=0
      do k=1,nparts
         start=end+1
         end  =min(end+10,natpi)
         write(21,'(//)')
         write(21,'(a,10(i6,4x))') '            ',(i,i=start,end)
         do j=1,natpi
            write(21,'(i12,10f10.4)') atnr(j),(res(j,i),i=start,end)
         end do
      end do
c     
c     That's it folks...
c     
      return
      end
