      subroutine anal
c
c Topological Analysis (Rings etc...)
c
      implicit none
      include 'sizes.h'
      include 'moldat.h'
      include 'bounds.h'
      include 'options.h'
c
      integer i,j,k,k1,k2,n1,n2,l,r,nh,prnt(mxnat),in(mxnat),
     .     nb(20),prm(3,4),sl(3,6),sd(3,6),hold
      integer s(mxnat),d(mxnat),lst(mxnat),n,bnr,rsz,dbl,trpl
      real*8 w(6),pi,t,dx,dy,d1,d2,d3,d13,x1,y1,x2,y2
      logical mrk(mxnat),m
      real*8 gl,gu,d1l,d1u,d2l,d2u,dl,du,tol
      real*8 taul(0:7),tauu(0:7)
c
      data prm / 1,2,3, 1,4,2, 4,1,3, 4,3,2 /
      data sl  / 2,1,3, 2,1,4, 3,1,4, 1,2,5, 1,2,6, 5,2,6 /
      data sd  / 1,3,2, 1,3,4, 2,3,4, 5,4,6, 5,4,3, 6,4,3 /
      data pi  / 3.14159265358979323846 /
c                  0    1    2    3    4   5     6    7
      data taul / 60, 175, 118, 106,  60, 100, 100,  95 /
      data tauu /170, 180, 122, 112, 100, 110, 130, 130 /
c
c
      nang=0
      ntor=0
      nstc=0
c
c  define hyb, to help 'dobounds' routine
c
      do i=1,nat
         hyb(i)=0
         dbl=0
         trpl=0
         if (chs(i).eq.'C '.or.chs(i).eq.'N '.or.chs(i).eq.'O ') then
            do j=1,nneigh(i)
               k=bnd(j,i)
               if (btype(k).eq.2) dbl=dbl+1
               if (btype(k).eq.3) trpl=trpl+1
            end do
            if (trpl.gt.0.or.dbl.gt.1) then
               hyb(i)=1
            else if (dbl.gt.0) then 
               hyb(i)=2
            else
               hyb(i)=3
            end if
         else if (nneigh(i).gt.4) then
            hyb(i)=4
         else if (nneigh(i).gt.3) then
            hyb(i)=5
         else if (nneigh(i).gt.2) then
            hyb(i)=6
         else 
            hyb(i)=7
         end if
      end do
      do i=1,nat      ! find amide bonds and N.pl3 in N-(C,N)=X
         if (chs(i).eq.'N '.and.nneigh(i).lt.4.and.hyb(i).eq.3) then
            hold=hyb(i)
            do j=1,nneigh(i)
               k=neigh(j,i)
               if (hyb(k).eq.2) then
                  if (chs(k).eq.'C ') then
                     do l=1,nneigh(k)
                        if (btype(bnd(l,k)).eq.2.and.
     .                       chs(neigh(l,k)).eq.'O') then
                           btype(bnd(j,i))=6
                        end if
                     end do
                     hold=2
                  else if (chs(k).eq.'N ') then
                     hold=2
                  end if
               end if
            end do
            hyb(i)=hold
         end if
      end do
c
c Mark all ring atoms and ring bonds
c
      do i=1,nat
         aring(i)=.false.
         s(i)=0
         d(i)=0
      end do
c
      do j=1,nbnd
         if (nneigh(bfrom(j)).eq.1.or.nneigh(bto(j)).eq.1) then
            brsz(j)=0
         else
            brsz(j)=nbnd+1
         end if
      end do
c
      do bnr=1,nbnd
         if (brsz(bnr).gt.0) then
            s(bfrom(bnr))=-1
            d(bfrom(bnr))=1
            lst(1)=bfrom(bnr)
            s(bto(bnr))=1
            d(bto(bnr))=1
            lst(2)=bto(bnr)
            rsz=0
            n=2
            i=1
            do while(i.le.n.and.rsz.eq.0) 
               j=lst(i)
               do k=1,nneigh(j) 
                  if (brsz(bnd(k,j)).gt.0) then
                     if (s(neigh(k,j)).eq.0) then
                        s(neigh(k,j))=s(j)
                        d(neigh(k,j))=d(j)+1
                        lst(n+1)=neigh(k,j)
                        n=n+1
                     else if (s(neigh(k,j)).ne.s(j)) then
                        if (rsz.eq.0) then
                           if (d(neigh(k,j))+d(j).gt.2) then
                              rsz=d(neigh(k,j))+d(j)
                           end if
                        end if
                     end if
                  end if
               end do
               i=i+1
            end do
            brsz(bnr)=rsz
            do j=1,n
               s(lst(j))=0
               d(lst(j))=0
            end do
         end if
         bring(bnr)=brsz(bnr).gt.0
         if (bring(bnr)) then
            aring(bfrom(bnr))=.true.
            aring(bto(bnr))=.true.
         end if
      end do
c
c  initialize lower/upper bounds
c
      do i=1,nat
         do k=1,i-1
            topb(i,k)=0        ! no known bound, will be replaced by vdW bound
            wb(i,k)=0
         end do
         do k=i+1,nat
            topb(i,k)=10*nat   ! large.
            wb(i,k)=0
         end do
         topb(i,i)=0.0
      end do
c
c  lower bound = upper bound for covalently linked pairs
c
      do i=1,nbnd
         j=bfrom(i)
         k=bto(i)
         topb(j,k)=rcov(j)+rcov(k)
         topb(k,j)=topb(j,k)
         wb(j,k)=wlower
         wb(k,j)=wlower
      end do
c
c  bound derived from angles
c
      do i=1,nat
         gl=cos(taul(hyb(i))*3.141592653/180.0)
         gu=cos(tauu(hyb(i))*3.141592653/180.0)
         do k1=2,nneigh(i)
            n1=neigh(k1,i)
            if (n1.lt.i) then
               d1l=topb(i,n1)
               d1u=topb(n1,i)
            else
               d1u=topb(i,n1)
               d1l=topb(n1,i)
            end if
            do k2=1,k1-1
               n2=neigh(k2,i)
               if (n2.lt.i) then
                  d2l=topb(i,n2)
                  d2u=topb(n2,i)
               else
                  d2u=topb(i,n2)
                  d2l=topb(n2,i)
               end if
               dl=sqrt(d1l*d1l+d2l*d2l-2*d1l*d2l*gl)
               du=sqrt(d1u*d1u+d2u*d2u-2*d1u*d2u*gu)
               if (n2.lt.n1) then
                  if (dl.le.topb(n2,n1)) then
                     topb(n1,n2)=max(topb(n1,n2),dl)
                     wb(n1,n2)=wlower
                  end if
                  if (du.ge.topb(n1,n2)) then
                     topb(n2,n1)=min(topb(n2,n1),du)
                     wb(n2,n1)=wlower
                  end if
               else
                  if (dl.le.topb(n1,n2)) then
                     topb(n2,n1)=max(topb(n2,n1),dl)
                     wb(n2,n1)=wlower
                 end if
                  if (du.ge.topb(n2,n1)) then
                     topb(n1,n2)=min(topb(n1,n2),du)
                     wb(n1,n2)=wlower
                 end if
               end if
            end do
         end do
      end do
c
c  lower-bounds = sum of vdw radii
c
      do i=1,nat-1
         do j=i+1,nat
            if (topb(i,j).gt.0.85*(rvdw(i)+rvdw(j))) then
               if (0.85*(rvdw(i)+rvdw(j)).gt.topb(j,i)) then
                  topb(j,i)=0.85*(rvdw(i)+rvdw(j))
                  wb(j,i)=wlower
               end if
            end if
         end do
      end do
c
c Set up stereo constraints
c
      if (dostc) then
         do i=1,nat
            if (flags(i)(9:11).eq.'  1'.or.flags(i)(9:11).eq.'  2') then
               do j=1,nneigh(i)
                  nb(j)=neigh(j,i)
               end do
               do j=1,nneigh(i)-1 ! Bogo sort...
                  do k=1,nneigh(i)-j
                     if (chs(nb(k)).eq.'H '.or.
     .                    (nb(k).gt.nb(k+1).and.chs(nb(k+1)).ne.'H ')) then
                        l=nb(k)
                        nb(k)=nb(k+1)
                        nb(k+1)=l
                     end if
                  end do
               end do
               if (nneigh(i).le.4.and.nneigh(i).ge.3) then
                  do k=1,(nneigh(i)-3)*3+1
                     if (nstc.lt.mxstc) then
                        nstc=nstc+1
                        vstc(nstc)=1.0
                        do j=1,3
                           stc(j,nstc)=nb(prm(j,k))
                        end do
                        stc(4,nstc)=i
                        if (flags(i)(9:11).eq.'  2') then
                           l=stc(1,nstc)
                           stc(1,nstc)=stc(2,nstc)
                           stc(2,nstc)=l
                        end if
                     end if
                  end do
               end if
            end if
         end do
      end if
c
c Out of plane terms at sp2 C,N
c     
      if (dooop) then
         do i=1,nat
            if (hyb(i).eq.2.and.nneigh(i).eq.3. .and.
     .           flags(i)(9:11).ne.'  1' .and. flags(i)(9:11).ne.'  2'
     .           ) then
               if (nstc.lt.mxstc) then
                  nstc=nstc+1
                  do j=1,3
                     stc(j,nstc)=neigh(j,i)
                  end do
                  stc(4,nstc)=i
                  vstc(nstc)=0.0
               end if
            end if
         end do
      end if
c
c  A few dihedral constraints... first for amide bonds not in small rings
c
      if (doamide) then
         do k=1,nbnd
            if (btype(k).eq.6.and.(.not.bring(k).or.brsz(k).gt.24)) then          ! test for small rings...
               nb(3)=0
               nb(4)=0
               nb(5)=0
               nb(6)=0
               nh=0
               if (chs(bfrom(k)).eq.'C ') then
                  nb(1)=bfrom(k)
                  nb(2)=bto(k)
               else
                  nb(1)=bto(k)
                  nb(2)=bfrom(k)
               end if
               do j=1,nneigh(nb(1))
                  if (neigh(j,nb(1)).ne.nb(2)) then
                     if (btype(bnd(j,nb(1))).eq.2.and.
     .                    chs(neigh(j,nb(1))).eq.'O ') then
                        nb(3)=neigh(j,nb(1))
                     else
                        nb(4)=neigh(j,nb(1))
                     end if
                  end if
               end do
               do j=1,nneigh(nb(2))
                  if (neigh(j,nb(2)).ne.nb(1)) then
                     if (chs(neigh(j,nb(2))).eq.'H ') nh=nh+1
                     if (nb(5).eq.0) then
                        nb(5)=neigh(j,nb(2))
                     else
                        nb(6)=neigh(j,nb(2))
                     end if
                  end if
               end do
               if (nh.eq.1.or.(nneigh(nb(2)).eq.2.and.nh.eq.0)) then
                  if (chs(nb(5)).eq.'H') then
                     i=nb(6)
                     nb(6)=nb(5)
                     nb(5)=i
                  end if
                  do i=3,4
                     do j=5,6
                        if (nb(i).ne.0.and.nb(j).ne.0) then
                           if (ntor.lt.mxtor) then
                              ntor=ntor+1
                              tor(1,ntor)=nb(i)
                              tor(2,ntor)=nb(1)
                              tor(3,ntor)=nb(2)
                              tor(4,ntor)=nb(j)
                              torc(1,ntor)=180*mod(i+j,2)
                              torc(2,ntor)=180*mod(i+j,2)
                              trsz(ntor)=brsz(k)
                           end if
                        end if
                     end do
                  end do
               end if
            end if
         end do
      end if
c
c ...and then for cis/trans stereo bonds
c
      if (dodbl) then
         do k=1,nbnd
            if (btype(k).eq.2.and.bster(k).ne.3.and.
     .           (.not.bring(k).or.brsz(k).gt.3).and.
     .           hyb(bfrom(k)).eq.2.and.hyb(bto(k)).eq.2) then
               nb(3)=bfrom(k)
               nb(4)=bto(k)
               if (nneigh(nb(3)).gt.1.and.nneigh(nb(4)).gt.1) then
                  nb(1)=0
                  nb(2)=0
                  nb(5)=0
                  nb(6)=0
                  i=0
                  do j=1,nneigh(nb(3))
                     if (neigh(j,nb(3)).ne.nb(4)) then
                        i=i+1
                        if (i.lt.3) nb(i)=neigh(j,nb(3))
                     end if
                  end do
                  if (nb(2).gt.0.and.
     .                 (nb(1).gt.nb(2).and.chs(nb(2)).ne.'H '.or.
     .                 chs(nb(1)).eq.'H ')) then
                     j=nb(2)
                     nb(2)=nb(1)
                     nb(1)=j
                  end if
                  i=4
                  do j=1,nneigh(nb(4))
                     if (neigh(j,nb(4)).ne.nb(3)) then
                        i=i+1
                        if (i.lt.7) nb(i)=neigh(j,nb(4))
                     end if
                  end do
                  if (nb(6).gt.0.and.
     .                 (nb(5).gt.nb(6).and.chs(nb(6)).ne.'H '.or.
     .                 chs(nb(5)).eq.'H ')) then
                     j=nb(6)
                     nb(6)=nb(5)
                     nb(5)=j
                  end if
                  if (nb(1).gt.0.and.nb(5).gt.0) then
                     if (bster(k).eq.0) then             ! use drawing to decide cis/ctrans
                        dx=x(1,nb(4))-x(1,nb(3))
                        dy=x(2,nb(4))-x(2,nb(3))
                        if (dx*dx+dy*dy.gt.0.0001) then
                           w(3)=atan2(dy,dx)
                           if (w(3).lt.0) w(3)=w(3)+2*pi
                           do i=1,2
                              if (nb(i).gt.0) then
                                 dx=x(1,nb(3))-x(1,nb(i))
                                 dy=x(2,nb(3))-x(2,nb(i))
                                 if (dx*dx+dy*dy.gt.0.000001) then
                                    w(i)=atan2(dy,dx)
                                    if (w(i).lt.0) w(i)=w(i)+2*pi
                                    w(i)=w(i)-w(3)
                                    if (w(i).lt.0) w(i)=w(i)+2*pi
                                 else
                                    w(i)=-4*pi
                                    nb(i)=0
                                 end if
                              else 
                                 w(i)=-4*pi
                              end if
                           end do
                           if (.not.bring(k).or.brsz(k).gt.7) then
                              if (w(1).gt.pi.and.w(2).gt.pi) then
                                 if (w(1).gt.w(2)) then
                                    w(1)=2*pi-w(1)
                                 else
                                    w(2)=2*pi-w(2)
                                 end if
                              else if (w(1).lt.pi.and.w(2).lt.pi .and.
     .                                w(1).gt.0.and.w(2).gt.0) then
                                 if (w(1).gt.pi) then
                                    w(2)=2*pi-w(2)
                                 else
                                    w(1)=2*pi-w(1)
                                 end if
                              end if
                           end if
                           do i=5,6
                              if (nb(i).gt.0) then
                                 dx=x(1,nb(4))-x(1,nb(i))
                                 dy=x(2,nb(4))-x(2,nb(i))
                                 if (dx*dx+dy*dy.gt.0.000001) then
                                    w(i)=atan2(dy,dx)
                                    if (w(i).lt.0) w(i)=w(i)+2*pi
                                    w(i)=w(i)-w(3)+pi
                                    if (w(i).gt.2*pi) w(i)=w(i)-2*pi
                                    if (w(i).lt.0) w(i)=w(i)+2*pi
                                 else
                                    w(i)=-4*pi
                                    nb(i)=0
                                 end if
                              else
                                 w(i)=-4*pi
                              end if
                           end do
                           if (.not.bring(k).or.brsz(k).gt.7) then
                              if (w(5).gt.pi.and.w(6).gt.pi) then
                                 if (w(5).lt.w(6)) then
                                    w(5)=2*pi-w(5)
                                 else
                                    w(6)=2*pi-w(6)
                                 end if
                              else if (w(5).lt.pi.and.w(6).lt.pi .and.
     .                                w(5).gt.0.and.w(6).gt.0) then
                                 if (w(5).lt.pi) then
                                    w(6)=2*pi-w(6)
                                 else
                                    w(5)=2*pi-w(5)
                                 end if
                              end if
                           end if
                           do i=1,6
                              if (w(i).gt.pi) then
                                 w(i)=1
                              else if (w(i).gt.0) then
                                 w(i)=-1
                              else
                                 w(i)=0
                              end if
                           end do
                           if (w(1)*w(2).gt.0) then     ! illegal drawing, let 1st bond dominate
                              if (.not.bring(k).or.brsz(k).gt.7) then
                                 w(2)=-w(1)
                              else 
                                 nb(1)=0
                              end if
                           end if
                           if (w(5)*w(6).gt.0) then     ! illegal drawing, let 1st bond dominate
                              if (.not.bring(k).or.brsz(k).gt.7) then
                                 w(6)=-w(5)
                              else
                                 nb(1)=0
                              end if
                           end if
                        else
                           nb(1)=0
                        endif
                     else if (bster(k).eq.7) then ! use A.W.'s extension of bond stereo flags
                        w(1)=1
                        w(2)=-1
                        w(5)=-1
                        w(6)=1
                     else if (bster(k).eq.8) then
                        w(1)=1
                        w(2)=-1
                        w(5)=1
                        w(6)=-1
                     else
                        nb(1)=0
                     endif
                  endif
                  if (nb(1).gt.0) then    ! else: no torsion angle, or stereochemistry not defined
                     do i=1,2
                        do j=5,6
                           if (nb(i).gt.0.and.nb(j).gt.0) then
                              if (w(i)*w(j).gt.0) then
                                 t=180
                              else
                                 t=0
                              end if
                              if (ntor.lt.mxtor) then
                                 ntor=ntor+1
                                 tor(1,ntor)=nb(i)
                                 tor(2,ntor)=nb(3)
                                 tor(3,ntor)=nb(4)
                                 tor(4,ntor)=nb(j)
                                 torc(1,ntor)=t
                                 torc(2,ntor)=t
                                 trsz(ntor)=brsz(k)
                              end if
                           end if
                        end do
                     end do
                  end if
               end if
            end if
         end do
      end if                 ! cis/trans constraints
c
c  Volume constraint for double bonds and amide bonds
c
      do k=1,nbnd
         if (btype(k).eq.6.or.
     .        (btype(k).eq.2.and.
     .        hyb(bfrom(k)).eq.2.and.hyb(bto(k)).eq.2)) then
            nb(1)=bfrom(k)
            nb(2)=bto(k)
            nb(3)=0
            nb(4)=0
            nb(5)=0
            nb(6)=0
            l=3
            do j=1,nneigh(nb(1))
               if (neigh(j,nb(1)).ne.nb(2)) then
                  nb(l)=neigh(j,nb(1))
                  l=l+1
               end if
            end do
            l=5
            do j=1,nneigh(nb(2))
               if (neigh(j,nb(2)).ne.nb(1)) then
                  nb(l)=neigh(j,nb(2))
                  l=l+1
               end if
            end do
            do i=3,4
               do j=5,6
                  if (nstc.lt.mxstc.and.nb(i).gt.0.and.nb(j).gt.0) then
                     nstc=nstc+1
                     stc(1,nstc)=nb(i)
                     stc(2,nstc)=nb(1)
                     stc(3,nstc)=nb(2)
                     stc(4,nstc)=nb(j)
                     vstc(nstc)=0.0
                  end if
               end do
            end do
         end if
      end do
c
c  1-4 bounds for amides and double bonds (assuming 120 deg. bond angles)
c
      do i=1,ntor
         d1=topb(tor(1,i),tor(2,i))
         d2=topb(tor(2,i),tor(3,i))
         d3=topb(tor(3,i),tor(4,i))
         x1=-0.5*d1
         y1=-0.5*sqrt(3.0)*d1
         x2=d2+0.5*d3
         y2=-0.5*sqrt(3.0)*d3*cos(torc(1,i)*3.141592653/180)
         d13=sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2))
         if (trsz(i).eq.4) then
            tol=0.4
         else if (trsz(i).eq.5) then 
            tol=0.3
         else
            tol=0.0
         end if
         n1=max(tor(1,i),tor(4,i))
         n2=min(tor(1,i),tor(4,i))
         if (d13-tol.lt.topb(n2,n1)) then
            if (d13-tol.gt.topb(n1,n2)) then
               wb(n1,n2)=wlower
               topb(n1,n2)=d13-tol
            end if
         end if
         if (topb(n1,n2).lt.d13+tol) then
            if (topb(n2,n1).gt.d13+tol) then
               wb(n2,n1)=wlower
               topb(n2,n1)=d13+tol
            end if
         end if
      end do
c
c use constraints from optional constraints file
c
      do k=1,ndcnstr
         i=icnstr(k)
         j=jcnstr(k)
         if (i.gt.j) then
            topb(i,j)=max(topb(i,j),lcnstr(k))
            topb(j,i)=min(topb(j,i),ucnstr(k))
            wb(i,j)=wlower
            wb(j,i)=wupper
         else if (j.gt.i) then
            topb(j,i)=max(topb(j,i),lcnstr(k))
            topb(i,j)=min(topb(i,j),ucnstr(k))
            wb(j,i)=wlower
            wb(i,j)=wupper
         end if
      end do
c
c  use traingle inequality to tighten upper bounds
c
      n=nat
      do while(n.gt.1)       ! not very clever !!!
         do i=1,nat-1
            do j=i+1,nat
               do l=1,i-1
                  if (topb(l,i)+topb(l,j).lt.topb(i,j)) then
                     topb(i,j)=topb(l,i)+topb(l,j)
                     wb(i,j)=0.5*sqrt(wb(l,i)*wb(l,j))
                  end if
               end do
               do l=i+1,j-1
                  if (topb(i,l)+topb(l,j).lt.topb(i,j)) then
                     topb(i,j)=topb(i,l)+topb(l,j)
                     wb(i,j)=0.5*sqrt(wb(i,l)*wb(l,j))
                  end if
               end do
               do l=j+1,nat
                  if (topb(i,l)+topb(j,l).lt.topb(i,j)) then
                     topb(i,j)=topb(i,l)+topb(j,l)
                     wb(i,j)=0.5*sqrt(wb(i,l)*wb(j,l))
                  end if
               end do
            end do
         end do
         n=n/2
      end do
c
c
c tighten lower bounds...
c
      n=nat
      do while(n.gt.1)          ! very unsophisticated, sorry !!!
         do i=1,nat-1
            do j=i+1,nat
               do k=1,i-1
                  if (topb(j,i).lt.topb(i,k)-topb(k,j)) then
                     topb(j,i)=topb(i,k)-topb(k,j)
                     wb(j,i)=0.5*sqrt(wb(i,k)*wb(k,j))
                  end if
               end do
               do k=i+1,j-1
                  if (topb(j,i).lt.topb(k,i)-topb(k,j)) then
                     topb(j,i)=topb(k,i)-topb(k,j)
                     wb(j,i)=0.5*sqrt(wb(k,i)*wb(k,j))
                  end if
               end do
               do k=j+1,nat
                  if (topb(j,i).lt.topb(k,i)-topb(j,k)) then
                     topb(j,i)=topb(k,i)-topb(j,k)
                     wb(j,i)=0.5*sqrt(wb(k,i)*wb(j,k))
                  end if
               end do
            end do
         end do
         n=n/2
      end do
c
c make sure that lower bound <= upper bound
c
      do i=2,nat
         do j=1,i-1
c            topb(i,j)=min(topb(i,j),topb(j,i))
         end do
      end do
c
c DEBUG: write constraints
c
C      do i=1,nstc
C         write(0,'(a,4i4,f8.3,1x,f8.3)') ' V ',(stc(k,i),k=1,4),vstc(i)
C      end do
C      do i=1,ntor
C         write(0,'(a,4i4,f6.1)') ' T ',(tor(k,i),k=1,4),torc(2,i)
C      end do
C      do i=1,nang
C         write(0,'(a,3i4,f6.1)') ' A ',(ang(k,i),k=1,3),angl(i)
C      end do
      return
      end
