      subroutine embed
c
      implicit none
      include 'sizes.h'
      include 'moldat.h'
      include 'options.h'
      include 'bounds.h'
c
c Embed metric matrix via G.M.Crippen, Distance Geometry and
c Conformational Calculations, Theorem 2.2, p.14.
c
      integer i,j,k,l,n,ier
      real*8 d0(mxnat),eval(mxnat),dbig
c
      do j=1,nat
         do i=1,nat
            dist(i,j)=dist(i,j)*dist(i,j)
         end do
      end do
      dbig=0
      do j=2,nat
         do k=1,j-1
            dbig=dbig+dist(k,j)
         end do
      end do
      dbig=dbig/(nat*nat)
      do i=1,nat
         d0(i)=0
         do j=1,nat
            d0(i)=d0(i)+dist(i,j)
         end do
         d0(i)=max(0.0,d0(i)/nat-dbig)
      end do
c
      do i=1,nat
         do j=i,nat
            dist(i,j)=(d0(i)+d0(j)-dist(i,j))/2
            dist(j,i)=dist(i,j)
         end do
      end do
c
c
c   Compute eigenvalues and eigenvectors of FM (sorted descending)
c
      call EPtred2(mxnat,nat,dist,eval,d0,dist)
      call EPimtql2(mxnat,nat,eval,d0,dist,ier)
      if (ier.ne.0) write(0,'(a,i4)') 
     .     ' Abnormal return from IMTQL2: ',ier
      call EPevsort(mxnat,nat,eval,dist,1)
      do i=1,nat
         eval(i)=sqrt(abs(eval(i)))
      end do
c
      do j=1,nat
         do i=1,3
            x(i,j)=eval(nat+1-i)*dist(j,nat+1-i)
         end do
      end do
      return
      end

