      integer function read_maccs(in)
c
c read next molecule into common
c
      implicit none
c
      integer nelt
      parameter (nelt=13)
c
      include 'sizes.h'
      include 'moldat.h'
c
      integer in
      integer status,i,j,k,l,bs,dbl,trpl
      character*80 rec
c
      real*8 rvtab(nelt),rctab(nelt)
      character*2 elt(nelt)
      data elt /
     .     'C ','H ','N ','O ','S ','P ','Cl','Si','Br','F ',
     .     'D ','T ', 'I'
     .     /
      data rvtab /
     .      1.7, 1.2, 1.5, 1.4, 1.9, 1.9, 1.9, 1.9, 1.9, 1.3,
     .      1.2, 1.2, 2.0
     .     /
      data rctab /
     .     0.75,0.35,0.65,0.60,0.95,0.95,0.95,0.90,0.95,0.70,
     .     0.35,0.35, 0.95
     .     /
c
c     clear out old stuff
c
      read_maccs=0
      nbnd=0
      nat=0
c
c read three header lines and decode first data line
c
      rec='nothing read...'
      do i=1,4
         hdr(i)=' '
      end do
      do i=1,4
         read(in,'(a)',err=901,end=902) hdr(i)
      end do
      read(hdr(4),'(3i3,6x,i3,12x,i3)',err=901) 
     .     nat,nbnd,nal,ntxt,nprop
      if (nat.gt.mxnat.or.nbnd.gt.mxbnd) then
         read_maccs=3
         do while (rec(1:4).ne.'$$$$')
            read(in,'(a)',end=902,err=901) rec
         end do
         return
      end if
         
c
c read the atoms...
c
      do i=1,nat
         read(in,'(a)',err=901,end=902) rec
         read(rec,'(3f10.0,1x,a)',err=901)
     .        (x(k,i),k=1,3),flags(i)
         chs(i)=flags(i)(1:2)
         if (chs(i)(2:2).ge.'A'.and.chs(i)(2:2).le.'Z') then
            chs(i)(2:2)=char(ichar(chs(i)(2:2))-ichar('A')+ichar('a'))
         end if
         rvdw(i)=1.7
         rcov(i)=0.75
         do k=1,nelt
            if (chs(i).eq.elt(k)) then
               rvdw(i)=rvtab(k)
               rcov(i)=rctab(k)
            end if
         end do
      end do
c
c read other records to end of molecule marker
c
      nrec=0
      do while (rec(1:4).ne.'$$$$')
         read(in,'(a)',end=902,err=901) rec
         if (rec(1:4).ne.'$$$$') then
            if (nrec.lt.mxrec) then
               nrec=nrec+1
               recrd(nrec)=rec
            else
               read_maccs=3
            end if
         end if
      end do
      if (read_maccs.ne.0) return
      
      do i=1,nat
         nneigh(i)=0
      end do

      do k=1,nbnd
         read(recrd(k),'(4i3)',err=901) i,j,l,bs
         if (i.lt.0.or.i.gt.nat) go to 901
         if (j.lt.0.or.j.gt.nat) go to 901
         if (nneigh(i).lt.mxneigh) then
            nneigh(i)=nneigh(i)+1
            nneigh(j)=nneigh(j)+1
            neigh(nneigh(i),i)=j
            neigh(nneigh(j),j)=i
            bnd(nneigh(i),i)=k
            bnd(nneigh(j),j)=k
         else
            read_maccs=4
         end if
         if (k.le.mxbnd) then
            bfrom(k)=i
            bto(k)=j
            btype(k)=l
            bster(k)=bs
         else
            read_maccs=4
         end if
      end do
c
      return
c
 901  continue
      read_maccs=1
      write(0,'(a)') ' ERROR READING FILE:'
      do i=1,4
         write(0,'(1x,a)') hdr(i)
      end do
      write(0,'(1x,a)') rec
      do i=1,50
         read(in,'(a)',err=90011,end=90011) rec
         write(0,'(1x,a)') rec
      end do
90011 continue
      return
c
 902  continue
      read_maccs=2
      return
      end
