      real*4 function refine()
c
      implicit none
      include 'sizes.h'
      include 'moldat.h'
      include 'options.h'
      include 'bounds.h'
c
      integer maxfn,i,j,k,conjgrad,status
c
      real*8 acc,deexp,ef,fplus,fminus,rgan,rnum,
     .     gan(3,mxnat),gnum(3,mxnat),target
      logical prg,acceptable
      external target
c
      refine=1.e6
      if (max_ref.le.0) then
         maxfn=8*nat
      else
         maxfn=max_ref
      end if
      acc=0.1
      deexp=0.5
      if (nstc.gt.0.and.wstc.gt.0) then
         ef=target(3*nat,x,gan)
         fplus=targ_s
         do i=1,nat
            x(3,i)=-x(3,i)
         end do
         ef=target(3*nat,x,gan)
         fminus=targ_s
         if (fminus.gt.fplus) then
            do i=1,nat
               x(3,i)=-x(3,i)
            end do
         end if
      end if
      status=conjgrad(target,3*nat,x,ef,gan,deexp,acc,maxfn)
      ef=target(3*nat,x,gan)    ! needed, to get targ_x terms at best point
      if (vlev.gt.2) then
         write(0,'(a,f11.5,1x,f11.5,1x,f11.5,1x,f11.5)')
     .        ' Target (d,s,t,D) : ',targ_d,targ_s,targ_t,targ_d_max
      end if
      if (acceptable()) refine=0  ! stop if solution is acceptable
      if (status.eq.-2) then
         if (vlev.gt.2) then
            write(0,'(a,i4)') ' *** No Convergence:',status
            if (vlev.gt.3) then
               write(0,'(a)') ' Gradient report:'
               call grad(3*nat,x,gnum)
               rgan=0
               rnum=0
               do j=1,nat
                  prg=.false.
                  do i=1,3
                     rgan=rgan+gan(i,j)**2
                     rnum=rnum+gnum(i,j)**2
                     prg=prg.or.(abs(gan(i,j)-gnum(i,j)).gt.0.05)
                  end do
                  if (prg) write(0,'(a,i4,a,3f10.4,a,3f10.4)')
     .                 ' atom:',j,
     .                 '   ana.: ',(gan(i,j),i=1,3),
     .                 '   num.:',(gnum(i,j),i=1,3)
               end do
               rgan=sqrt(rgan/(3*nat))
               rnum=sqrt(rnum/(3*nat))
               write(0,'(a,f10.4,a,f10.4)')
     .              ' rms.  ana.: ',rgan,'   num.: ',rnum  
            end if
         end if
      end if
c
      return
      end
c------------------------------------------------------------------------
      logical function acceptable()
      implicit none
      include 'sizes.h'
      include 'moldat.h'
      include 'options.h'
      include 'bounds.h'
      integer nb(4),k,l,j,i
      real*8 d1(3),d2(3),d3(3),d12(3),d13(3)
c
      acceptable= targ_s.lt.0.1 .and.
     .     targ_d.lt.0.3 .and.
     .     targ_t.lt.5.0 .and.
     .     targ_d_max.lt.0.2

      if (acceptable) then
         do k=1,nbnd           ! check geometry at double bonds 
            if (btype(k).eq.2.or.btype(k).eq.6) then
               nb(1)=bfrom(k)
               nb(2)=bto(k)
               do l=1,2
                  if (hyb(nb(l)).eq.2.and.nneigh(nb(l)).gt.1) then
                     j=2
                     do i=1,nneigh(nb(l))
                        if (neigh(i,nb(l)).ne.nb(3-l)) then
                           j=j+1
                           nb(j)=neigh(i,nb(l))
                        end if
                     end do
                     do i=1,3
                        d1(i)=x(i,nb(l))-x(i,nb(3-l))
                        d2(i)=x(i,nb(3))-x(i,nb(l))
                     end do
                     d12(1)=d1(2)*d2(3)-d1(3)*d2(2)
                     d12(2)=d1(3)*d2(1)-d1(1)*d2(3)
                     d12(3)=d1(1)*d2(2)-d1(2)*d2(1)
                     if (j.eq.4) then
                        do i=1,3
                           d3(i)=x(i,nb(4))-x(i,nb(l))
                        end do
                        d13(1)=d1(2)*d3(3)-d1(3)*d3(2)
                        d13(2)=d1(3)*d3(1)-d1(1)*d3(3)
                        d13(3)=d1(1)*d3(2)-d1(2)*d3(1)
                        acceptable=acceptable .and. 
     .                        d12(1)*d13(1)
     .                       +d12(2)*d13(2)
     .                       +d12(3)*d13(3) .lt. -0.1
                     else
                        acceptable=acceptable .and. 
     .                        d12(1)*d12(1)
     .                       +d12(2)*d12(2)
     .                       +d12(3)*d12(3) .gt.  0.1
                     end if
                     if (.not. acceptable) return
                  end if
               end do
            end if
         end do
      end if
c

      return
      end
