      subroutine seldist
c
      implicit none
      include 'sizes.h'
      include 'moldat.h'
      include 'options.h'
      include 'bounds.h'
c
      integer i,k,l
      real*8 r,s
      real*8 randomf
c
      if (extfact.gt.1.e-6) then
c
c  set dist 'close' to upper bound
c
         do i=1,nat-1
            do k=i+1,nat
               dist(i,k)=bounds(k,i)+
     .              (extfact+(1-extfact)*randomf())*(bounds(i,k)-bounds(k,i))
               dist(k,i)=dist(i,k)
            end do
            dist(i,i)=0
         end do
         dist(nat,nat)=0
      else
c
c Uses Crippen's method (DG and Conformational Calculations p.24)
c
         do i=1,nat
            do k=i+1,nat
               dist(i,k)=randomf()
            end do
            dist(i,i)=0.0
         end do
         do i=1,nat-1
            do k=i+1,nat
               s=1.0
               r=dist(i,k)
               do l=1,i-1
                  if (bounds(l,k).le.0.2*bounds(l,i)) then
                     s=s+0.9
                     r=r+0.9*dist(l,i)
                  end if
                  if (bounds(k,l).ge.0.9*bounds(l,i)) then
                     s=s+0.5
                     r=r-0.5*(dist(l,i)-1.0)
                  end if
               end do
               do l=i+1,k-1
                  if (bounds(l,k).le.0.2*bounds(i,l)) then
                     s=s+0.9
                     r=r+0.9*dist(i,l)
                  end if
                  if (bounds(k,l).ge.0.9*bounds(i,l)) then
                     s=s+0.5
                     r=r-0.5*(dist(i,l)-1.0)
                  end if
               end do
               do l=k+1,nat
                  if (bounds(k,l).le.0.2*bounds(i,l)) then
                     s=s+0.9
                     r=r+0.9*dist(i,l)
                  end if
                  if (bounds(l,k).ge.0.9*bounds(i,l)) then
                     s=s+0.5
                     r=r-0.5*(dist(i,l)-1.0)
                  end if
               end do
               dist(k,i)=bounds(k,i)+(r/s)*(bounds(i,k)-bounds(k,i))
            end do
         end do
         do i=1,nat-1
            do k=i+1,nat
               dist(i,k)=dist(k,i)
            end do
         end do
      endif
c
      return
      end

