      real*8 function target(n,y,g)
c
      implicit none
      include 'sizes.h'
      include 'moldat.h'
      include 'options.h'
      include 'bounds.h'
c      
      integer n,i,j,k,l,m,i1,i2,i3,i4
      real*8 y(3,*),g(3,*),f,dy(3),d,r,s,
     .     r32,ta1,ta2,ta3,tb1,tb2,tb3,tan,tbn,sigma,t,sp,
     .     f1,f2,f3,f4,s2,s3,dl,dh,dt,dmid,frc,w,v(3,3),vv(3,3)
c
c Reset...
c
      target=0.0
      targ_d=0.0
      targ_s=0.0
      targ_t=0.0
      targ_a=0.0
      do j=1,nat
         do i=1,3
            g(i,j)=0
         end do
      end do
c
c max. violation of uopper bounds for bond lengths
c
      targ_d_max=0
      do i=1,nbnd
         j=min(bfrom(i),bto(i))
         k=max(bfrom(i),bto(i))
         d=sqrt((y(1,j)-y(1,k))**2
     .        +(y(2,j)-y(2,k))**2
     .        +(y(3,j)-y(3,k))**2)
         targ_d_max=max(targ_d_max,d-topb(j,k))
      end do
c
c Violations of upper/lower bounds on distances... (Q: should topb be used, or bounds?)
c
      if (max(wupper,wlower).gt.0) then
         do i=1,nat-1
            do j=i+1,nat
               dy(1)=y(1,i)-y(1,j)
               dy(2)=y(2,i)-y(2,j)
               dy(3)=y(3,i)-y(3,j)
               r=sqrt(dy(1)*dy(1)+dy(2)*dy(2)+dy(3)*dy(3))
               if (r.lt.topb(j,i)) then
                  d=r-topb(j,i)
                  w=wb(j,i)
               else if (r.gt.topb(i,j)) then
                  d=r-topb(i,j)
                  w=wb(i,j)
               else
                  d=0.0
                  w=0.0
               end if
               targ_d=targ_d+w*d*d
               do k=1,3
                  g(k,i)=g(k,i)+2*w*dy(k)*d/r
                  g(k,j)=g(k,j)-2*w*dy(k)*d/r
               end do
            end do
         end do
      end if
c
c Violations of atom stereo parity
c
      if (wstc.gt.0) then
         do i=1,nstc
            do k=1,3
               do l=1,3
                  v(k,l)=y(k,stc(l,i))-y(k,stc(4,i))
               end do
            end do
            do k=1,3
               j=mod(k,3)+1
               l=mod(j,3)+1
               vv(1,k)=v(2,j)*v(3,l)-v(3,j)*v(2,l)
               vv(2,k)=v(3,j)*v(1,l)-v(1,j)*v(3,l)
               vv(3,k)=v(1,j)*v(2,l)-v(2,j)*v(1,l)
            end do
            vcalc(i)=-(v(1,1)*vv(1,1)+v(2,1)*vv(2,1)+v(3,1)*vv(3,1))
            if (abs(vstc(i)).lt.0.1  .or.
     .           vstc(i).lt.-0.1.and.vcalc(i).gt.vstc(i) .or.
     .           vstc(i).gt.0.1.and.vcalc(i).lt.vstc(i)           ) then
               d=vstc(i)-vcalc(i)
               targ_s=targ_s+wstc*d*d
               frc=-2*wstc*d
               do k=1,3
                  do j=1,3
                     g(j,stc(k,i))=g(j,stc(k,i))-frc*vv(j,k)
                     g(j,stc(4,i))=g(j,stc(4,i))+frc*vv(j,k)
                  end do
               end do
            end if
         end do
      end if
c     
c Violations of dihedral constraints...
c
      if (wtor.gt.0) then
         w=wtor*57.29578**2
         do i=1,ntor
            i1=tor(1,i)
            i2=tor(2,i)
            i3=tor(3,i)
            i4=tor(4,i)
            r32=0
            do j=1,3
               r32=r32+(y(j,i2)-y(j,i3))**2
            end do
            r32=sqrt(r32)
            ta1=(y(2,i2)-y(2,i3))*(y(3,i2)-y(3,i1))-
     *           (y(3,i2)-y(3,i3))*(y(2,i2)-y(2,i1))
c     
            ta2=(y(3,i2)-y(3,i3))*(y(1,i2)-y(1,i1))-
     *           (y(1,i2)-y(1,i3))*(y(3,i2)-y(3,i1))
c     
            ta3=(y(1,i2)-y(1,i3))*(y(2,i2)-y(2,i1))-
     *           (y(2,i2)-y(2,i3))*(y(1,i2)-y(1,i1))
c     
            tb1=(y(2,i2)-y(2,i3))*(y(3,i3)-y(3,i4))-
     *           (y(3,i2)-y(3,i3))*(y(2,i3)-y(2,i4))
c     
            tb2=(y(3,i2)-y(3,i3))*(y(1,i3)-y(1,i4))-
     *           (y(1,i2)-y(1,i3))*(y(3,i3)-y(3,i4))
c     
            tb3=(y(1,i2)-y(1,i3))*(y(2,i3)-y(2,i4))-
     *           (y(2,i2)-y(2,i3))*(y(1,i3)-y(1,i4))
c     
            tan=sqrt(ta1*ta1+ta2*ta2+ta3*ta3)
            tbn=sqrt(tb1*tb1+tb2*tb2+tb3*tb3)
            if (tan.lt.1.e-19.or.tbn.lt.1.e-19) then
               d=0.0
            else
               ta1=ta1/tan
               ta2=ta2/tan
               ta3=ta3/tan
               tb1=tb1/tbn
               tb2=tb2/tbn
               tb3=tb3/tbn
               sigma=sign(1.0D0,(ta2*tb3-ta3*tb2)*(y(1,i2)-y(1,i3))+
     *              (ta3*tb1-ta1*tb3)*(y(2,i2)-y(2,i3))+
     *              (ta1*tb2-ta2*tb1)*(y(3,i2)-y(3,i3)))
               sp=max(-1.0,min(1.0,ta1*tb1+ta2*tb2+ta3*tb3))
               t=-sigma*acos(sp)
               d=t*57.29578
c     
c     normalize constraint...
c     
               if (torc(1,i).gt.0.0) then
                  dl=torc(1,i)-360.0
                  dh=torc(2,i)-360.0
               else
                  dl=torc(1,i)
                  dh=torc(2,i)
               end if
               dmid=(dl+dh+360.0)*0.5
               dt=0.0
               if (d.gt.dmid) then
                  if (d.lt.dl+360.0) dt=d-dl-360.0
                  if (d.gt.dh+360.0) dt=d-dh-360.0
               else
                  if (d.lt.dl) dt=d-dl
                  if (d.gt.dh) dt=d-dh
               end if
c     
               dt=dt/57.29578
               targ_t=targ_t+0.5*w*dt*dt
               frc=w*dt
c     
               if (frc.ne.0.0) then
                  s2=0.0
                  s3=0.0
                  do l=1,3
                     s2=s2+(y(l,i2)-y(l,i3))*(y(l,i2)-y(l,i1))
                     s3=s3+(y(l,i2)-y(l,i3))*(y(l,i3)-y(l,i4))
                  end do
                  f1=-frc*r32/tan
                  f2=frc*s2/(tan*r32)
                  f3=frc*s3/(tbn*r32)
                  f4=-frc*r32/tbn
                  g(1,i1)=g(1,i1)+f1*ta1
                  g(1,i2)=g(1,i2)-(f1+f2)*ta1+f3*tb1
                  g(2,i1)=g(2,i1)+f1*ta2
                  g(2,i2)=g(2,i2)-(f1+f2)*ta2+f3*tb2
                  g(3,i1)=g(3,i1)+f1*ta3
                  g(3,i2)=g(3,i2)-(f1+f2)*ta3+f3*tb3
                  g(1,i3)=g(1,i3)+(f4-f3)*tb1+f2*ta1
                  g(1,i4)=g(1,i4)-f4*tb1
                  g(2,i3)=g(2,i3)+(f4-f3)*tb2+f2*ta2
                  g(2,i4)=g(2,i4)-f4*tb2
                  g(3,i3)=g(3,i3)+(f4-f3)*tb3+f2*ta3
                  g(3,i4)=g(3,i4)-f4*tb3
               end if
            end if
         end do
      end if
c
c  Angles... (equality constraints)
c
      if (nang.gt.0.and.wang.gt.0) then
         w=wang
         do i=1,nang
            s=0.0
            f1=0.0
            f3=0.0
            do m=1,3
               v(m,1)=y(m,ang(1,i))-y(m,ang(2,i))
               v(m,3)=y(m,ang(3,i))-y(m,ang(2,i))
               s=s+v(m,1)*v(m,3)
               f1=f1+v(m,1)*v(m,1)
               f3=f3+v(m,3)*v(m,3)
            end do
            f1=sqrt(f1)
            f3=sqrt(f3)
            if (f1.gt.1e-10) then
               f1=1/f1
            else
               f1=0.0
            end if
            if (f3.gt.1e-10) then
               f3=1/f3
            else
               f3=0.0
            end if
            s=max(-1.0,min(1.0,s*f1*f3))
            t=acos(s)*57.29578
            d=angl(i)-t
            targ_a=targ_a+w*d**2
            if (1-s**2.gt.1.e-20) then
	      t=57.29578*2*(w*d)/sqrt(1-s**2)
	      do m=1,3
	         r=t*(v(m,3)*f1*f3-s*v(m,1)*f1*f1)
	         g(m,ang(1,i))=g(m,ang(1,i))+r
		 g(m,ang(2,i))=g(m,ang(2,i))-r
                 r=t*(v(m,1)*f1*f3-s*v(m,3)*f3*f3)
		 g(m,ang(3,i))=g(m,ang(3,i))+r
		 g(m,ang(2,i))=g(m,ang(2,i))-r
	      end do
	   end if
	end do
      end if
c
      target=targ_d+targ_s+targ_t+targ_a
      if ((wupper+wlower)*0.5.gt.0.and.nat.gt.1) 
     .     targ_d=sqrt(targ_d/((wupper+wlower)*0.5*(nat*(nat-1))/2))
      if (nstc.gt.0.and.wstc.gt.0) 
     .     targ_s=sqrt(targ_s/(wstc*nstc))
      if (ntor.gt.0.and.wtor.gt.0)
     .     targ_t=sqrt(targ_t/(ntor*wtor))
      if (nang.gt.0.and.wang.gt.0)
     .     targ_a=sqrt(targ_a/(nang*wang))
c     
      return
      end
