@echo off
setlocal

:: set to 1, to tell Wit!P that it was called from DOS script
set WNPINDOS=1

:: Keep a pointer to where we started
set WNP_STARTDIR=%cd%

:: Keep a pointer to the user's home directory
set WNP_USERDIR=%HOMEDRIVE%%HOMEPATH%

:: Find the root of the Wit!P installation
set WNP_ROOT=%~pd0
set WNP_ROOT=%WNP_ROOT:~0,-1%

:: Find a Cygwin installation, or use mini-Cygwin from %WNP_ROOT%\sys
call %WNP_ROOT%\findCygwin 2> nul
if defined CYG_ROOT (
  if exist "%CYG_ROOT%\bin\sw_client.exe" (
    set CYG_ROOT=%WNP_ROOT%
    set WNP_CYGBIN=%WNP_ROOT%\sys
  ) else (
    set WNP_CYGBIN=%CYG_ROOT%\bin
  )
) else (
  set WNP_CYGBIN=%WNP_ROOT%\sys
)

reg add HKLM\Software\Classes\witnotp /v EditFlags /t REG_DWORD_LITTLE_ENDIAN /d 0x00010000 /f >nul
reg add HKLM\Software\Classes\witnotp /v AlwaysShowExt /f >nul
reg add HKLM\Software\Classes\witnotp /v BrowserFlags /t REG_DWORD_LITTLE_ENDIAN /d 0x00000008 /f >nul
reg add HKLM\Software\Classes\witnotp\DefaultIcon /ve /d "%WNP_ROOT%\witnotp.ico,0" /f  >nul
reg add HKLM\Software\Classes\witnotp\shell /ve /d "open" /f  >nul

setlocal
for %%x in ( "%WNP_ROOT%" ) do (
  set short=%%~sx
)
reg add HKLM\Software\Classes\witnotp\shell\open\command /ve /d "%short%\witnotp.cmd ""%%1""" /f >nul
endlocal

reg add HKCR\.wnp /ve /d witnotp /f >nul

:: Add Wit!P bin and sys directories to executables path
set PATH=%WNP_ROOT%\bin;%WNP_CYGBIN%;%SystemRoot%\system32

:: If script was called with a command line argument, use it to defin WNP_INIT

set init=%1
if defined init (
  set WITNOTP_INIT=%init%
)

:: Do not allow start in root directory of installation
if "%WNP_STARTDIR%" EQU "%WNP_ROOT%" (
   cd "%WNP_USERDIR%"
   echo started in %WNP_STARTDIR%, changed directory to %WNP_USERDIR%
)

:: Launch Wit!P in Bourne (again) Shell
bash.exe "%WNP_ROOT%/bin/witnotp" port 29945
endlocal
