{!Simmulated Annealing, with optional set of fixed atoms.}
      overlap = 0.01
      cutdis = {? float "cutoff (on): " 12.0}
      cutoff = {? float "cutoff (off): " 14.0}
      swtdis = 2.0

      begin simulation
     *    add-automatic bond torsion valence out-of-plane
      reduce

      set dielectric  = 2*r
 
      {? fixed "fixed atoms: "}

      Minimize
     *    no cross terms
     *    no morse
     *    for {? int "number of minimization steps at start: " 500} iterations
     *    using conjugate gradient
     *    until the maximum derivative is less than 0.001 kcal/A 

      tempi = {? float "initial temperature (K): " 1000}
      tempf = {? float "final temperature (K): " 300}
      iequi = {? int "equilibration time (fs): " 500}
      icool = {? int "cooling time (fs): " 10000}
      delta = {? float "temperature drop per cooling step (K): " 50}

      dtemp = tempi - tempf
      nsteps = dtemp/delta
      icool = icool/nsteps
      delta = dtemp/nsteps      
      temp = tempi
      
      Initialize Dynamics
     *    at temp K
     *    for iequi iterations
     *    steps of 1.000 
     *    no cross terms
     *    no morse
     *    write history every {? int "number of steps (fs) per history frame: " 200} steps
     *    averages every {? int "number of steps (fs) between averages: " 200} steps

cool  temp = temp - delta
      Resume Dynamics
     *    at temp K
     *    for icool iterations
     *    no cross terms
     *    no morse
      if temp .gt. tempf then cool

      Minimize
     *    no cross terms
     *    no morse
     *    for {? int "number of minimization steps at end : " 1000} iterations
     *    using conjugate gradient
     *    until the maximum derivative is less than 0.001 kcal/A 

      end
